 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Fichero:applied.lsp  Version 2.0
;; (load "C:/Hamlet/Integration/applied.lsp")  
;;
;; Descripcion: Integrar en el arbol de busqueda de Prodigy, el algoritmo de Veloso y la Red Temporal
;; Historico:
;;      Version    Autor        Fecha        Cambio
;;      Creacion    M.D        25/08/02      --------
;;      0.2		  M.D        30/08/02      Annadir las CI despues de annadir todos lo operadores
;;      0.3		  M.D.        4/09/02      Funciona algoritmo. Comprobar si ya hay un link entre 2 ops mas 
;;                                           cercano, en dicho caso no annadirlo.
;;                                           Tiempo de ejecucion del algoritmo. 
;;      0.4		  M.D.       16/09/02      Integrar con el handler. Eliminamos la lista de operadores
;;	  0.5		  M.D.	 03/09/02      Calculo de estados, N0 funciona todavia comprobar
;;							   si algun operador borra alguna precondicion
;;	  0.6	        M.D		 19/10/02	   Integrada ambas partes: (algoritmo y parte de extraccion de datos de Prodigy). 
;;      0.7		  M.D.	 21/10/02	   Resuelto el problema de acciones en paralelo. Eliminado variables no utilizadas
;;							   Crear una funcion recursiva para detectar links.
;;							   REducir los bucles utilizando los identificadores de los operadores
;;	  0.8		  M.D.	 24/10/02	   Convertir la lista de operadores a matriz. Resolver el problema
;;							   de un op que depende de un estado cuando se han annadido varios pero con uno solo no encuentra (
;;							   Es decir, depende de varios operadores.
;;      0.9         M.D.       27/10/02      Resuelto errores de calculo de estados (cuando depende 
;;							   de varios links no se puede calcular el estado con add o del si no mediante el estado ultimo calculado)
;;							   A F-OP se le ha annadido el campo state (que debe coincidir con lo q devuelve show-state)
;;							   y annadido a la lista-de-estados (F-OP). (Se podria haber repetido el ultimo estado).
;;     1.0          M.D        28/10/02      Eliminados links redundantes.
;;							   Annadido funciones en caso que Prodigy haba backtraking y el caso de que tenga 
;;							   un operador como solucion.
;;							   Calculo de los links del operador final y el resto de operadores. De esta manera si algun
;;							   operador tiene un vinculo con el final, y se sobrepasa el tiempo, no tengo que esperar a 
;;							   annadirlo todo y ver que no es consistente.
;;							   Al annadir los links con el ultimo operador, podia estar amenazado y por tanto se deberia eliminar. (En Del-Precond)Siempre el link con el F-OP sera el ultimo insertado por tanto no hago mas que pop.
;;     1.1		  M.D        7/11/02	   Cambios en la forma de Restaurar la Rete, debia savarla al hacer el ultimo restaure o perdia ese estado de la pila.
;;							   Cambio en las metas del operador F-OP para que coja la funcion (get-f-operator).
;;							   Calcular el numero posible de TP de la RETE (por ejemplo n de metas * 2 + 1 si supera el numero de 100 TP que esel valor por defecto). No sirve...
;;     1.2		 M.D.		10/11/02	   Eliminar las funciones format  para hacer pruebas
;;	 1.3		 M.D.		17/11/02	   Eliminados los warning de compilacion
;;							   Comprobar si el operador ya tiene un enlace con el final, si se annaden otros links--> eliminar el ultimo (se puede hacer con los links, pero como con la red, no se puede, pero se annaden siempre por lo cual si.
;;							   Variables globales en default.lsp, se puede ejecutar mas de una vez el programa. Se ha creado una carpeta con todos los ficheros de la integracion.
;;						         Me he dado cuenta que debo annadir con el final un link en la red para que calcule su consistencia, si no, no lo hace.
;;    1.4          M.D.       12/12/02       Annadido una condicion en FIND-PATH para que no considere como camino cuando se tiene el F-OP. Se ha eliminado el error de OverFlow (bucle infinito).
;;					17/12/02	   Para que funcionen las soluciones multiples, se annade siempre la restriccion entre 1 y 2.
;;    1.5          M.D.       8/02/03        Se annade el chequeo de conflicto de recursos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; MEJORAS PARA UNA VEZ TERMINADA LA INTEGRACION

;;YA NO ME PASA F-OP!!!!!
;; salirse del programa(COMO SE HARIA???) (cons :stop :achieve) NO FUNCIONA
;;Mensaje-->Se ha superado el numero de TP's.  
;;Si vuelvo a NIL en la rete, quizas deberia salirme del programa --> Mensaje: Inconsistencia en la red

;;HE MODIFICADO CHECK-CONSISTENCE en la otra parte para que se pueda escribir todo en un fichero

; Convertimos las lista de operadores a matriz Da problemas, no se porque pero tienen distintas las longitudes list-op y ListOP global !!!!

;La lista de operadores list-TPop tiene la forma:  --- (F-OP, ...Op1, S-OP)

(in-package "P4")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Convierte una lista en una matriz unidimensional
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun De-Lista-Array(DIM v)
  (make-array  (list DIM)  :element-type t
	      :initial-contents  v)	    
)    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; La funcion se encargara de devolver la consitencia de los links calculados por CALCULATE-THREATS.
;;
;; Inicialmente estaran el operador S-OP y el primer operador solucion, luego voy annadiendo
;; los demas hasta terminar con el operador F-OP. Como este ultimo viene con el ultimo operador tendre que desglosarlo
;; en dos.  (YA NO)
;;
;; Paramtros: opcionalmente el t donde se desea visualizar los resultados.
;; Devuelve:  Un valor nil si no es consistente o t en caso contrario.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun check-consistence () 
 (let* ((list-op user::*list-TPs*)   ; Me quiero quedar con todos menos el ultimo operador (annadido)
	  (op (pop list-op))           ; Me quedo con el ultimo operador (que es el que me pasan))
	  (op-antf nil)                ; Puesto que se annaden a la vez el penultimo y FOP debo pasarlo uno a uno a Calculate. Por eso lo desgloso como operador anterior a F-OP
	  (consistent nil)
	  (SOP nil)
       )

 ;(format t"~%****************      INIcio de la funcion check-consistencie ****************~%")
 ;(format t"~%Lista de ops (lo que me pasan) =  ~a~%" user::*list-TPs*)
 ;(format t"~%Lista de ops(mia) = ~a ~%~% El OPERADOR que me pasan es= ~d --~% n total=~d....~% La golbal= ~d~% " list-op op (length list-op) user::*list-TPs*)

  ; Tengo que hacer la interseccion de cada uno de los estados que hay en la lista-de-estados con las precondiciones
  ; Aquella cuya interseccion sea en numero igual a las precondiciones--> depende de ese estado. Empiezo con el S-OP
  ; hasta llegar al ultimo operador insertado (anterior al que se esta pasando)
  ; Luego se deberan comprobar los efectos de borrado del operador a insertar no borra alguna condicion establecida anteriormente
  ; y que ningun operador que estan entre medias de los links no borra dicho link.
  
  ; Cuando estamos ante el primer operador, calculamos el estado--> los adds.
  (if (and (= (length list-op) 1) (not (equal (user::TimePoint-operator op) '(F-OP))) (equal user::*Final* nil))
      (progn
          (setq SOP (pop list-op))
          (push  (user::TimePoint-adds SOP) user::*lista-de-estados*) 
	    ;(format t "~%Estamos con un solo operador Adds= ~d" (user::TimePoint-adds SOP))
          (push SOP list-op)
	    (push SOP user::*list-TPop*)
          ;;(format t"~%Mi estado actual = ~d ........~%" user::*lista-de-estados*)	    
 	    (setf (user::TimePoint-state SOP) (user::TimePoint-adds SOP)) 
   	    (setf (user::TimePoint-links-added SOP) nil)	   
	    ;(format t "~%Operador= ~d" SOP)
	    (setf user::*Final* (user::make-TimePoint :id  2 ; F-OP
						:operator '(F-OP)	
						:preconds  (get-f-operator) 
						:adds  nil
						:dels  nil	
						:start-id  2			
						:end-id    2		
						:duration-min  0		
						:duration-max  0		
						:added     t))

	    #| Esto no me sirve, no tiene porque ser general en todos los dominios
	    ;(format t "~%numero = ~d~% num= ~d~%METAS = ~%"  (* (length (user::TimePoint-preconds user::*Final*)) 2)  user::*num* (user::TimePoint-preconds user::*Final*))
	    (if ( > (* (length (user::TimePoint-preconds user::*Final*)) 2) (- user::*num* 2) )
		   (setq user::*num* (+ (* (length (user::TimePoint-preconds user::*Final*)) 2) 30))
	         ;(format t "~%El valor de n es mayor que el numero de operadores en el plan")
          );;fin if
	   ;(read t)|#
      );;fin del progn  
  );;fin del if
  
  ;Cuando el operador es el ultimo, tengo que separarlo en 2: el anterior y el F-OP
  (if (equal (user::TimePoint-operator op) '(F-OP))
      (progn
	   (setq op-antf (pop list-op))
	   ;(format t "~%Anterior al Ultimo operador ,,,,,,,,,,,,,,,,,,,,,~%op-ant= ~d~%" op-antf)
	   ;(format t "~%estados = ~d ~%" user::*lista-de-estados* )
	   ;;(read t)
	   (setq consistent (CALCULATE-LINKS op-antf list-op )) 
	   (if (not (equal consistent nil))
		(progn
	   		;(format t "~%Ultimo operador ,,,,,,,,,,,,,,,,,,,,,~%op = ~d~%" op) ;;(read t)
			;(setq user::links-TPs nil)
			(push op-antf list-op)
	            ;(format t"~%La lista de oper ANTES del ultimo= ~d" user::*list-TPop*) 
	    		;(format t "~%Estados = ~d ~%" user::*lista-de-estados*) 
	  	      (CALCULATE-LINKS op  list-op )
              );;fin del progn
         );;fin if consistent
      );;fin del progn
	;else   --> Como no es el ultimo llamo normalmente a la funcion
      (setq consistent (CALCULATE-LINKS op list-op )) 
   );;fin del if
  ;(format t"~%Lista de operadores = ~d ***********" user::*list-TPop*)
  ;(format t"~%~%La lista de list-links  es: ~d~%" user::*list-links*) ;;(read t)
  ;(COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num* ) 
  ;;(format t "~%consistente= ~d" consistent) ;(read t)

  (if (equal consistent nil)
	(progn
 	   (setf user::*last-op-consistence* nil)
	   ;(format t"~% Operador = ~d~% NO ES CONSISTENTE = ~d" op consistent) ;(read t)
      );;fin del progn
  )

   consistent
 ); fin del Let*
); fin de la funcion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Calcula los causal link desde un operador que se le pasa como parametro, a la lista de operadores existente
;;
;; Parametros: op (en estructura timePoint), list-op (hasta ahora annadidos) ;;            
;; Devuelve:   una lista con los causal-links (list-links)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun CALCULATE-LINKS (t_op list-op );  &optional (stream t))
 (let* ((is-nil nil)
	  ;(not-nil)
	  (add-effects nil)
        (del-effects nil)
        (preconds nil)
        ;(adds-primary nil)
        ;(goal-l nil)
	  (op-name nil)   
	  (ltemp nil)               ; Variable temporal que almacena el link
	  ;(num-op (length list-op)) ; EL numero de operadores que hay hasta ahora en la lista de operadores
	  (num-op (length user::*list-TPop*))
	  (is-consistent nil)
	  (new-state nil)
	  (temp-state nil)      ; Almacena los links calculados mediante lista-de-estados
        (links-temp nil)      ; Lista con los links que se annaden para cada operador  
	 ; (from-ops nil)        ; Almacena los links calculados desde el campo "state" del operador
	 ; (ltemp-plus nil)      ; En caso de q un operador tenga dependencias de varios operadores (calculadas por diferencia entre operadores y estados)
	  (m-op (De-Lista-Array num-op (reverse user::*list-TPop*))) ; Convertimos las lista de operadores a matriz
	  ;(m-op (De-Lista-Array num-op (reverse list-op))) ; Convertimos las lista de operadores a matriz Da problemas, 
; no se porque pero tienen distintas las longitudes!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        (ultimo nil)  ; Contiene el ultimo link (primero en calcularse) entre dos operadores. Esto es el mas cercano.
	  (ultimo-op  nil) ; Ultimo operador annadido a la lista de operadores consitentes
	  (op-aux1 nil)
	  (condit nil)
	  (ult nil)
	  (cont nil)
	  (seguir t)  ; Calcular el ultimo operador que 
	(opx nil)
	)
 

 (setq preconds     (user::TimePoint-preconds t_op)) ;Preconds
 (setq add-effects  (user::TimePoint-adds t_op))  ;Add Effects
 (setq del-effects  (user::TimePoint-dels t_op))  ;Delete Effects
 (setq op-name      (user::TimePoint-operator t_op)) ;The name of the new operator
 ;(setq add-op nil)   ; De momento el operador no se ha annadido


 ;(format t"Llamada a la funcion CALCULATE LINKS *****************************~%")
 ;(format t"~%Nombre= ~d~%preconds: ~a~%adds= ~d~%DELS = ~d~%" op-name (user::TimePoint-preconds t_op) (user::TimePoint-adds t_op) (user::TimePoint-dels t_op))    
 ;;(read t)
 (setq cont 0) 
 #|(if (= num-op 1) ;Si hay uno es porque es el primero-->igualo las listas
        (setq user::*list-TPop* list-op)
 );;fin del if
 |#   

 ;(format t"~%******** En la lista de TP verdadera hay  *****~d~%" user::*list-TPop*)
; (setq m-op (De-Lista-Array num-op (reverse user::*list-TPop*))) 	

 (if (/=  (user::TimePoint-id t_op) 2 )
    (progn
	   (setq op-aux1 nil)
	   #|
	     (loop for b from  1 to  (- (array-dimension m-op 0) 1) do
           ;(format t"Cont= ~d valor= ~d~%"  b (aref m-op  b))
	     ;(format t"Cont= ~d valor= ~d~%"  b (aref m-op b))
          );;fin del loop
          |#
	   ;(format t"~%Lista-TPop= ~d~%" (length user::*list-TPop*))
 	   ;(format t"~%Lista-op= ~d~%" (length list-op)) ;Parece que no tienen la misma longitud, QUE RARO!!!
	   ;(format t"~%Estados = ~d " (length user::*lista-de-estados*))
	   ;;(read t)
	   (setq temp-state (reverse (LINKS-FROM-STATE user::*lista-de-estados* m-op t_op )))
         ;(format t"~%------------------------------------------------------------")
         ;(format t"~%Los links DESDE FROM-STATE = ~d" temp-state)
	   ;(format t"~%operadores= ~d~%" user::*list-TPop*)
         ;;(read t)
	   (if temp-state ;mi-links-temp  
		(progn   ; Si no es nil es porque no hay op que dependan de varios. 
	  	  ;(format t"~%Fuera del bucle que calcula los links de cada estado. Saco el link")
         	  ;(format t"~%Sin sacar. Temp Link (state) = ~d ~% de la lista total = ~d~%LONG=~d~%" op-aux1 temp-state (length temp-state))
		  (setf ultimo (car (reverse temp-state)))
		  ;;(read t)
	  	  (setq op-aux1 (pop temp-state)) 
        	  ;(format t"~%Sacado. Temp Link (state) = ~d ~% de la lista total = ~d~%LONG=~d~%" op-aux1 temp-state (length temp-state))
	        ;;(read t)
		  (setq user::*mi-links-temp* nil) ; annadido ENERO 25/1/2003
   	  	  (if op-aux1
	  	     (progn
			 ;(format t"~%EL link es: ~%~d ~% y ~% t_op=~d" op-aux1 t_op) 
                   (setq ltemp op-aux1)
			 ;;(read t)
 		     );;fin progn	       
	           );;fin if no es op-aux1 nil
   	        );;fin progn
		 (progn  ; ya estan calculados--> mi-links-temp != nil
		   (setq ltemp user::*mi-links-temp*) 
		   (setq user::*mi-links-temp* nil)
	  	   ;(format t"~%Se han calculados links ya que habia paralelismo!!!!!!!! ~%ltemp = ~d" ltemp) ;;(read t)
	       );;fin del progn
	    );;fin del if temp-state != nil
     ;;(read t)

    ;; Se debe comprobar que la operacion a annadir no borra alguno de los links ya establecidos
    ;; La funcion devolvera una lista de nuevos links en caso que el link que se establece pueda borrar
    ;; alguno de los links establecidos y que deben estar comprendido entre los ID del link calculado
    ;; anteriormente.
    (if (listp ltemp)
  	 (setq is-nil ltemp) ;MODIFICAR UNO A UNO LOS COMPONENTES
       (setq is-nil (DEL-PRECOND t_op ltemp m-op ))  
    );;fin del if es lista ltemp

    ; NO lo(s) puedo annadir todavia, debo comprobar que no es borrado.
    (if (not(equal is-nil nil))
	  (setq ltemp is-nil)
    );;fin del if

   ;(format t"~%Lista de links despues de DEL-PRECONDS~%~d" ltemp)  
   ;;(read t)
	
   ;; Se debe comprobar que los efectos de las  acciones en el conjunto de acciones no niega las
   ;; condicion(es) establecida(s)  por el/los link(s). El Link-id1  debe ir en un estado posterior de dicha  accion.TEST-LINK
 
   ;(format t "~%*******Efectos de borrado de alguna accion******************************~%")
   ;(format t"~%Llamamos a detect State Links ")
   (setq  ltemp (Detect-State-links ltemp  list-op m-op t_op temp-state ))

   (if (equal ltemp nil)  ; SI NO HAY, BUSCO CON EL ULTIMO OPERADOR CONSISTENTE
	(progn
	   (setq ultimo-op (car user::*list-TPop*))  ; Ultimo operador consistente de la lista
	   (setq condit (intersection (user::TimePoint-state ultimo-op) (user::TimePoint-preconds t_op) :test #'equal))
	   ;(format t"~% A VER= preconds = ~d ~%state = ~d~% condit = ~d" (user::TimePoint-preconds t_op) (user::TimePoint-state ultimo-op) condit) 		
	   (if (equal condit nil)
	       (setq condit (user::TimePoint-preconds t_op))
	   )
	   ;(if (= (length condit) (length  (user::TimePoint-preconds t_op)))
	     ;(progn
;;;;;;;;;;;;;;;;;;;;;;;;;;;;  nueva modificacin  diciembre 2003 ;;;;;;;;;;;;;;;;;
	     ;(format t "~%Links que quedan por calcular = ~d~% cont = ~d~%" temp-state cont) ;(read t)
             ;(if  user::*calculate-resources*
               (if (> (user::RESOURCE-total  user::*Resorce-Consumed*) 1) ;;;; CAMBIAR!!!!!!
                (progn
                  ;(format t "~% HAY MAS DE UN RECURSO Y ADEMas los  QUEREMOS CALCULAR~%") ;(read t) 
                  (do* ((opx-aux-list temp-state (cdr opx-aux-list))
                        )
	               ((or (null opx-aux-list) (not (equal ltemp nil)))) ;no esta vacia la lista y no se han calculado link temporales
                        ;(format t "~%opx-zux = ~d~%" opx-aux-list) ;(read t)
                        (setq opx (car opx-aux-list))
		        ;;;(print 'ENTRA)
		        (incf cont)
			(setq ltemp (list opx)) ;;(format t "opx = ~d" ltemp) ;(read t)
		        (setq  ltemp (Detect-State-links ltemp  list-op m-op t_op temp-state ))
                        ;(format t "~%Dentro del bucle estado = ~d~% temp = ~d cont = ~d~%" temp-state ltemp cont)		    
                   );;fin do*                
                 );;fin progn
	        );;fin if numero de recursos es mayor que 1
               ;);;fin if se calculan recursos
              ; (format t "~%ltemp despues del bucle anadido=~d~%" ltemp) ;(read t)
               (if (equal ltemp nil)
                (progn
		  ;; (format t "~% user::*list-TPop* = ~d" user::*list-TPop*) ;(read t)
                    (do* ((opx-list user::*list-TPop* (cdr opx-list))
	 	          (opx (car opx-list) (car opx-list)))
	                       ((or (null opx-list)
		                    (not  seguir)))
		      ;; (format t "~%opx= ~d" opx) (read t)
					(setq  new-state (intersection (user::TimePoint-state opx) preconds :test #'equal))
		      ;; (format t "~%new-state=~d~%" new-state)
					(if (and new-state (= (length new-state) (length preconds)))
;;					(if (and (not (equal new-state nil)) (= (length new-state) (length preconds)))
					    (progn
					       (setq seguir nil)
					       (setq ltemp (user::make-link :id1 opx
					      	                :condition condit
				       	 	                :id2 t_op
				       		                :min user::*Min-Dist-Ops*
				       		                :max user::*Max-Dist-Ops*))
					       ;; (format t "~%link es ~d" ltemp) (print 'AQUI) (read t)
					    );;fin progn
					 );;fin if
			);;fin do
;; 		   (format t "~%Seguir = ~d" seguir)
                  (if  seguir					       
;;;;;;;;;;;;;;;;;;;;;;;;;;   FIN modificacion  diciembre de 2003 ;;;;;;;;;;;;;;;;;;;
	            (setq ltemp  (user::make-link :id1 ultimo-op
					      	  :condition condit
				       	 	  :id2 t_op
				       		  :min user::*Min-Dist-Ops*
				       		  :max user::*Max-Dist-Ops*))	
		  );;fin if 
		  ;; (format t "~%Anadido link con el ultimo operador ltemp = ~d~%" ltemp) ;(read t)
                 ) ;;fin progn
                );;fin if equal ltemp nil
	        ;(read t)  ; NO COMENTARRRRRRRRRRRRRRRRRRRRR
                
	        ;(setq is-consistent ultimo)
		;);;fin del progn
	        ;(setq ltemp nil)
	  ; );;fin del if
         ;(setq is-consistent nil)
	);;fin del progn
     );;fin is-consitent != nil (en caso de que no haya enlaces se hace annade uno con el anterior siempre que haya link entre ellos)
    ;(format t"~% ************ El operador es = ~d ~% ltemp = ~d  ***********************~% " t_op ltemp) 		
  
    (if ltemp
       (progn   
        ;(setq ltemp is-consistent) ; ANTES
         ;(format t"~%Lista de links ~d +++++ ANTES ~%" links-temp)
         ;(format t"~%EL link temporal para annadir es : ~d *******" ltemp)
         (if (listp ltemp)
	     (dolist (ll ltemp)
	   	  (push ll links-temp)
	      )
	     (push ltemp links-temp)
         );;fin if ltemp es lista
        ;(format t"~%Lista de links ~d~% T_OP= ~d " links-temp t_op)
        ;;(read t)
        ;(setq is-nil nil)

        ;; Annadimos el link del operador con la meta, si existe y lo annado a los totales	
        ;(format t"~%LLamamos a links goals")

        (setq ltemp  (links-goals t_op ))
        ;(format t"~%ltemp = ~d" ltemp)

        (if ltemp
		(progn
           	    ;(format t"~%NO nil")
	          (push ltemp links-temp)
		)
		;(format t"~%Es nil")											
        );;fin if	
        ;(format t"~%AQUIIIII temp~d~% links-temp = ~d" ltemp links-temp)
        (setq is-consistent (Add-TP  t_op links-temp user::*num* )) ;; LLamada a Add-Tp
        ;(format t"~%Es consistentes????  ~d" is-consistent)
        (if (equal is-consistent t)
          (progn 
	      ;(format t"~%La lista de oper DESPUES DE TODO = ~d" user::*list-TPop*) ;;(read t)
	      (setq ult (car user::*lista-de-estados*)) ;(format t" ~%Ult = ~d" ult)
	      ;(format t"~%Calculo de estados para ~d" (user::TimePoint-operator t_op))
	      (setq new-state (set-difference ult  del-effects :test  #'equal))
	      ; ;(format t"~%la lista de efectos es: ~d"  del-effects)
	      ; ;(format t"~%El nuevo estado interseccion es con dels :  ~d" new-state)	
		(setq ltemp nil)
		;(setq new-state (union new-state add-effects))

		;(setq new-state (union (list new-state) (list add-effects) :key #'car))
  	     (dolist (add add-effects)
		     (if (equal (member add new-state :test #'equal) nil)
		  	   (progn
					   ;(format t"~%Annadido porque no esta ~d ~%" add)
			  	         (push add new-state)
		  	    );;fin progn
			   ;(format t"~%No Annadido porque esta ~d ~%" add)
		     )
				 ;(setq ltemp (intersection  add state :test #'equal))
			       ;(setq state (union (list state) (list add) :key #'car))
		             ;;(format t"~%Hay predicados repetidos al calcular el estado del operador: ~d ~% add= ~d~%NS= ~d" ltemp add state)
		     ;(format t"~%Hay predicados AQUI repetidos: NS= ~d" new-state)
	      );;fin del dolist


	      #|(dolist (add add-effects)
			(setq ltemp (intersection  add new-state :test #'equal))
			(setq new-state (union (list new-state) (list add) :key #'car))
		      ;(format t"~%Hay predicados AQUI repetidos: ~d ~% add= ~d~%NS= ~d" ltemp add new-state)
	       );;fin del dolist
|#
	      (push new-state user::*lista-de-estados*)
	      (setf  (user::TimePoint-state t_op) (State-Operator t_op links-temp ult )) 
            (setf  (user::TimePoint-links-added t_op) links-temp) 
            ; ;(format t"~%Todos los estados : ~d" user::*lista-de-estados*)	
            ;; Juntar los links en la lista de links totales
             (setq user::*list-links* (append links-temp user::*list-links*)) 
            ;(format t"~% El operador completo annadido ~%~d ~%" t_op)
            ;;(read t)
           );;fin del progn
	   ;(format t"~%LA RETE DICE QUE NO ES CONSISTENTE")	
        );;fin del if is consistent
     );;fin progn	
    ;(format t"~%NO HAY ENLACES CON NINGUN OPERADOR!!!!")	
   );;fin if ltemp != nil
  );;fin del progn	 
 (progn ;; es F-OP
     (push t_op user::*list-TPop*)
     ;(format t"~%La lista de oper DESPUES DE TODO = ~d" user::*list-TPop*) ;;(read t)
     (setf  (user::TimePoint-state t_op) (user::TimePoint-state (car user::*list-TPop*))) ;;Estado de F-OP
     (push '(F-OP) user::*lista-de-estados*)  ; Podria poner de nuevo el ultimo estado, para que no ocupe tanto
     (setf (user::TimePoint-links-added t_op) user::*list-goal*)
     (setf (user::TimePoint-preconds t_op) (cdadr (p4::problem-goal(current-problem))))
     ;(COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num* ) 
     ;(format t"~%~%La lista de list-links  es: ~d~%" user::*list-links*) ;;(read t)

 );;fin del progn F-OP
);;fin if != F_OP
; ;(format   t "~%~%La lista de list-links  es: ~d~%" user::*list-links*)

;; (if *tracep* (break))
 ;(format t"~%  ..............  fin de la funcion CALCULATE-THREATS  .......... ~%")
 is-consistent 
 );;fin del let *
);fin de Calculate-Threats


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Calcula los links a partir del estado anterior. 
;;
;; Param: lista de estados (de todos los operadores aplicados hasta ahora), matriz de operadores (lista convertida a matriz)
;; , op, list-op,
;; Devuelve: la lista de links
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun LINKS-FROM-STATE (l-estados matriz t_op ); &optional (stream t))
 (let* ( ;(op-aux1 nil)
	  (comun-state nil)
	  (comun-op nil)
	  (preconds (user::TimePoint-preconds t_op))
	  (lt nil)
	  (lista-links nil)
	  (ind 0)   ;Indice de la matriz de los operadores
	  (op-aux nil)
	  ;(matriz (De-Lista-Array (length user::*list-TPop*) (reverse user::*list-TPop*))) antes tenia mm en vez de matriz
       )

   ;(format t"~% La matriz = ~d" matriz)
   ;(format t "~%************  INIcio de la funcion LINKS-FROM-STATE ****************~%")
   #|;(format t"Long l-estados=~d  Long matriz=~d  Long op= ~d Long mm=~d  " (length l-estados) (array-dimension matriz 0) (length list-op) (array-dimension mm 0))
	   (loop for b from  1 to  (- (array-dimension matriz 0) 1) do
           ;(format t"Cont= ~d valor= ~d~%"  b (aref matriz b))
	     ;(format t"~%Cont= ~d matriz= ~d~%"  b (aref matriz b))
	     ;(format t"~%Cont= ~d mm= ~d~%"  b (aref mm b))

          );;fin del loop
	   ;(format t"~%Lista-TPop= ~d~%" user::*list-TPop*)
 	   ;(format t"~%Lista-op= ~d~%" list-op)
	  ; ;(format t"~%Estados = ~d " l-estados)
  |#

   (dolist (state (reverse l-estados))  ;La lista me la recorro desde S-OP al ultimo estado introducido
	      (setq  comun-state (intersection state preconds :test #'equal))
	      (setq op-aux (aref matriz ind)) ; Operador en la matriz que me recorro para saber su estado
	      (setq  comun-op (intersection (user::TimePoint-state op-aux) preconds :test #'equal)) ; Numero de predicados en comun entre las precondiciones del operador y el estado del op. de la matriz
	      ;;(format t"~%Estado = ~d ~%Operador-state = ~d" state (user::TimePoint-state op-aux))
		;(format t"~%Indice = ~d ~% Operador segun matriz = ~d" ind (user::TimePoint-operator op-aux))
	      ;(format t"~%Operador segun lista estados = ~d~%Operador pasado por Prodigy~d" (user::TimePoint-operator op-aux) (user::TimePoint-operator t_op))
		;(format t"~%Comun-op=~d ~%Comun-state=~d ~%Preconds=~d" comun-op comun-state preconds)
	      ;(format t"~%Long comun-state = ~d Long comun-op= ~d y preconds = ~d" (length comun-state)(length comun-op) (length preconds)) 
	      (if (and (= (length comun-state) (length preconds)) (/= 0 (length preconds)) (/= 0 (length comun-state)) (/= 0 (length comun-op))  )   ; MODIFICACION 18/1/03	
	      ;(if (= (length comun-state) (length preconds))
		    (if ( = (length comun-op) (length comun-state))
   	              (progn
			      ;(format t"~%Tienen los = literales COMUNES: ~% ~d~% y ~% ~d" (user::TimePoint-operator t_op) (user::TimePoint-operator op-aux))
				(setq lt   (user::make-link   :id1  op-aux 
									:condition comun-state 
					           			:id2  t_op
									:min user::*Min-Dist-Ops*
									:max user::*Max-Dist-Ops*)
				 )
				(push lt lista-links)
			      ;(format t"~%temp state added= ~d ~% a lista total" lt lista-links)
				;;(read t)
		         );;fin del progn
        	        (progn  ;no coinciden, debo calcular los links de los que depende
			      ;(format t"~%No coinciden los literales de los operadores y estados") 
				(setq user::*mi-links-temp* nil)  ; Si no lo ponia a nil me annadia otros links ...
      			;(loop for cont  from 0 to (- (array-dimension matriz 0) 1) do  ;Empezar desde el principio
      			(loop for cont  from (- (array-dimension matriz 0) 1)  downto 0 do
				    ;(format t"~%Cont= ~d Preconds=~d" cont preconds)
	      		    (setq op-aux (aref matriz cont)) 
				    (if (not (equal preconds nil))
					(progn
	      			   (setq  comun-op (intersection (user::TimePoint-state op-aux) preconds :test #'equal))
					   (if (not (equal comun-op nil))
						(progn
					         (setq preconds (set-difference  preconds comun-op :test #'equal)) ;Los literales diferentes
					         ;(format t "~%Comun-op= ~d~%Preconds=~d" comun-op preconds )
					         (setq lt   (user::make-link   :id1  op-aux 
					   	    				  :condition comun-op 
					           				  :id2  t_op
										  :min user::*Min-Dist-Ops*
										  :max user::*Max-Dist-Ops*)
					         )
					  	   (push lt user::*mi-links-temp*)
			              	   ;(format t"~%temp state added si comun-op (no NIL) = ~d ~%a lista total=~d" lt user::*mi-links-temp*)
						);;fin del progn
					  );;fin del if
 				         ;(format t "~%La interseccion es nil")
					);;fin del progn
					(return t)
				    );;fin del if
				);;fin del loop
				;;(read t)
			   );;fin del progn
	           );;fin del if  iguales condiciones en comun
		     ;(format t"~%No tienen todas las condiciones en comun")
		);;fin del if (= preconds y state)
	     (incf ind)    
     );;fin del dolist 
   ;(format t "~%************  FIN de la funcion LINKS-FROM-STATE ****************~%")
  lista-links 
 );;fin del let*
);;fin de la funcion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Calcula el estado que se encuentra cada operador despues de annadir 
;;  los links de los que depende. 
;;  1-->3  l operador 3 estara en el estado: estado(1) + add(3) - del(3)
;;
;; Parametro: el operador, la lista de links calculados para ese operador y el ultimo estado
;;            en caso que se tuvieran mas de un link para ese operador (no se puede calcular  annadiendo adds
;;            y del ya que puede haber operadores que se repiten por varios caminos y que no se pueden eliminar.
;; Retorna:   el estado asociado a ese operador una vez aplicado.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun State-Operator (op lista estado ); &optional (stream  t))
 (let* ((state nil)
	  (orig nil)   ; Operador Origen de link
	  (dest nil)   ; Operador Destino del link (debe coincidir con op)
 	  (add-effects  (user::TimePoint-adds op))  ;Add Effects
 	  (del-effects  (user::TimePoint-dels op))  ;Delete Effects
        ;(ltemp nil)
	 )
  ;;(format t "~%*****  State-Operator ***************************~% operador = ~d" op)
  ;;(format t "~%DEl= ~d~%ADD= ~d ~% NOMBRE= ~d" add-effects del-effects  (user::TImePoint-operator op))
  ;;(format t "~%El link es: ~d " lista) ;;(read t)

  (dolist (lik lista)
      (setq orig (user::link-id1 lik)) 
      (setq dest (user::link-id2 lik)) 
      ;(format t"El link es: ~d ........*******" lik)
      (if (equal dest op)
	    (progn
		 ;(format t"~%EL destino del link y el operador son iguales")
		 (if (equal state nil) ; Es el primero en annadir, annado todo el estado
			(progn
			   ;(format t"~% Es el primero pppppppppppppppppppppppppp" )
			   (setq state (user::TimePoint-state orig))      ; Estado del link origen
			   ;;(format t"~% State = ~d~%Dif=~d" state (set-difference state  del-effects :test  #'equal))
			   (setq state (set-difference state  del-effects :test  #'equal)) ; menos los del del operador 
			   #|(dolist (add add-effects)   ; Y le annado los add del operador 
			  	 (push add state)
				 ;(format t"~% Add = ~d" add) 
			       ;;(read t)
			   );;fin del dolist|#  ; Antes
		 
                   ;(setq state  (union (list state) add-effects :key #'car))

			  ;; Despues
			   (dolist (add add-effects)
			       (if (equal (member add state :test #'equal) nil)
					(progn
					   ;(format t"~%Annadido en FUNCION porque no esta ~d ~%" add)
			  	         (push add state)
					);;fin progn
					;(format t"~%No Annadido en FUNCION porque esta ~d ~%" add)
				 )
				 ;(setq ltemp (intersection  add state :test #'equal))
			       ;(setq state (union (list state) (list add) :key #'car))
		             ;;(format t"~%Hay predicados repetidos al calcular el estado del operador: ~d ~% add= ~d~%NS= ~d" ltemp add state)
	               );;fin del dolist
			  

			   ;(format t"~%EL estado es: ~d" state) 
			   ;;(read t)
			);;fin del progn
			(progn
			   ;(format t"~% Se han annadido mas links +++++++++++++++++++++++++++" )
			   ;(format t"~% Estado= ~d" estado)
			   (setq state (set-difference estado del-effects :test  #'equal)) 
			   (dolist (add add-effects)
			       (if (equal (member add state :test  #'equal) nil)
					(progn
					   ;(format t"~%Annadido otra porque no esta ~d ~%" add)
			  	         (push add state)
					);;fin progn
					;(format t"~%No Annadido OTRA porque esta ~d ~%" add)
				 )
				 ;(setq ltemp (intersection  add state :test #'equal))
			       ;(setq state (union (list state) (list add) :test  #'car))
		             ;;(format t"~%Hay predicados repetidos al calcular el estado del operador: ~d ~% add= ~d~%NS= ~d" ltemp add state)
	               );;fin del dolist

			   ;(format t"~%EL estado es en links: ~d" state) ;;(read t)
			   (return t)
			);;fin del progn
		 );;fin del if state nil
           );;fin del progn
	     (progn
		   (if (not (equal orig op)) ; Si el origen del link es el operador, es porque ha cumplido la meta
			(progn
		          ;(format t"~%ES IMPOSIBLE QUE NO COINCIDAN") ; Me quedo con la lista calculada secuencialmente
		          ;(format t"~%ES IMPOSIBLE QUE NO COINCIDAN") ; Me quedo con la lista calculada secuencialmente
		          (setq state estado) ; ANtes  lista??
		          ;;(read t)
		          (return t)
			);;fin del progn
		   );;fin del if
		);;fin del progn
	);;fin del if dest = op
  );;fin del dolist
  ;(format t"~%*****  FIN State-Operator ***************************~%")
  state
 );;fin del let*
);; fin de la funcion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Calcula si hay un path que une dos operadores.
;;  Parametros: lista de links de un operador, el id del operador que se esta buscando.
;;  Devuelve:   t o nil
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun FIND-PATH (lista id-orig id-dest m ) ;&optional (stream  t) )
 (let* ((find nil)
	  (link nil)
	  (ind nil)
	  (list-aux nil)
	  (op nil)
	 )
;(format t"~%***** FIND-PATH  ***************************~%")
;(format t"~% Links = ~d" lista) ;;(read t)
   (if ( >= (length lista) 1)
	 (progn
		(setq link (pop lista))
		;(format t"~% Links = ~d~%Id-origen = ~d id1 del link = ~d" lista id-orig (user::TimePoint-id (user::link-id1 link)))
		(if (= (user::TimePoint-id (user::link-id1 link)) id-orig)
			(setq find t)
 			;(format t"~%Pues no devuelve TRUE!!!!")
            );;fin del if
		(if (and (> (user::TimePoint-id (user::link-id1 link)) id-orig) (/= (user::TimePoint-id (user::link-id2 link)) 2)) ;Annadido la 2 parte para que en caso que sea el enlace con el ultimo no haya bucle infinito
		    (progn
	             (setq ind  ( - (user::TimePoint-id (user::link-id1 link)) 2)) ; El resto tienen ind -2
			 ;(format t"~% ind=~d" ind);;(read t)
			 (if (> ind 0)
			   (progn
		       	(setq op (aref m ind)) 
			 	;(format t"~% op=~d " op)
			 	(setq list-aux (user::TimePoint-links-added op ))
			 	;(format t"~% ind= ~d lista-aux = ~d " ind list-aux) ;;(read t)
			 	(setq find (FIND-PATH list-aux id-orig id-dest m ))
			   );; fin del progn
 			);;fin del if
		    );;fin del progn
            );;fin del if
	 );;fin del progn
    );;fin del if
  find
  );;fin del let*
);;fin de la funcion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Se debe comprobar que la operacion a annadir no borra ninguno de los links ya establecidos
;;  La funcion devolvera una lista de nuevos links en caso que el link que se establece pueda borrar
;;  alguno de los links establecidos (y que deben estar comprendido entre los ID del link calculado
;;  anteriormente. --> no ES CIERTO ya que se quedarian sin annadir algunos links)
;;
;;  Se calcularan los nuevos links. Hay que tener en cuenta si los links calculado sya estan enlazados
;;  por otros links anteriores, en dicho caso no hace falta annadirlos porque estan a salvo
;;  Parametros: el operador que me pasa Prodigy y el link que se ha establecido.
;;  Devuelve:   una lista con los nuevos links o nil si no hubiera amenazas
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun DEL-PRECOND (op l-establec m ); &optional (stream  t) )
;(format t"~%*****  DEL-PRECOND  ***************************~%")
 (let* ((delete nil)
	  (not-nil nil)
	  (condit nil)
 	  (link-temp nil)
	  (lista nil)
	  (id-orig nil) ; en caso de haber un op. que se borra por el link, comprobar que no haya uno ya desde orig a dest ((in)directamente)
	  (id-dest nil)
	  (links-op nil)
	  (finded nil)
	  (ind 0)
	  (t-op nil)
	  (l-borra nil)

       )
   ;(format t"~% La matriz = ~d" m)
   ;(format t"~%Lista de links hasta el momento= ~% ~d ~%El establecido= ~d~%" user::*list-links* l-establec)
   ;(format t"~%El operador  ~d~% NO DEBE BORRAR NINGUN LINK ESTABLECIDO. sI LO HAY devuelve las dependencias" (user::TimePoint-operator op))
   (loop for link  in user::*list-links* do
	;(format t"~% Siguiente link=~d  ~%Condicion del link= ~d" link (user::link-condition link))
	(setq condit  (intersection (user::TimePoint-dels op)  (user::link-condition link) :test #'equal)) 
	;(format t"~%La interseccion es: = ~d" condit)
	(setq  not-nil (not (equal condit nil)))  ; Hay una accion  que borra algo
          (cond (not-nil
	       ;(format t"~%El operador que borra condiciones es =~d  ~%" op)
	       ;(format t "~%id link establecido= ~d  Id2 link = ~d" (user::TimePoint-id (user::link-id1 l-establec)) (user::TimePoint-id (user::link-id2 link)))
		 (if (= (user::TimePoint-id (user::link-id2 link)) 2)
			(progn
			   ;(format t "~%Id2 del link es el FINAL, Lo tenemos que elimnar")
			   (if  (= (user::TimePoint-id (user::link-id1 link)) 1)
				  (setq ind 0)
				  (setq ind (- (user::TimePoint-id (user::link-id1 link)) 2))
  			   );;fin if
			   (setq ind (- (length user::*list-TPop*) ind 1))
			   (setq t-op (nth ind user::*list-TPop*))
			   (setq l-borra (pop (user::TimePoint-links-added t-op))) 
			   ;(format t   "~%El operador es: ~d~%El link borrado: ~d~% "t-op l-borra)
		         (setq user::*list-links* (set-difference user::*list-links* (list l-borra)  :test #'equal)) 
			   ;(format t "~%LINKS= ~d"  user::*list-links*)
			   ;(format t "~%ind = ~d" ind)
			   (setf (nth ind user::*list-TPop*)  t-op)
			   ;(format t "~%list-TPOP= ~d"  user::*list-TPop*)
			);;fin
		  (progn
             ; Si el op origen del link al que borra va antes del inicio del op-origen del link establecido
		 ; se debe buscar si existe un camino que les una --> si no existe el link se establece, en caso con trario no se annade.
		 (if ( <= (user::TimePoint-id (user::link-id1 link)) (user::TimePoint-id (user::link-id1 l-establec))  ) 
		    (progn
			#|(if (= (user::TimePoint-id op) 1) ; El origen es el id-origen del link al que se le amenaza
		             (setq id-orig  ( - (user::TimePoint-id (user::link-id1 link)) 1)) ; Es (S-OP)--> ind = 1
		             (setq id-orig  ( - (user::TimePoint-id (user::link-id1 link)) 2)) ; El resto tienen ind -2
                   );;fin del progn |#
	            (setq id-orig  (user::TimePoint-id (user::link-id2 link))) ; iD-ORIGEN ES EL ID-destino DEL LINK AL QUE SE LE AMENAZA
	            (setq id-dest (user::TimePoint-id (user::link-id1 l-establec))) ; El id-dest maximo es el origen del link establecido
			;(format t"~% id-dest = ~d id-orig = ~d ~%Links-op =~d~% operador= ~d" id-dest id-orig  links-op op)
			(if (and (/= id-dest id-orig) (> (- id-dest 2) 0)) 
			  (progn				
		  	   (setq links-op  (user::TimePoint-links-added (aref m (- id-dest 2)))) ; Empezamos desde la ultima posicion de la matriz
		         (setq finded (FIND-PATH links-op id-orig id-dest m )) ;;(read t)
			   ;(format t"~%***** FIN FIND-PATH  ***************************~%")
			   ;(format t"~%finded = ~d" finded)
			  );;fin del progn
			);;fin del if
		    );;fin del progn
		 );;fin del if
		 (if (equal finded nil)
		    (progn
				;; Si el operador destino del link es amenazado por los efectos de op, compruebo que el operador origen del 
			      ;; link establecido por op (op es el destino) y que me pasan (l-establec) es < quel ID destino del link
	       		;; en dicho caso no meto en la pila l-establec y meto el/los nuevo(s).
			      ;; He puesto que los operadores no se llamen igual por el porblema p4. No hay manera de controlarlo
		  		    ;(format t"~%Id origen del link pasado = ~d" (user::link-id1 l-establec))
		                ;(format t"~%Id del operador al que borran las precond= ~d"(user::TimePoint-id (user::link-id2 link)))
		  		    (setq link-temp (user::make-link :id1 (user::link-id2  link)   
										 :condition condit            
										 :id2  op             
										 :min user::*Min-Dist-Ops*         ;; Se deberian coger desde el dominio 
										 :max user::*Max-Dist-Ops* ))      ;; Crear una funcion que me lo de.
		
				    ;(format t"~%Link ESTABLECIDO  ...... ~d~%" link-temp)
		  		    (push link-temp  lista)
	   			    (setq delete t)
		     );;fin del progn
		 );;fin del if finded = nil	 	 
		);;fin progn
	     );;fin del if no es id=2
	    ));; fin del cond
    );;fin del loop list-link
   ;;Incluimos el link establecido inicialmente ya que no borra ninguna condicion (link) establecido anteriormente
   (if (equal delete nil)
       (progn
          (push l-establec lista)
          ;(format t"~%~d"  l-establec)
        );;fin del progn
       ;(format t"~%Ha borrADO algo. Links annadido= ~d" lista)
   );;fin del if

   ;(format t "~%************************FIN  DEL-PRECOND  *************~%")
   lista
 );;fin del let* 
);;fin de Del-precond

;; mejora: comprobar SOLO los links cuyo Id-1 y Id-2 esten entre los ID's de l-establec (no tener que
;; recorrer la lista de links). Esto supondria tener una tabla con los links, o algo asi...


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Se debe comprobar que los efectos de alguna accion en el conjunto de acciones no niega una/las
;;  condicion(es) establecida(s)  por el link. 
;;
;;  Parametros: la lista de operadores, el(los) link(s) y opcionalmente el fichero
;;   
;;  Devuelve: true si hay amenazas o nil si no las hay.
;;		  EN caso de que haya amenazas se considerara el siguiente link del estado (temp-state)
;; En la matriz: los indices seran:
;;  S-OP..ID-1-->(0) Op-1..ID-3-->(1) Op-2..ID-4 (2) ..... F-OP ..
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun TEST-LINK (links matriz ); &optional (stream t))
 (let* ((del-effects nil)
	  (not-nil nil)
	  (condit nil)
	  (hay nil)
	  (i 0)
	  (j 0)
	  (longt (array-dimension matriz 0))    ; el numero total de operadores
	  (opdel nil)
       )

;;;(format t"~% La matriz = ~d" matriz)
;;(format t"~% Los links = ~d" links)
;(format t"~%*****  INICIO TEST-LINK FUNCTIONS  ***************************~%") 
;(format t"~% Los efectos de alguna accion en el conjunto de acciones no niega el link = ~d~%"links) ;(read t)
(if (listp links)
 (dolist (lik links)
   (setq i (user::TimePoint-id (user::link-id1 lik))) 
   (setq j (user::TimePoint-id (user::link-id2 lik)))
   ;(format t"~%i= ~d  j= ~d~%LINK= ~d" i j lik)
   (if (= i 1)
       (setq i (- i 1))
       (setq i (- i 2))
   );;fin del if   
   (setq j (- j 2))
   (if (or (= j 0) (= j longt))
       (setq j (- longt 1)); es el operador final o el ultimo annadido (todavia no esta en la lista)
   );;fin del if
   ;(format t"~%NUEVOS i= ~d  j= ~d LONG= ~d" i j longt)
   (if ( /= i j)
     (progn
      (loop for ind  from i to j do
        ;(format t"~%Indice = ~d" ind)
	  (setq opdel (aref matriz ind)) 
	  ;(format t"~% Nombre del operador =~d  " (user::TimePoint-operator opdel))
	  (if (not (and (equal (user::TimePoint-operator opdel) '(S-OP))(not(equal (user::TimePoint-operator opdel) '(F-OP)))))
	    (progn
	      ;(format t"~%EL link que me pasan: ~d~%Condicion " lik (user::link-condition lik))
	      ;(format t"~%EL operador ~d tiene como del=~d~%" (user::TimePoint-operator opdel) (user::TimePoint-dels opdel) )
	      (setq del-effects (user::TimePoint-dels opdel))
	      (setq condit (intersection del-effects  (user::link-condition lik) :test #'equal)) 
	      (setq  not-nil (not (equal condit nil)))  ; Hay una accion  
	      ;(format t"~%Interseccion = ~d " condit)
      	(cond (not-nil
  	         ;(format t"~%La condicion ~d ~%  se borra por ~d~%" condit (user::TimePoint-dels opdel))
		   ;(format t "~%Link destino=~d  ~%" (user::TimePoint-id  (user::link-id2  lik)))
	         (if  (and (> (user::TimePoint-id opdel) (user::TimePoint-id (user::link-id1 lik)))
				 (< (user::TimePoint-id opdel) (user::TimePoint-id (user::link-id2 lik))) )
		      (progn
		        ;(format t"~%No Son Iguales Los IDS Ni CoincidenAmbos ID y El Operador que borra va despues")
			  (setq hay t)
                    ;(format t"~%El valor de hay=~d" hay)
			  (return t)
		      );;fin de progn 
		      ;(format t"~% link se establece entre = op o entre 2 op = no la incluyo en la lista de UNSAFE~%")
                 );;fin del if       
	       ));; fin del cond
	    );;fin del progn
	    ;(format t"~%EL operador es igual a S-OP o F-OP")	
        );;if
     );;fin del loop for
     ;;(read t)
     (if (equal hay t)
	 (return)
      );;fin del if
    );;fin del progn
    ;(format t"~%Los dos operadores estan seguidos")
    );;fin del if
  );;fin del dolist
 )
  ;(format t "~%************************  FIN  de TEST-LINK FUNCTIONS  *************~%")
  ;(format t"El valor de hay=~d" hay)
  ;;(read t)
  hay
 );;fin del let* 
);;fin de Test-Link

;;mejora: Se podria comprobar si exite ya un ordenacion entre los operadores, en dicho caso no hace falta annadirlo.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Calcula si el Link esta a salvo y sino, calcula los links del siguiente estado
;;
;;  Parametros: el link establecido, lista de operadores, matriz de operadores. el operador que se va a annadir
;;		    la lista de links posibles que se pueden establecer. SI no se pudiera establecer ninguno
;;		    se establecera con el anterior (iran en serie)
;;  Devuelve:  la lista de links que se establece o nil si no se puede establecer ninguno de los calculados
;;		   en temp-state (la funcion que la llama comprueba si es nil y en dicho caso
;;		   establece el link con el operador anterior)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Detect-State-links (ltemp  list-op matriz t_op temp-state );&optional (stream  t))
 (let* ((resul nil)
	  (is-nil nil)
	  (lt nil)
       )

   ;(format t"~% La matriz = ~d" matriz)
  ;(format t"~% ...........FUNCION Detect-State-links ........... ") 
  (setq is-nil (TEST-LINK ltemp  matriz ))
  ;(format t"~%Is-Nil = ~d" is-nil)


  (if (equal is-nil nil) ; No hay condiciones en peligro, se debe incluir el link "ltemp" en la red
	(progn
	   (setq resul ltemp) 
	   ;(format t"LTEMP = ~d" ltemp)
	   ;(format t"~%no hay borrados") ;;(read t)
 	 );;fin del progn
	(progn ;;Como hay un operador que borra el link, el siguiente estado de los calculados
	   ;(format t"La longitud de los estados calculados ~d" (length temp-state))
	   (if (> (length temp-state) 0)
		(progn
	   	   (setq lt  (pop temp-state))
	         ;(format t"~%El nuevo link a probar es: ~d " lt)
		   (setq is-nil (DEL-PRECOND t_op lt matriz )) 
		   ;;(read t) 
		   ; NO lo(s) puedo annadir todavia, debo comprobar que no es borrado.
		   (if (not(equal is-nil nil))
			  (setq lt  is-nil)
		    );;fin del if
	     ;(format t "~%NUEVO!!!!!!!!!!!!!!!!~%Llamada recursiva a la misma funcion Detect-State donde lt = ~d is-nil = ~d~%" lt is-nil) ;(read t)
;;;;;;;;;;;;;;;;;;;;;;;;;; MD  MODIFICADO DICIEMBRE DE 2003 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    (if (listp lt)
  	               (do* ((lista lt (cdr lista))
		             (list (car lista) (car lista)))
	                      ((or (null lista) (not(null resul))) 		               
                               (setq resul (Detect-State-links lista  list-op matriz t_op temp-state ))
		               ;(format t "~%EL primer valor que se pasa es = ~d" lista)
			       ;(read t)                               
                              );;fin or
                       );;fin del do
                    );;fin if es list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  FIN MD  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    ;;; (setq resul (Detect-State-links lt  list-op matriz t_op temp-state )) ;; ANtes de diciembre
		 );;fin del progn
	       (progn  ; No hay mas estados
		   (setq resul nil)
		   ;(format t"~%No hay mas estados. Devuelvo el ultimo de la lista de estados~%") ;;(read t)
             );;fin del progn (else)
	  );;fin del if
       );;fin del progn
    );; fin if equal is-nil
  ;(format t"~%resu=~d" resul)
  ;(format t"~% ...........FIN Detect-State-links ........... ") 
  resul 
 );;fin del let*
);;fin funcion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se encarga de iniciar la red temporal con n nodos.
;;
;; Parametros: el numero de nodos que compondran la red temporal
;; Devuelve: nada
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Init-TemporalNetwork (n );&optional (stream t))

  ;(format t"~% *****  ------   Init-TemporalNetwork------------- dur= ~d MaX= ~d~%" user::*DurationMin* user::*DurationMax*)

  (setq user::*rete* (COMMON-LISP-USER::init-time-map 1)) ; crea la Red temporal
  (COMMON-LISP-USER::gen_tps user::*rete* n)              ; crear el resto, ya q la anterior solo crea  origen y horizonte
 
 ;Establecemos el makespan entre el origen y el horizonte en caso de que se hubiera impuesto algun valor
  (if (not(equal user::*DurationMin* nil)) 
    (progn
  	(COMMON-LISP-USER::relate_tp_id user::*rete* 1 2 user::*DurationMin* user::*DurationMax*)
  	(COMMON-LISP-USER::propagate-AC user::*rete*)           ; propaga. Se debe poner propagate-BF si BF. propagate-AC si AC
  	(COMMON-LISP-USER::save-solution user::*rete*)   
    );;fin progn
  );;fin if
  
  ;(COMMON-LISP-USER::write-dcs user::*rete* 1 user::*num*)  ; Visualiza los arcos entre esas actividades
  ;(format t"~% *****  ------  FIN   Init-TemporalNetwork------------- ~%")
  ;(read t)
);;fin de Init-TemporalNetwork


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se encarga de annadir las relaciones causales y temporales a la red para ver si son consistentes
;; en el tiempo
;; Parametros: el operador elegido por Prodigy, la lista de links para ese operador  y el numero de nodos totales de la red.
;;
;; Devuelve:  nil si no es consitente o t en caso contrario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Add-TP (op  links-temp n );  &optional (stream  t))
 (let* ((consistent t)
	  (added-f nil)	
	 )

  ;(format t"~% *****  ------     ADD TP  ------------- m= ~d~%" n)
  ;;(format t "~%Primero. Antes de Llamar a RETE  user::*last-op-consistence* = ~d" user::*last-op-consistence*) ;(read t)

  ;; Iniciamos la Red en caso de que no se hubiera iniciado.
  (if (equal user::*rete* nil)
	(Init-TemporalNetwork n )  ; Llamada a Init-TemporalNetwork
  );;fin del if

 ;(format t "~%Operador que me pasan es: ~d " op)

 ;(format t"~%Temporales para add ~d" links-temp) 
 (setf  (user::TimePoint-added op) t)  ; Ponemos del campo de annadido a la red a TRUE

 ;;(format t "~%El horizonte es ~d~%" (COMMON-LISP-USER::get-horizon user::*rete*) ) 
 ;(format t"~%El horizonte es ~d~%" (COMMON-LISP-USER::get-horizon user::*rete*))
 
 (if (>= (user::TimePoint-id  op) (/ user::*num* 2))
    (progn
	;;(format t "~%The number of Time Points (~d) has been exceed. Open a new window and type: ~%~%(setf  user::*num* 500)~%" user::*num*)
 	(break  "~%SE HA SOBREPASADO EN NUMERO DE TIMEPOINTS DISPONIBLES EN LA RED !!!!!!!!!!!!!!!!")
	;(p4::cons :stop :achieve)  ;NO FUNCIONA

    );;fin progn

    (progn 
	(COMMON-LISP-USER::relate_tp_id user::*rete* 1 2 user::*DurationMin* user::*DurationMax*)
	;(COMMON-LISP-USER::propagate-AC user::*rete*)           ; propaga. Se debe poner propagate-BF si BF. propagate-AC si AC

	 ;;El operador F-OP se ha annadido al crear la red, no hace falta annadirlo otra vez
	 (if (and (not(equal (user::TimePoint-id  op) 2)) (not(equal (user::TimePoint-id  op) 1)))
	   (progn
     		;; Annadimos la relacion temporal (duracion) entre los TP del operador op
	     (COMMON-LISP-USER::relate_tp_id user::*rete* (user::TimePoint-start-id op) (user::TimePoint-end-id op)(user::TimePoint-duration-min op) (user::TimePoint-duration-max op))   ; Establece el arco entre start-id y end-id, con [durmin, durmax]
	     ;;(format t"~%El operador con TP ~d y ~d con dur =  ~d y ~d ~%..... Se ha annadido~%" (user::TimePoint-start-id op) (user::TimePoint-end-id op)(user::TimePoint-duration-min op) (user::TimePoint-duration-max op))
	   );;fin del progn
	   ;;(format t"IGUAL A S-OP")
	 );;fin del if

	 ;(COMMON-LISP-USER::save-solution user::*rete*) 
	 ;(incf cont)
	 (if (> (length links-temp) 0)
	    (progn
      	 (dolist (lik links-temp) 
		    ;;Establecemos el link entre el end de id1 y start de id2 con min y max de separacion entre ellos
		    ;;(format t"~%Entre TP ~d y ~d con dur entre ~d y ~d~%"  (user::TimePoint-end-id (user::link-id1 lik)) (user::TimePoint-start-id (user::link-id2 lik))  (user::link-min lik)(user::link-max lik))
		    (if (= (user::TimePoint-start-id (user::link-id2 lik)) 2)
			(progn
			  (setq added-f t)
			  ;;(format t"~%El link final= ~d no es igual a  2~%Added = ~d "(user::TimePoint-start-id (user::link-id2 lik)) added-f)
      	      );;fin progn
		     ;;(format t"~%El link final= ~d no es igual a  2" (user::TimePoint-start-id (user::link-id2 lik)) )
	    	   )
	    	  (COMMON-LISP-USER::relate_tp_id user::*rete* (user::TimePoint-end-id (user::link-id1 lik)) (user::TimePoint-start-id (user::link-id2 lik))     (user::link-min lik)(user::link-max lik))
	  	);;fin del dolist
	 	;Annadimos el enlace con el ultimo para que se propague bien la red ya que no se ha annadido
		(if (equal added-f nil)  
		   (progn
	          (COMMON-LISP-USER::relate_tp_id user::*rete* (user::TimePoint-end-id op) 2 user::*Min-Dist-Ops* user::*Max-Dist-Ops*)
		    ;;(format t"~%SE ha annadido LINK con el ultimo operador")
	         );;fin progn del equal
		   ;(format t"~%NO se ha annadido LINK con el ultimo operador")
		);;fin if
		 ;; Propagamos la relacion del link  y vemos si es consistente
		 (setq consistent  (COMMON-LISP-USER::propagate-AC user::*rete*)) ;;(format t"~%consi= ~d" consistent)
		 (if (equal consistent nil) ; Es inconsistente, debemos restablecer el estado a salvo 
      	   (progn ;Si NO es consistente
                  ;(COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num* )
    	      	(COMMON-LISP-USER::restore-solution user::*rete*) 
	            ;(format t"~%~% Como no es consistente hemos restaurado el ultimo estado consistente~%") ;(read t)
		      (COMMON-LISP-USER::save-solution user::*rete*)  
	    	   );;fin progn
		   (progn ;Es consistente, debemos ver si hay que calcular recursos
                 (if user::*calculate-resources* 
			   (setq consistent (Calculate-resource-relation op))
			   (progn
 		            (COMMON-LISP-USER::save-solution user::*rete*)  ;else --> consistente
				(push op user::*list-TPop*)
          		      ;(format t "~%~% Hemos salvado la solucion en la pila. corresponde al op= ~d~%links= ~d~%" op links-temp)
                     );;fin progn de no hay q calcular recursos
                  );;fin if hay que calcular recursos
	     );;fin de progn es consistente, veamos si hay q calcular o no recursos
     );;fin if no es consistente
   ));;fin del progn del > length links temp
 ));;fin del if *num* = n/2

 ;(format   t "~% *****  ------ FIN    ADD TP  ------------- ~%")
 consistent
 );;fin let*
);;fin defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se encarga del calculo de recursos en caso que se haya introducido en (run) el parametro :include-resources
;;
;; Parametros: el operador que se va a annadir. Se debe incluir aunque luego se borre si no es consistente. 
;;
;; Devuelve:   la consistencia
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun Calculate-resource-relation (op )
 (let* ((lista-res nil)
	  (consistent nil)
       )

  ;(format   t "~% ***** CALCULAR relaciones entre RECURSOS    ------------- ~%")
  ;;annadido para la gestion de recursos 8/2/2003
  (push op user::*list-TPop*)  ; Lo annado aqui, y si no es consitente lo borro ya q si no, no considera el op. con los recursos
  ;;;; VERSION PARA CADA ACTIVIDAD TIENE UN MODELO DE RECURSOS
  ;;;;(setq lista-res (COMMON-LISP-USER::resource-reasoning user::*rete* 1 user::*num* t))

  ;;;; VERSION DONDE SE DEFINEN RECURSOS SEGUN OBJETOS DEL DOMINIO 
  (setq lista-res (COMMON-LISP-USER::resource-reasoning-SIN user::*rete* 1 user::*num* ))
  ;(format t"Despues de Llamar a RESOURCE last-op-consistence = ~d" user::*last-op-consistence*) ;(read t)
  (if user::*last-op-consistence*  ;;(si hay links entre actividades con recursos)
	 (progn
	    (if (> (length lista-res) 0)
  		      (progn
     	 	         (dolist (lik lista-res) 
				;(format t"~%Se annade a la red los links = ~d ~d~%" (user::TimePoint-end-id (user::link-id1 lik)) (user::TimePoint-start-id (user::link-id2 lik))) ;(read t)
	    	             (COMMON-LISP-USER::relate_tp_id user::*rete* (user::TimePoint-end-id (user::link-id1 lik)) (user::TimePoint-start-id (user::link-id2 lik))     (user::link-min lik)(user::link-max lik))
	  	           );;fin del dolist

		       );;fin del progn
           );;fin if longitud
	     (setq consistent (COMMON-LISP-USER::propagate-AC user::*rete*)) 
	     (if (not (equal consistent nil))
		    (progn
	 	          ;(format t "Se han annadido los links entre recursos y es consistente")
                       ;(COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num* )
			     ;(push op user::*list-TPop*) ;Se annade si tambien es consistente en recursos
		           (COMMON-LISP-USER::save-solution user::*rete*) 
			     (if (> (length lista-res) 0)
				  (progn
			           ;(format t "~%Hay Links entre operadores debido a los RECURSOS, se annaden")
		 	           (setf (user::TimePoint-links-res op) lista-res)
				     (dolist (ll lista-res)
			               (push ll  user::*list-links-res*)
					)
				  );;fin progn
 		             ;(format t "~%NO SE AADEN POR RECURSOS")
			     )
          		);;fin del progn
	        );;fin del if
 	  );;fin de progn
	  (progn
	          ;(format t "~%Despues de llamar a resource-reasoning es inconsistente")
		    (setq consistent nil)
		    (pop user::*list-Tpop*)
	  );;fin progn es inconsistente
     );;fin if
  ;(format   t "~% ***** FIN CALCULAR relaciones entre RECURSOS    ------------- ~%")


  consistent
 );;fin del let*
);;fin defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se encarga de restaurar la rete, la lista de operadores y links si Prodigy hace backtracking.
;;
;; Parametros: si el operador se ha annadido (es consistente), el numero de 
;;             veces que se debe restaurar (hacer backtraking hasta llegar a un estado a salvo).
;;	 	   Por defecto siempre se restaura una vez y el fichero (por defecto la pantalla).
;; Devuelve:   nada
;;
;; Seria conveniente pasarle o el operador o la consitencia. Puede que al annadir la rete diga
;; que no es consistente
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun restore-rete-state (&optional (cont 1))
 (let* ((op nil)
	  (links nil)
	  (links-res nil)
	 )

  ;;(format t"~% ------ restore-rete-state------------- ~% ~d~%" cont)
  ;;(format t"~%Long Links= ~d~% Links= ~d"  (length user::*list-links*) user::*list-links*)
  ;(COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num* )  ;;(read t)

  (if (not (equal user::*list-links* nil)) ; se ha annadido el ultimo operador a la rete. NO hace falta, se controla en la parte de Prodigy
     (progn
       (loop for b from  1 to cont do
   ;       ;(format t"~% ------ restore-rete-state---------Visualizamos ---- ~% b= ~d~%" b)
	     (pop user::*lista-de-estados*)  ; Elimino el ultimo estado global
	     (setq op (pop user::*list-TPop*)) ; Elimino el operador annadido
           (COMMON-LISP-USER::restore-solution user::*rete*)   ; Restaura la rete 
          ; (COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num* t ) 
	     (setq  links (user::TimePoint-links-added op)) ; Elimino los links de la lista de links
	     (loop for n from 1 to (length links) do
	        (pop user::*list-links*)
           );;fin del loop

	     ;;En caso de recursos -------------- MD Marzo 2003
	     (setq  links-res (user::TimePoint-links-res op)) ; Elimino los links de recursos del operador
		;(format t "~%El op = ~d tiene los links-resources = ~d~%" op links-res) 
	     (loop for n from 1 to (length links-res) do
	        (pop user::*list-links-res*)
           );;fin del loop
	 
         (if user::*Resorce-Consumed* 
		(progn
		  (decf  (aref (user::RESOURCE-times  user::*Resorce-Consumed*) (- (user::TimePoint-id-domain op) 1)  ))
		  ;(format t "~%Se decrementa en una unidad")
	      )
	   )

	 );;fin del loop
       (if (not (equal cont 0))
	    (progn
             ;;(format t "~% ------RESTAURAMOS 1 ---- ~d ~%" cont)
             (COMMON-LISP-USER::restore-solution user::*rete*)   ; Restaura la rete
  		 (COMMON-LISP-USER::save-solution user::*rete*)  ;salvamos de nuevo el ultimo estado
           );;fin progn
	    ;;(format t"~%el cont ES CERO = ~d" cont)
        );;fin del if
     );;fin del progn
    ;;(format t"~%La lista de links esta vacia!!!~%")
  );;fin del if

  ;(format t "~%~%The resource links between operators are .....................~%~%~d~%" user::*list-links-res*)

 ;;(format t"~%Lista de operadores despues de eliminar = ~d ***********" user::*list-TPop*)
 ;;(format t"~%La lista de links	 (push op user::*list-TPop*) es = ~d~%" user::*list-links*)
; (COMMON-LISP-USER::write-dcs-for-prodigy user::*rete* 1 user::*num* )


;;(format t"~%  ------ FIN    restore-rete-state  ------------- ~%")
 );;fin de let*
);fin de la funcion 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se encarga de crear la rete para un unico operador.
;;
;; Parametros: ninguno
;; Devuelve:   si es o no consistente la red temporal.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#|
(defun one-operator( ) ;&optional (stream  t))
 (let* ((SOP (car list-op))
	  (op  (cadr list-op))           
	  (FOP (caddr list-op))           
	  (list-op nil)   
	  (consistent nil)
       )
 
   ;(format t "~%**************** inicio  one-operator  ****************~%")
   ;(format t "~%Lista de ops(lo que me pasan) =  ~a~%" user::*list-TPs*)
   ;(format t  "~%FOP = ~a El OPERADOR= ~d SOP = ~d " FOP op SOP)

  
   (push  (user::TimePoint-adds SOP) user::*lista-de-estados*) 
   ;(format t "~%Estamos con un solo operador Adds= ~d" (user::TimePoint-adds SOP))
   (push SOP list-op)
   ;(format t"~%Mi estado actual = ~d ........~%" user::*lista-de-estados*)	    
   (setf (user::TimePoint-state SOP) (user::TimePoint-adds SOP)) 
   (setf (user::TimePoint-links-added SOP) nil)	   
 
   (setq consistent (CALCULATE-LINKS op list-op )) 

;  Si no es consistente --> tu llamaras backtracking, y volveras a hacer la llamada
;  (setq consistent (CALCULATE-LINKS nuevo-op list-op )) 

   (if (not (equal consistent nil))
  	  (progn
	     ;(format t"~%La lista de oper ANTES del ultimo= ~d" user::*list-TPop*) 
	     ;(format t "~%Estados = ~d ~%" user::*lista-de-estados*)
	     (push op list-op)
	     (CALCULATE-LINKS FOP list-op t )
        );;fin del progn
	  ;(format t "~%No es consistente el operador que me pasan!!!~%")
   );;fin del if
   consistent 
 );;fin del let*
);;fin de defun

|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se encarga de calcular los links con las metas (o el operador Final).
;;
;; Parametros: el operador
;; Devuelve:   el link entre el operador y la(s) metas o nil si no hay ninguno.
;; Se podria pensar en quitar (es decir la transitividad) pero en los grafos dara igual y el buscar el link puede llevar
;; bastante gasto computacional.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun links-goals (t_op  ); &optional (stream  t))
 (let* ((metas  (user::TimePoint-preconds user::*Final*))
        (adds-op  (user::TimePoint-adds t_op))  ;adds
	  ;(link nil)
	  (condit nil)
	  (lt nil)
       )
 
    ;(format t"~%**************** links-goals****************~%")
 	   ;(format t "~% Metas = ~d op = ~d~% adds del op= ~d" metas t_op adds-op)
    	   (setq condit  (intersection adds-op metas :test #'equal)) 
           ;(format t"~%La interseccion es: = ~d" condit)
           (if (not (equal condit nil))  
	     (progn
	         ;(format t"~%Hay un link con el ultimo") 
		 (setq lt   (user::make-link  :id1  t_op 
					      :condition condit 
					      :id2  user::*Final*
						:min user::*Min-Dist-Ops*
						:max user::*Max-Dist-Ops*)
		  )
		 (push lt user::*list-goal*)
		 ;(format t"~%Link annadido= ~d ~% a lista total" lt user::*list-goal* condit)
		 ;(setf (user::TimePoint-preconds user::*Final*) (set-difference metas  condit :test #'equal)) 
             ;(format t"~%Las  metas que quedan son = ~d" (user::TimePoint-preconds user::*Final*))  
	     );;fin progn
             ;(format t"~%No hay links con este operador")
           );;fin if    
    ;(format t"~%**************** FIN links-goals****************~%") 
   lt
 );;fin let*
 );;fin defun
