(in-package "USER")

(defun execute-ff (&optional (directory *ff-output-directory*) &key (file-prefix "test*"))
  (let ((filename nil)
	(output-file (concatenate 'string directory "ff-output.lisp")))
    (with-open-file (ostream output-file
		     :direction :output :if-exists :supersede
		     :if-does-not-exist :create))
    (dolist (file (directory (format nil "~a~a" directory file-prefix)))
      (setq filename (concatenate 'string (pathname-name file) ".pddl"))
      (with-open-file (ostream output-file
		       :direction :output :if-exists :append
		       :if-does-not-exist :create)
	(format ostream "~%(~a" filename))
      (run-shell-command (concatenate 'string "/home/dborrajo/planning/Metric-FF/ff -p " 
				      directory " -o domain.pddl -f " filename
 				      " | grep \"\\([0-9]\\+: \\|total time\\|egmentation\\|FALSE\\|step\\)\""
 				      "| sed -e \"s/ff: goal can be simplified to FALSE. No plan will solve it/ nil/\""
  				      "| sed -e \"s/step $/ ((*finish*/\""
				      "| sed -e \"s/step[ ]\\+0:/ ((/\""
				      "| sed -e \"s/[0-9]\\+:/)(/\" "
				      "| sed -e \"s/\\([0-9]\\+.[0-9]\\+\\) seconds total time/)) \\1/\""
 				      ">> " directory "ff-output.lisp"
				      )
			 :wait t)
      (with-open-file (ostream output-file
		       :direction :output :if-exists :append
		       :if-does-not-exist :create)
	(format ostream ")")))))
;;  | tail -n 2 -
;;  "t[-_0-9a-zA-Z]*.pddl"

;; It returns the list of number of solved problems by FF under a given time-limit
(defun count-solved-ff-problems (&key (ff-results-file (concatenate 'string *ff-output-directory* "ff-output.lisp"))
				      (time-limit 15))
  (with-open-file (istream ff-results-file :direction :input)
    (do* ((problem (read istream nil 'eof)
		   (read istream nil 'eof))
	  (endp (eq problem 'eof) (eq problem 'eof))
	  (solvedp (and (not endp) (listp (cdr problem)))
		   (and (not endp) (listp (cdr problem))))
	  (time (and solvedp (nth 2 problem))
		(and solvedp (nth 2 problem)))
	  (number-solved (if (and time (<= time time-limit)) 1 0)
			 (if (and time (<= time time-limit))
			     (1+ number-solved)
			   number-solved)))
	(endp number-solved))))

;; It returns the list of solutions generated by FF under a given time-limit
(defun solutions-ff (&key (ff-results-file (concatenate 'string *ff-output-directory* "ff-output.lisp"))
			  (time-limit most-positive-fixnum))
  (with-open-file (istream ff-results-file :direction :input)
    (do* ((problem (read istream nil 'eof)
		   (read istream nil 'eof))
	  (endp (eq problem 'eof) (eq problem 'eof))
	  (solvedp (and (not endp) (listp (cdr problem)))
		   (and (not endp) (listp (cdr problem))))
	  (time (and solvedp (nth 2 problem))
		(and solvedp (nth 2 problem)))
	  (solutions (if (and time (<= time time-limit))
			 (list (nth 1 problem)))
		     (if (and time (<= time time-limit))
			 (cons (nth 1 problem) solutions)
		       solutions)))
	(endp (nreverse solutions)))))
