;; AUTOR: Francisco Javier Garcia Polo

;; Este fichero define las funciones necesarias para el cambio de idioma
;; de la interfaz.

;; Devuelve una tabla hash en la cual las claves corresponden a los nombres
;; de etiquetas o botones sin traducir y las entradas para esas claves corresponden
;; a los elementos traducidos.
(defun load-languages ()
  (with-open-file (fd (format nil "~aes.po" *pltool-interface-dir*) :direction :input)
   
    (do ((item (read-line fd nil 'eof) (read-line fd nil 'eof))
	 (table (make-hash-table :test 'equal))
	 (item-aux nil)
	 (i 0))
        ((eql item 'eof)
	 (return table))
	(progn
	  (if (valid-line item)
	    	(progn
	  	  (if (eq (mod i 2) 0)
	    		(setf item-aux item)
	    		(setf (gethash item-aux table) item)
	  	  )
	  	  (setf i (+ i 1)))))
    )
  )
)

;; Comprueba que la linea que se le pasa como parametro sea una linea valida.
;; Para que una linea se considere valida no debe ser un comentario o una linea
;; de longitud 0.
(defun valid-line (line)
  (not (or (eq (search "#" line) 0) (eq (length line) 0))))

