(in-package "USER")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Comentarios por David Montero ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;----------------------------------------------------------------------------------
;; Carga el paquete xmls que se encuentra en la carpeta xmls-1.2 desde 
;; el directorio de la interfaz y lo compila en el mismo directorio    
;;----------------------------------------------------------------------------------
#+unix
(load-and-compile (list "xmls")
		  :load-path (format nil "~axmls-1.2/" *pltool-interface-dir*)
		  :compile-path (format nil "~axmls-1.2/" *pltool-interface-dir*)
		  :re-load-p nil)
#+win32
#(load "xmls")


;;----------------------------------------------------------------------------------
;; Carga el paquete gtk y gtk-glade que se encuentra en el directorio  
;; de la interfaz y los compila en el mismo directorio                  
;;----------------------------------------------------------------------------------

(load-and-compile (list "gtk")
		  :load-path *pltool-interface-dir*
		  :compile-path *pltool-interface-dir*
		  :re-load-p nil)
(load-and-compile (list "gtk-glade")
		  :load-path *pltool-interface-dir*
		  :compile-path *pltool-interface-dir*
		  :re-load-p nil)

(use-package :gtk)

; (g_thread_init nil)
; (gdk_threads_init)


;;----------------------------------------------------------------------------------
;; Se inicializa gtk                          
;;----------------------------------------------------------------------------------

(gtk_init nil nil)

;;----------------------------------------------------------------------------------
;; Se carga el estilo de la aplicacion                     
;;----------------------------------------------------------------------------------

(gtk_rc_parse (format nil "~arc" *pltool-interface-dir*))

; (gdk_threads_enter)


;;----------------------------------------------------------------------------------
;; Si el lenguaje de instalacion es el español se cargan las etiquetas 
;; en español                                                          
;;----------------------------------------------------------------------------------

;;;;;;;;;;;;;;;;; Inicio: Francisco Javier Garcia Polo ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(load (format nil "~alanguage.lisp" *pltool-interface-dir*))

(setf traduction-table nil)
(if (eq *language* 'es)
	(setf traduction-table (load-languages))
)

;;;;;;;;;;;;;;;; Fin: Francisco Javier Garcia Polo ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;----------------------------------------------------------------------------------
;; la primera sentencia almacena en inp el parseo del archivo pltool.glade
;; la seguna sentencia guarda en widgets una tabla hash con los widgets existentes 
;; en inp con la tabla de traduccion pasada
;;----------------------------------------------------------------------------------
(let ((inp (with-open-file (p (format nil "~apltool.glade" *pltool-interface-dir*))
	     :direction :input
	     (xmls:parse p))))
  (setf widgets (gtk-glade:glade-parse inp traduction-table)))


;;----------------------------------------------------------------------------------
;; Carga el paquete callbacks que se encuentra en el directorio de la  
;; interfaz y lo compila en el mismo directorio                        
;;----------------------------------------------------------------------------------

(load-and-compile (list "callbacks")
		  :load-path *pltool-interface-dir*
		  :compile-path *pltool-interface-dir*
		  :re-load-p nil)


;;----------------------------------------------------------------------------------
;; Carga el paquete tree que se encuentra en el directorio de la       
;; interfaz y lo compila en el mismo directorio                        
;;----------------------------------------------------------------------------------

(load-and-compile (list "tree")
		  :load-path *pltool-interface-dir*
		  :compile-path *pltool-interface-dir*
		  :re-load-p nil)

  
;; Inicialization of hamlet variables
(setf *never-repeat-p* nil)
(setf *repeat-problem-p* nil)
(setf *repeat-probset-p* nil)

;; From what I have seen it converges in less than 4 cycles...
(setf *max-number-probset-repeats* 4)
(setf *max-number-cycles* 6)

;; For active learning
;; (setf *default-parameters-alist* (list (cons 'fixed-goal 'at)))
;; (setf *types-info*  '((object 5 5) (city 4 4) (plane 1)))
(setf *number-training-problems* 100)
(setf *re-refine-p* t)

;; (setf *lisp-extension* "lisp")
;; (setf *stop-after-problem-p* t)
;; (setf *print-utility-p* t)
;; (setf *utilityp* t)
(setf *utility-threshold* 0)
(setf *state-threshold* 1)
(setf *re-use-prior-goal-p* nil)

;; Interface initialization
;; window v1-w-lr
(gtk_widget_set_sensitive (gethash "cost-bound-entry" widgets) 0)
;; window v1-w-ipss
(gtk_widget_set_sensitive (gethash "IPSScost-bound-entry" widgets) 0)
;;
(gtk_widget_reparent (gethash "fixed-v1-ipss" widgets) (gethash "fixed-ppal" widgets))
(gtk_widget_reparent (gethash "fixed-v1-lr" widgets) (gethash "fixed-ppal" widgets))
(gtk_widget_reparent (gethash "fixed-v1-lm" widgets) (gethash "fixed-ppal" widgets))
(gtk_widget_reparent (gethash "fixed-v1-trans" widgets) (gethash "fixed-ppal" widgets))

(gtk_widget_show_all (gethash "window-ppal" widgets))

(initialize-v1-w-ipss)

(gtk_main)

; (gdk_threads_leave)
