;;****************************************************************************************************
;; This file contains functions to show trees
;; Raquel 05/2005
;;****************************************************************************************************

;;-----------------------------------------------------------------------------------------------
;; Functions to create and show a tree representation of the Hamlet learned rules 
;;-----------------------------------------------------------------------------------------------
(defun show-rules-tree ()
  (declare (special widgets))  
  (let ((window (gethash "scrolledwindow-rules" widgets))
	(rules-view-exists *rules-view*))
    (create_view_and_model_rules)
    (if  (not rules-view-exists)
	 (gtk_container_add window *rules-view*))
    (gtk_widget_show_all (gethash "V3-RULES" widgets))
    ))

;; (defun show-rules-tree ()
;; (setq window (gethash "scrolledwindow-rules" widgets))
;; (if *rules-view*
;;   (progn (gtk_container_remove window *rules-view*)
;;          (gtk_widget_destroy *rules-view*)))
;; (setf *rules-view* (create_view_and_model_rules))
;; ;;(gtk_container_add window view)
;; (gtk_container_add window view)
;; (gtk_widget_show_all (gethash "V3-RULES" widgets))
;; ;(gtk_widget_reparent (gethash "vbox-rules" widgets) (gethash "hbox-results" widgets))
;; ;(show-window "vbox-rules")
;; 
;; )



;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------
(defun create_view_and_model_rules ()
(let ((col)
      (renderer))
;;   (setq view (gtk_tree_view_new))
;; 
;; ;;  /* --- Column #1 --- */
;; 
;;   (setq col (gtk_tree_view_column_new))
;; 
;;   (gtk_tree_view_column_set_title col "Learned Control Rules")
;; 
;;   (setq renderer (gtk_cell_renderer_text_new))
;; 
;; 
;;   (g_object_set renderer "editable" 1 nil)
;;   (g_object_set renderer "editable-set" 1 nil)
;;   (gtk_connect renderer "edited" (lambda (&rest args) (funcall #'cell_edited_callback renderer view args)))
;; 
;;   (gtk_tree_view_column_pack_start col renderer 1)
;; 
;;   (gtk_tree_view_column_add_attribute col renderer "text" 0)
;; ;;  /* pack tree view column into tree view */
;; 
;;  
;;   (gtk_tree_view_append_column view col)
  (if *rules-model*
      (gtk_tree_view_set_model *rules-view* nil))
  
  (if (not *rules-view*)
      (progn
	(setf *rules-view* (gtk_tree_view_new))
	
	;;  /* --- Column #1 --- */

	(setq col (gtk_tree_view_column_new))
	
	(gtk_tree_view_column_set_title col "Learned Control Rules")
	
	
  
	(setq renderer (gtk_cell_renderer_text_new))
	(g_object_set renderer "editable" 1 nil)
	(g_object_set renderer "editable-set" 1 nil)
	(gtk_connect renderer "edited" (lambda (&rest args) (funcall #'cell_edited_callback renderer *rules-view* args)))
	(gtk_tree_view_column_pack_start col renderer 1)
	(gtk_tree_view_column_add_attribute col renderer "text" 0)
	
	;;  /* pack tree view column into tree view */
	(gtk_tree_view_append_column *rules-view* col)
	(gtk_connect *rules-view* "button_press_event" (let ((code (read-from-string "(button_press_event)")))
							 (lambda (&rest args) (eval code))))
	(gtk_tree_selection_set_mode (gtk_tree_view_get_selection *rules-view*) 1)))
  ;;                              GTK_SELECTION_SINGLE)
  
  ;;  /* set 'cell-background' property of the cell renderer */
  ;;  (g_object_set renderer
  ;;               "cell-background" "Yellow"
  ;;               "cell-background-set" TRUE
  ;;               NULL)
  

  (setf *rules-model* (create_and_fill_model_rules))
    
;;   (gtk_tree_view_set_model view *rules-model*)
  (gtk_tree_view_set_model *rules-view* *rules-model*)
  ;;   (gtk_connect *rules-view* "button_press_event" (let ((code (read-from-string "(button_press_event)")))
  ;;                                              (lambda (&rest args) (eval code))))
  (gtk_tree_selection_set_mode (gtk_tree_view_get_selection *rules-view*) 1)
  ;;                              GTK_SELECTION_SINGLE)

;; /* destroy model automatically with view */
  (g_object_unref *rules-model*)

 *rules-view*
))
;; ;  (gtk_tree_selection_set_mode (gtk_tree_view_get_selection view) 0)
;; ;;                              GTK_SELECTION_NONE)
;;  (gtk_connect view "button_press_event" (let ((code (read-from-string "(button_press_event)")))
;;                                                (lambda (&rest args) (eval code)))) 
;;   view

;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------
(defun create_and_fill_model_rules ()
(let ((toplevel)
      (child)
      (subchild)
      (treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64))) ))

(declare (type GtkTreeIter toplevel))
(declare (type GtkTreeIter child))
(declare (type GtkTreeIter subchild))

 
;; antes *cr-list*
(dolist (cr *rules*)
    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0 (format nil "~(~a~)" (p4::control-rule-name cr)) -1)

  (setq child (gtk_tree_store_append treestore toplevel))
  (gtk_tree_store_set treestore child 0 "IF" -1)
  (dolist (precond (cdr (p4::control-rule-if cr)))
      (setq subchild (gtk_tree_store_append treestore child))
      (gtk_tree_store_set treestore subchild 0  (format nil "~(~a~)" precond) -1))
  
  (setq child (gtk_tree_store_append treestore toplevel))

  (gtk_tree_store_set treestore child 0 "THEN" -1)
  

  (setq subchild (gtk_tree_store_append treestore child))
  (gtk_tree_store_set treestore subchild 0 (format nil "~(~a~)" (p4::control-rule-then cr)) -1))

 treestore
))

;;---------------------------------------------------------------------------------------------------------------
;; Functions to create and show the plan tree (trace of the IPSS planification process) 
;;---------------------------------------------------------------------------------------------------------------


(defun show-plan-tree-inic ()
(declare (special widgets))
(let ((max-depth (read-from-string (gtk_entry_get_text (gethash "TPspinbutton-max-depth" widgets))))
      (problem-number (read-from-string (gtk_entry_get_text (gethash "TPspinbutton-problem-number" widgets))))
      (tree-with-rules *real-t-tree*)
      (tree-without-rules *old-tree*))
;(gtk_button_released (gethash "button-ipss-see-search-tree" widgets))
(hide-window "v1-tree-params")
;; to search the tree that corresponds to the problem number

(if (and *store-plans-p* *all-trees*)
    (let ((real-number-of-problems (/ (length *all-trees*) 2))
          (all-trees-in-order (reverse *all-trees*)))
      
         (if (<= problem-number real-number-of-problems)
           (progn (setq tree-without-rules (nth (- (* 2 problem-number) 1) all-trees-in-order))
                  (setq tree-with-rules (nth (- (* 2 problem-number) 2) all-trees-in-order)))
           ;; else error: problem doesn't exist
           (interface-trace t "problem doesn't exist"))))
;; to choose the window that corresponds (window for old-tree or window for real-tree)
(if (= 1 (gtk_toggle_button_get_active (gethash "TPcheckbutton-tree-without-rules" widgets)))
  ;; show tree-without-rules

    (show-plan-tree-without-rules  :tree tree-without-rules
                                   :best-child-info-p  (= 1 (gtk_toggle_button_get_active (gethash "TPcheckbutton-best-child-info" widgets))) 
                                   :only-success-path-p  (= 1 (gtk_toggle_button_get_active (gethash "TPcheckbutton-only-success-path" widgets)))
                                   :only-tried-p (= 1 (gtk_toggle_button_get_active (gethash  "TPcheckbutton-only-tried" widgets))) 
                                   :max-depth  max-depth)

    (show-plan-tree-with-rules     :tree tree-with-rules
                                   :best-child-info-p (= 1 (gtk_toggle_button_get_active (gethash "TPcheckbutton-best-child-info" widgets))) 
                                   :only-success-path-p  (= 1 (gtk_toggle_button_get_active (gethash "TPcheckbutton-only-success-path" widgets)))
                                   :only-tried-p (= 1 (gtk_toggle_button_get_active (gethash  "TPcheckbutton-only-tried" widgets)))  
                                   :max-depth  max-depth))))




(defun show-plan-tree-without-rules (&key  (tree *old-tree*)
                                    (best-child-info-p nil)
                                    (only-success-path-p t)
                                    (only-tried-p t)
                                    (max-depth 100))
(declare (special widgets))
(let ((window (gethash "scrolledwindow-tree-without-rules" widgets)))
(if *tree-view-without-rules*
  (progn (gtk_container_remove window *tree-view-without-rules*)
         (interface-trace t "destroying tree view without rules")
         (gtk_widget_destroy *tree-view-without-rules*)))

(if tree
   (setf *tree-view-without-rules* (create_view_and_model_plan_tree tree 
                                                   best-child-info-p
	                                          only-success-path-p 
                                                   only-tried-p
                                                   max-depth))
  (setf *tree-view-without-rules* nil))

(if *tree-view-without-rules*
  (progn
   (gtk_container_add window *tree-view-without-rules*)
   (gtk_tree_view_expand_all *tree-view-without-rules*)
;;(gtk_widget_reparent (gethash "vbox-tree" widgets) (gethash "hbox-results" widgets))
   (gtk_widget_show_all (gethash "V2-SEARCH-TREE-WITHOUT-RULES" widgets)))
  (error-dialog nil "Tree without rules has not been created")) 

;;(show-window "vbox-tree")
))

(defun show-plan-tree-with-rules (&key  (tree *real-t-tree*)
                                    (best-child-info-p nil)
                                    (only-success-path-p t)
                                    (only-tried-p t)
              		         (max-depth 100))
(declare (special widgets))
(let ((window (gethash "scrolledwindow-tree-with-rules" widgets)))
(if *tree-view-with-rules*
  (progn (gtk_container_remove window *tree-view-with-rules*)
         (interface-trace t "destroying tree view with rules")
         (gtk_widget_destroy *tree-view-with-rules*)))
(setf *tree-view-with-rules* (create_view_and_model_plan_tree tree 
                                                   best-child-info-p
	                                          only-success-path-p 
                                                   only-tried-p
                                                   max-depth))

(gtk_container_add window *tree-view-with-rules*)
(gtk_tree_view_expand_all *tree-view-with-rules*)
;;(gtk_widget_reparent (gethash "vbox-tree" widgets) (gethash "hbox-results" widgets))
(gtk_widget_show_all (gethash "V2-SEARCH-TREE-WITH-RULES" widgets))
;;(show-window "vbox-tree")
))


;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------
(defun create_view_and_model_plan_tree (tree 
                                        best-child-info-p
	                               only-success-path-p 
                                        only-tried-p
                       		     max-depth)
(let ((view (gtk_tree_view_new))
      (col (gtk_tree_view_column_new))
      (renderer (gtk_cell_renderer_text_new))
      (model))

  (gtk_tree_view_column_set_title col "Plan Tree")
  
  (gtk_tree_view_column_pack_start col renderer 1)
  
  (gtk_tree_view_column_add_attribute col renderer "markup" 0)

;;  /* pack tree view column into tree view */
  (gtk_tree_view_append_column view col)

;;  /* set 'cell-background' property of the cell renderer */
;;  (g_object_set renderer
;;               "cell-background" "Yellow"
;;               "cell-background-set" TRUE
;;               NULL)

  (setq model (create_and_fill_model_plan_tree  tree 
                                                best-child-info-p
                                                only-success-path-p
		                              only-tried-p
                         		            max-depth))
  
  (gtk_tree_view_set_model view model)

;; /* destroy model automatically with view */
  (g_object_unref model)

;  (gtk_tree_selection_set_mode (gtk_tree_view_get_selection view) 0)
;;                              GTK_SELECTION_NONE)

  view))

;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------
(defun create_and_fill_model_plan_tree (tree 
                                        best-child-info-p
                                        only-success-path-p
		                      only-tried-p
                         	             max-depth)

(let ((treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64)))))

;;----------------------inicio parte david montero--------------------------------------------------------------------------
      (setq *estructura-arbol2* nil)
      (setq *estructura-arbol3* nil)
;;----------------------fin parte david montero-----------------------------------------------------------------------------

(if tree
 
   (create_and_fill_model_plan_tree_aux   best-child-info-p only-success-path-p only-tried-p
                                          treestore nil                           
               		       	      tree max-depth))
;;(print "muestro el arbol")
;;(print *estructura-arbol3*)

treestore)
)


;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------
;; treestore is the tree store
;; parent is the node at the parent level
(defun create_and_fill_model_plan_tree_aux (best-child-info-p only-success-path-p only-tried-p
                                            treestore parent-tree                           
               			        &optional (tree (find-node 2))
				        (max-depth 100)
                                           (depth -1))

  (let ((learning-type (if (eq (node-learning-type tree) 'success) 's 'f))
	(type (node-type tree))
	(params-list "")
	(best-child-info (node-best-child-info tree))
         (fired-crs (mapcar #'(lambda (l) (p4::control-rule-name (car l)))
                            (node-fired-crs tree)))
	(child-tree)
	(child-tree2)
;;---------------------------variable para la parte de david montero--------------------------
	(aux nil)
	(aux2 nil)
	)
 (declare (type GtkTreeIter child-tree))
 (declare (type GtkTreeIter child-tree2))

;; (interface-trace t "interface-trace: only-tried ~a" only-tried-p)
    (setq child-tree (gtk_tree_store_append treestore parent-tree))
    (cond (best-child-info-p
               (gtk_tree_store_set treestore child-tree 0 
                    (concatenate 'string
                              (if (eq learning-type 's) 
                                  (format nil "<span foreground=~s>" "darkgreen")  
                                  (format nil "<span foreground=~s>" "red"))
                              (format nil (output-string2 type) (node-info tree type)
                   		   "") 
                              (format nil "~a ~(~a~)"
			      (p4::nexus-name tree)
		                (cons (mapcar #'(lambda (best-child)
				                    (node-info best-child
						         (node-type best-child)))
				              (car best-child-info))
			              (caddr best-child-info)))
                              (format nil "</span>")

                              (if fired-crs
		               (concatenate 'string
                                    (format nil "<span foreground=~s>" "blue")  
                                    (format nil "       Fired rules ~a" fired-crs )
                                    (format nil "</span>"))
                                    (format nil ""))) -1)

;;-------------------------------------------------inicio parte david montero-----------------------------------------------

;;------------------------------------------------para almacenarlo en HTML--------------------------------------
(setq *estructura-arbol2* (append *estructura-arbol2* (list (append (list depth) (list (concatenate 'string
                              (if (eq learning-type 's) 
                                  (format nil "<font color=~a>" "green")  
                                  (format nil "<font color=~a>" "red"))
                              (format nil (output-string2 type) (node-info tree type)
                   		   "") 
                              (format nil "~a ~(~a~)"
			      (p4::nexus-name tree)
		                (cons (mapcar #'(lambda (best-child)
				                    (node-info best-child
						         (node-type best-child)))
				              (car best-child-info))
			              (caddr best-child-info)))
                              (format nil "</font>")

                              (if fired-crs
		               (concatenate 'string
                                    (format nil "<font color=~a>" "blue")  
                                    (format nil "       Fired rules ~a" fired-crs )
                                    (format nil "</font>"))
                                    (format nil ""))))))))


;;------------------------------------------------para almacenarlo en XML---------------------------------------------
(setq *estructura-arbol3* (append *estructura-arbol3* (list (append (list depth) (list 
                              (if (eq learning-type 's) 
                                  'ex  
                                  'er)
			      type
			      (concatenate 'string
                              (format nil (output-string2 type) (node-info tree type)
                   		   "") 
                              (format nil "~a ~(~a~)"
			      (p4::nexus-name tree)
		                (cons (mapcar #'(lambda (best-child)
				                    (node-info best-child
						         (node-type best-child)))
				              (car best-child-info))
			              (caddr best-child-info)))
                              ;;(format nil "</font>")

;;************parte de las reglas que tengo que mirar**********************
                              (if fired-crs
		               (concatenate 'string
                                    (format nil "<font color=~a>" "blue")  
                                    (format nil "       Fired rules ~a" fired-crs )
                                    ;;(format nil "</font>")
)
                                    (format nil ""))))))))

;;-------------------------------------------------fin parte david montero-----------------------------------------------

)

	  (t   (gtk_tree_store_set treestore child-tree 0 
                      (concatenate 'string
                            (if (eq learning-type 's) 
                                  (format nil "<span foreground=~s>" "darkgreen") 
                                  (format nil "<span foreground=~s>" "red"))

							(if (eq type 'applied-op-node)
			   					  (progn 
			   					  	(dolist (param (p4::instantiated-op-values (p4::a-or-b-node-instantiated-op tree)))
								  		(setf params-list (concatenate 'string params-list (string (p4::prodigy-object-name param)) " ")))
								  	(format nil "~a ~a ~a" (node-info tree type) params-list (p4::nexus-name tree))
								  )
								  (format nil (output-string2 type) (node-info tree type) (p4::nexus-name tree))
							)

                            (format nil " ~(~a~)" (caddr best-child-info))
                            (format nil "</span>")
                            (if fired-crs
                                   (concatenate 'string 
                                     (format nil "<span foreground=~s>" "blue")  
                                     (format nil "       Fired rules: ~a" fired-crs)
                                     (format nil "</span>"))
                                    (format nil ""))) -1)


;;-------------------------------------------------inicio parte david montero-----------------------------------------------

;;------------------------------------------------para almacenarlo en HTML--------------------------------------
(setq *estructura-arbol2* (append *estructura-arbol2* (list (append (list depth) (list (concatenate 'string
                            (if (eq learning-type 's) 
                                  (format nil "<font color=~a>" "green") 
                                  (format nil "<font color=~a>" "red"))

							(if (eq type 'applied-op-node)
			   					  (progn 
			   					 (format nil "~a ~a ~a" (node-info tree type) params-list (p4::nexus-name tree)) )
								  (format nil (output-string2 type) (node-info tree type) (p4::nexus-name tree)))

                            (format nil " ~(~a~)" (caddr best-child-info))
                            (format nil "</font>")
                            (if fired-crs
                                   (concatenate 'string 
                                     (format nil "<font color=~a>" "blue")  
                                     (format nil "       Fired rules: ~a" fired-crs)
			            (format nil "</font>")
				)
                                    (format nil ""))))))))




;;------------------------------------------------para almacenarlo en XML---------------------------------------------
(setq *estructura-arbol3* (append *estructura-arbol3* (list (append (list depth) (list 
                           (if (eq learning-type 's) 
                                  'ex 
                                  'er)
				 type
				 (concatenate 'string
							(if (eq type 'applied-op-node)
			   					  (progn 
			   					 	(format nil "~a ~a ~a" (node-info tree type) params-list (p4::nexus-name tree)))
							  (format nil (output-string2 type) (node-info tree type) (p4::nexus-name tree)))

                           (format nil " ~(~a~)" (caddr best-child-info))
                            ;;(format nil "</font>")

;;parte de las reglas que debo mirar
                            (if fired-crs
                                   (concatenate 'string 
                                    (format nil "<font color=~a>" "blue")  
                                     (format nil "       Fired rules: ~a" fired-crs)
			            ;;(format nil "</font>")
				)
                                    (format nil ""))))))))






;;-------------------------------------------------fin parte david montero-----------------------------------------------

           
	))
    (when (or (not only-success-path-p) (eq learning-type 's))
      ;; the reverse is to print in the expansion order
      (dolist (child (reverse (p4::nexus-children tree)))
	(if (< depth max-depth)
                 (create_and_fill_model_plan_tree_aux best-child-info-p only-success-path-p only-tried-p
        	  treestore child-tree child max-depth (1+ depth)))
	(if (not only-tried-p)
	  (progn  
	    (interface-trace t "interface-trace: not only tried")
	    (case type

	      (goal-node
	       (dolist (other (p4::goal-node-ops-left tree))
                 (setq child-tree2 (gtk_tree_store_append treestore child-tree))
		 
	         (gtk_tree_store_set treestore child-tree2 0
	     (format nil (output-string2 (node-type other)) (p4::operator-name other) "untried")-1)

;;-------------------------------------------------inicio parte david montero-----------------------------------------------

		;;(setf *estructura-arbol2* (append *estructura-arbol2* (list (format nil (output-string2 (node-type other)) (p4::operator-name other) "untried"))))))
(setf aux (append aux (list (format nil (output-string2 (node-type other)) (p4::operator-name other) "untried"))))
(setf aux2 (append aux2 (list (format nil (output-string3 (node-type other)) type (p4::operator-name other) "untried"))))
))

		;;(print )))

;;-------------------------------------------------fin parte david montero-----------------------------------------------


	      ((binding-node applied-op-node)
	       (dolist (other (p4::a-or-b-node-applicable-ops-left tree))
                 (setq child-tree2 (gtk_tree_store_append treestore child-tree))
	         (gtk_tree_store_set treestore child-tree2 0
                    (format nil  (output-string2 (node-type other))  (get-applicable-op other) "untried") -1)

;;-------------------------------------------------inicio parte david montero-----------------------------------------------
		;;(setf *estructura-arbol2* (append *estructura-arbol2* (list (format nil (output-string2 (node-type other)) (get-applicable-op other) "untried")))))
(setf aux (append aux (list (format nil (output-string2 (node-type other)) (get-applicable-op other) "untried"))))
(setf aux2 (append aux2 (list (format nil (output-string3 (node-type other)) type (get-applicable-op other) "untried"))))
)
		;;(print *estructura-arbol2*))
;;-------------------------------------------------fin parte david montero-----------------------------------------------

	       (dolist (other (p4::a-or-b-node-goals-left tree))
                 (setq child-tree2 (gtk_tree_store_append treestore child-tree))
       	         (gtk_tree_store_set treestore child-tree2 0
     		     (format nil  (output-string2 (node-type other)) (get-visible-form other) "untried") -1)

;;-------------------------------------------------inicio parte david montero-----------------------------------------------
		;;(setf *estructura-arbol2* (append *estructura-arbol2* (list (format nil (output-string2 (node-type other)) (get-visible-form other) "untried"))))))
(setf aux (append aux (list (format nil (output-string2 (node-type other)) (get-visible-form other) "untried"))))
(setf aux2 (append aux2 (list (format nil (output-string3 (node-type other)) type (get-visible-form other) "untried"))))
))
		;;(print *estructura-arbol2*)))
;;-------------------------------------------------fin parte david montero-----------------------------------------------


	      (operator-node 
	       (dolist (other (p4::operator-node-bindings-left tree))
                 (setq child-tree2 (gtk_tree_store_append treestore child-tree))
		 
		 (setf params-list "")
		 (dolist (param (p4::instantiated-op-values other))
		   (setf params-list (concatenate 'string params-list (string (p4::prodigy-object-name param)) " "))
		   )
      	         (gtk_tree_store_set treestore child-tree2 0
		   (concatenate 'string (format nil "~a " (p4::operator-name (p4::instantiated-op-op other)))
				(format nil "~a" params-list)
				(format nil "untried")) -1)

;;-------------------------------------------------inicio parte david montero-----------------------------------------------
		;;(setf *estructura-arbol2* (append *estructura-arbol2* (list (format nil "~a ~a ~a" (p4::operator-name (p4::instantiated-op-op other)) params-list "untried"))))))
(setf aux (append aux (list (format nil "~a ~a ~a" (p4::operator-name (p4::instantiated-op-op other)) params-list "untried"))))
(setf aux2 (append aux2 (list (format nil "~a ~a ~a ~a" type (p4::operator-name (p4::instantiated-op-op other)) params-list "untried"))))
))

		;;(print *estructura-arbol2*)))(setq *estructura-arbol2* (append *estructura-arbol2* (list aux)
;;-------------------------------------------------fin parte david montero-----------------------------------------------

	      (t
	       (dolist (other (p4::goal-node-ops-left tree))
                 (setq child-tree2 (gtk_tree_store_append treestore child-tree))
      	         (gtk_tree_store_set treestore child-tree2 0
                    (format nil  (output-string2 (node-type other)) (p4::operator-name other) "untried") -1)


;;-------------------------------------------------inicio parte david montero-----------------------------------------------
	;;	(setf *estructura-arbol2* (append *estructura-arbol2* (list (format nil  (output-string2 (node-type other)) (p4::operator-name other) "untried"))))
(setf aux (append aux (list (format nil  (output-string2 (node-type other)) (p4::operator-name other) "untried"))))
(setf aux2 (append aux2 (list (format nil (output-string3 (node-type other)) type (p4::operator-name other) "untried"))))
;;-------------------------------------------------fin parte david montero-----------------------------------------------


)))))) 

;;(print "muestro aux2")
;;(print aux2)
(if (not (null aux))(setq *estructura-arbol2* (append *estructura-arbol2* (list aux))))
(if (not (null aux2))(setq *estructura-arbol3* (append *estructura-arbol3* (list aux2))))

;;(print "muestro estructura-arbol3")
;;(print *estructura-arbol3*)
)

			 
child-tree))

(defun output-string2 (type)
  (if (eq type 'applied-op-node)
      (format nil "~t~~a ~~(~~a~~)")
      (format nil "~t~~(~~a ~~a~~)")))
    

(defun output-string3 (type)
  (if (eq type 'applied-op-node)
      (format nil "~t~~a ~~a ~~(~~a~~)")
      (format nil "~t~~a ~~(~~a ~~a~~)")))

;;-----------------------------------------------------------------------------------------------
;; Functions to create and show a tree representation of the Hamlet plans 
;;-----------------------------------------------------------------------------------------------
(defun show-plans ()
(declare (special widgets))
(if *si-solucion*
	(let ((window (gethash "scrolledwindow-plans" widgets)) )
  		(if *plans-view*
		      (progn (gtk_container_remove window *plans-view*)
			     (gtk_widget_destroy *plans-view*)))
	        (setf *plans-view* (create_view_and_model_plans))
		;;(gtk_container_add window view)

	        (gtk_container_add window *plans-view*)
		(gtk_widget_show_all (gethash "V4-PLANS" widgets))
		;(gtk_widget_reparent (gethash "vbox-rules" widgets) (gethash "hbox-results" widgets))(" (holding blockb) untried4") 
		;(show-window "vbox-rules")
	)
	(if (eq *language* 'es)
		(information-dialog nil (format nil "No existen planes a mostrar"))
		(information-dialog nil (format nil "There aren't plans to show")))
))



;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------
(defun create_view_and_model_plans ()
(let ((view (gtk_tree_view_new))
      (col (gtk_tree_view_column_new))
      (renderer (gtk_cell_renderer_text_new))
      (model))

  (gtk_tree_view_column_set_title col "Plans")

  (gtk_tree_view_column_pack_start col renderer 1)
  
  (gtk_tree_view_column_add_attribute col renderer "text" 0)

;;  /* pack tree view column into tree view */
  (gtk_tree_view_append_column view col)

;;  /* set 'cell-background' property of the cell renderer */
;;  (g_object_set renderer
;;               "cell-background" "Yellow"
;;               "cell-background-set" TRUE
;;               NULL)

 (if (eq *planner* 'LPG)
	 	  (setq model (lpg_create_and_fill_model_plans)) 0)


 (if (eq *planner* 'METRIC-FF)
	 	  (setq model (metric_create_and_fill_model_plans)) 0)

 (if (eq *planner* 'SGPLAN)
	 	  (setq model (sgplan_create_and_fill_model_plans)) 0)

 (if (eq *planner* 'SAYPHI)
  	  (setq model (say_create_and_fill_model_plans)) 0)
	
  (if (eq *planner* 'IPSS)
  	  (setq model (create_and_fill_model_plans)) 0)
	
  (gtk_tree_view_set_model view model)

;; /* destroy model automatically with view */
  (g_object_unref model)

;  (gtk_tree_selection_set_mode (gtk_tree_view_get_selection view) 0)
;;                              GTK_SELECTION_NONE)

  view
))

;; --------------------------------------------------------------------------------------------
;; Funcion que genera los planes en IPSS y los muestra por pantalla
;; --------------------------------------------------------------------------------------------
(defun create_and_fill_model_plans ()
(let ((toplevel)
      (child)
      (subchild)
      (plans)

;;variables auxiliares para la parte de David Montero
      (auxiliar-planes)
      (auxiliar-plan)
      (aux)

      (plans-all-problems (if *store-plans-p*
                         (nreverse *all-solutions*)
                        (list (pp-solution :list-format-p t :stream nil :all-solutions-p t)))) 

      (problem-counter 0)             
      (plan-counter 0)
      (treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64)))))

(declare (type GtkTreeIter toplevel))
(declare (type GtkTreeIter child))
(declare (type GtkTreeIter subchild))

(dolist (plans-one-problem plans-all-problems)
  ;; se almacena en plans las solucion al problema plans-one-problem
  (setq plans  (if *store-plans-p*
                      (pp-problem-solution plans-one-problem :list-format-p t :stream nil :all-solutions-p t)
                      plans-one-problem))

  (setq problem-counter (1+ problem-counter))       
  (setq plan-counter 0)
  (setq toplevel (gtk_tree_store_append treestore nil))
  (gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "Problem" problem-counter)  -1)
  
  (dolist (plan plans)
    (setq plan-counter (1+ plan-counter))
    (setq child (gtk_tree_store_append treestore toplevel))
    (gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Plan" plan-counter)  -1)

    (setq auxiliar-plan nil)   
    (dolist (step plan)
       (setq subchild (gtk_tree_store_append treestore child))
       (gtk_tree_store_set treestore subchild 0  (format nil "~a" step) -1)

;;-------------------------------inicio david montero-------------------------------
       (setq auxiliar-plan (append auxiliar-plan (list step))))

    (setq aux (format nil "~a ~a" "Plan" plan-counter))
    (setq auxiliar-plan (append (list aux) auxiliar-plan))

    (setq auxiliar-planes (append auxiliar-planes (list auxiliar-plan))))
  (setq aux nil)
  (setq aux (format nil "~a ~a" "Problem" problem-counter))
  (setq auxiliar-planes (append (list aux) auxiliar-planes)))

  ;;(print (format nil "comparacion~%"))
  ;;(print auxiliar-planes)
;;-------------------------------fin david montero----------------------------------
  
 (if (not *store-plans-p*)
  (progn 
    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0  (format nil "Total time: ~a" (user::prodigy-result-time *prodigy-result*)) -1)
     
    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0 (format nil "Total nodes: ~a" (user::prodigy-result-nodes *prodigy-result*))  -1)
  
    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0 (format nil "Best cost: ~a" *best-cost*)  -1)

;;-------------------------------inicio david montero-------------------------------
    ;;(setq aux (format nil "Total time: ~a" (user::prodigy-result-time *prodigy-result*)))
    (setq aux (list 0 (user::prodigy-result-time *prodigy-result*)))
    (setq auxiliar-plan nil)
    (setq auxiliar-plan (append auxiliar-plan (list aux)))
    ;;(setq aux (format nil "Total nodes: ~a" (user::prodigy-result-nodes *prodigy-result*)))
    (setq aux (list 1 (user::prodigy-result-nodes *prodigy-result*)))
    (setq auxiliar-plan (append auxiliar-plan (list aux)))
    ;;(setq aux (format nil "Best cost: ~a" *best-cost*))
    (setq aux (list 2 *best-cost*))
    (setq auxiliar-plan (append auxiliar-plan (list aux)))

    (setq *estructura-arbol* (append (list auxiliar-planes) (list auxiliar-plan)))))
;;-------------------------------fin david montero----------------------------------
 	
    ;;(print *estructura-arbol*)
 treestore
))

;;----------------------------------------------------------------------------------------------------
;; Funcion que genera y muestra el plan generado con SAYPHI
;;----------------------------------------------------------------------------------------------------
(defun say_create_and_fill_model_plans ()
(let ((toplevel)
      (child)
      (subchild)
      (plans)

;;variables auxiliares para la parte de David Montero
      (auxiliar-planes)
      (auxiliar-plan)
      (aux)


      (objects (problem-inheritobjects *current-problem*))
      (planaction-counter 1)

      (plans-all-problems (if *store-plans-p*
                         (nreverse *all-solutions*)
                        (list (pp-solution :list-format-p t :stream nil :all-solutions-p t)))) 
	
      (problem-counter 0)             
      (plan-counter 0)
      (treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64)))))
  
(declare (type GtkTreeIter toplevel))
(declare (type GtkTreeIter child))
(declare (type GtkTreeIter subchild))
(print *current-problem*)
(setq toplevel (gtk_tree_store_append treestore nil))
(gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "Problem" problem-counter)  -1)


(setq child (gtk_tree_store_append treestore toplevel))
(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Plan" plan-counter)  -1)

	(dolist (i-node (solution-path *say-solution*) *say-solution*)
	     (let ((plan-action (snode-applied-action i-node)))
	       
	       ;(format t "~%     ~d: ~a ~a" planaction-counter (car plan-action)
		;       (instance-plan-action plan-action objects))
		
		(setq subchild (gtk_tree_store_append treestore child))
       			(gtk_tree_store_set treestore subchild 0  (format nil "~d: ~a ~a" planaction-counter (car (gaction-planaction plan-action)) (cdr (gaction-planaction plan-action))) -1)
					
;;-------------------------------inicio david montero-------------------------------
       	        (setq auxiliar-plan (append auxiliar-plan (list (append (list (car (gaction-planaction plan-action))) (cdr (gaction-planaction plan-action))))))
;;-------------------------------fin david montero----------------------------------

	       (incf planaction-counter)))


;;-------------------------------inicio david montero-------------------------------	
    (setq aux (format nil "~a ~a" "Plan" plan-counter))
    (setq auxiliar-plan (append (list aux) auxiliar-plan))

    (setq aux nil)
    (setq aux (format nil "~a ~a" "Problem" problem-counter))
    (setq auxiliar-planes (append (list aux) (list auxiliar-plan)))
;;-------------------------------fin david montero----------------------------------



;(dolist (plans-one-problem plans-all-problems)
;  (setq plans  (if *store-plans-p*
;                      (pp-problem-solution plans-one-problem :list-format-p t :stream nil :all-solutions-p t)
;                      plans-one-problem))

;  (setq problem-counter (1+ problem-counter))       
 ; (setq plan-counter 0)
  ;(setq toplevel (gtk_tree_store_append treestore nil))
;  (gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "problem" problem-counter)  -1)
  
 ; (dolist (plan plans)
  ;  (setq plan-counter (1+ plan-counter))
   ; (setq child (gtk_tree_store_append treestore toplevel))
    ;(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "plan" plan-counter)  -1)
   
    ;(dolist (step plan)
     ;  (setq subchild (gtk_tree_store_append treestore child))
      ; (gtk_tree_store_set treestore subchild 0  (format nil "~a" step) -1))))
  
 (if (not *store-plans-p*)
  (progn 
    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0  (format nil "Total time: ~a" (solution-total-time *say-solution*)) -1)
    
    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0 (format nil "Total nodes: ~a" (solution-num-nodes *say-solution*))  -1)

    (setq toplevel (gtk_tree_store_append treestore nil))
    (gtk_tree_store_set treestore toplevel 0 (format nil "Plan length: ~a" (- planaction-counter 1))  -1)


;;-------------------------------inicio david montero-------------------------------
    ;;(setq aux (format nil "Total time: ~a" (solution-total-time *say-solution*)))
    (setq aux (list 0 (solution-total-time *say-solution*)))
    (setq auxiliar-plan nil)
    (setq auxiliar-plan (append auxiliar-plan (list aux)))
    ;;(setq aux (format nil "Total nodes: ~a" (solution-num-nodes *say-solution*)))
    (setq aux (list 1 (solution-num-nodes *say-solution*)))
    (setq auxiliar-plan (append auxiliar-plan (list aux)))
    (setq aux (list 3 (- planaction-counter 1)))

    (setq auxiliar-plan (append auxiliar-plan (list aux)))
	

    (setq *estructura-arbol* (append (list auxiliar-planes) (list auxiliar-plan)))))
;;-------------------------------fin david montero----------------------------------

 treestore
))

;;----------------------------------------------------------------------------------------------------
;; Funcion que genera y muestra el plan generado con LPG
;;----------------------------------------------------------------------------------------------------
(defun lpg_create_and_fill_model_plans ()
(let ((toplevel)
      (child)
      (subchild)
      (plans)
      (contenido)

;;variables auxiliares para la parte de David Montero
      (auxiliar-planes)
      (auxiliar-plan)
      (aux)

      (planaction-counter 1)
      (bestplanaction-counter -1)
      (best-length -1)

      (problem-counter 0)             
      (plan-counter 1)
      (treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64)))))

(declare (type GtkTreeIter toplevel))
(declare (type GtkTreeIter child))
(declare (type GtkTreeIter subchild))
(setf *estructura-arbol* nil)

      (setf contenido (file-to-string "lpg-output.lisp" *my-lpg-pathname*))
      (setf contenido (read-from-string contenido))
      ;;(setf contenido (list contenido))
     (print (format nil  "el contenido 4 es: ~d ~%" (length contenido))) 
      (print contenido)



(progn

	(setq toplevel (gtk_tree_store_append treestore nil))
	(gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "Problem" problem-counter)  -1)


(dolist (plan1 contenido)
	(setq child (gtk_tree_store_append treestore toplevel))
		(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Plan" plan-counter)  -1)

	(dolist (plan (car plan1))
     		(let ()
	       
			(setq subchild (gtk_tree_store_append treestore child))
			(gtk_tree_store_set treestore subchild 0  (format nil "~d: ~a ~a" planaction-counter (car plan) (cdr plan)) -1)
					
;;-------------------------------inicio david montero-------------------------------
        		(setq auxiliar-plan (append auxiliar-plan (list (append (list (car plan)) (cdr plan)))))
;;-------------------------------fin david montero----------------------------------
	       		(incf planaction-counter)))

        (setq aux (format nil "~a ~a" "Plan" plan-counter))
	(setq auxiliar-plan (append (list aux) auxiliar-plan))

	(if (= 1 plan-counter)		
		(progn
		    (setq aux nil)
	    	    (setq aux (format nil "~a ~a" "Problem" problem-counter))
	 	    (setq auxiliar-planes (append (list aux) (list auxiliar-plan)))
	        )
	)


	(progn 

	    (setq child (gtk_tree_store_append treestore toplevel))
	    (gtk_tree_store_set treestore child 0  (format nil "Total time: ~a" (car (cdr plan1))) -1)

	    (setq child (gtk_tree_store_append treestore toplevel))
	    (gtk_tree_store_set treestore child 0  (format nil "Plan cost: ~a" (car (last (cdr plan1)))) -1)
    
	    (setq child (gtk_tree_store_append treestore toplevel))
	    (gtk_tree_store_set treestore child 0 (format nil "Plan Length: ~a" (- planaction-counter 1))  -1)

	    (setq aux (list 0 (car (cdr plan1))))
	    (setq auxiliar-plan nil)
	    (setq auxiliar-plan (append auxiliar-plan (list aux)))
	    (setq aux (list 4 (car (last (cdr plan1)))))
	    (setq auxiliar-plan (append auxiliar-plan (list aux)))
	    (setq aux (list 3 (- planaction-counter 1)))
	    (setq auxiliar-plan (append auxiliar-plan (list aux)))

;;-------------------------------inicio david montero-------------------------------

    	    (setq *estructura-arbol* (append *estructura-arbol* (list auxiliar-planes) (list auxiliar-plan))))
;;-------------------------------fin david montero----------------------------------

	(if (or (< bestplanaction-counter 0) (< planaction-counter bestplanaction-counter))
		(setf bestplanaction-counter planaction-counter)
	)

	(setf plan-counter (+ plan-counter 1))
	(setf planaction-counter 1)	
)
	(setq child (gtk_tree_store_append treestore nil))
	(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Total time:" (car (cdr (car (last contenido)))))  -1)

	(setq child (gtk_tree_store_append treestore nil))
        (gtk_tree_store_set treestore child 0  (format nil "Best Plan cost: ~a" (car (last (cdr (car (last contenido)))))) -1)

	(setq child (gtk_tree_store_append treestore nil))
	(gtk_tree_store_set treestore child 0 (format nil "Best Plan Length: ~a" (- bestplanaction-counter 1))  -1)



)

 treestore
))



;;----------------------------------------------------------------------------------------------------
;; Funcion que genera y muestra el plan generado con METRIC-FF
;;----------------------------------------------------------------------------------------------------
(defun metric_create_and_fill_model_plans ()
(let ((toplevel)
      (child)
      (subchild)
      (plans)
      (contenido)

;;variables auxiliares para la parte de David Montero
      (auxiliar-planes)
      (auxiliar-plan)
      (aux)

      (planaction-counter 1)
      (bestplanaction-counter -1)

      (problem-counter 0)             
      (plan-counter 1)
      (treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64)))))

(declare (type GtkTreeIter toplevel))
(declare (type GtkTreeIter child))
(declare (type GtkTreeIter subchild))
(setf *estructura-arbol* nil)

      (setf contenido (file-to-string "ff-output2.lisp" *my-metricff-pathname*))
      (setf contenido (read-from-string contenido))
      ;;(setf contenido (list contenido))
     (print (format nil  "el contenido 4 es: ~d ~%" (length contenido))) 
      (print contenido)

(if (= 1 (length contenido))
(progn
	(setq toplevel (gtk_tree_store_append treestore nil))
	(gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "Problem" problem-counter)  -1)

	(setq child (gtk_tree_store_append treestore toplevel))
	(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Plan" plan-counter)  -1)

	(dolist (plan (car (car contenido)))
	     (let ()
	       
	       (format t "~%     ~d: ~a ~a" planaction-counter (car plan)
		       (cdr plan))
		
		(setq subchild (gtk_tree_store_append treestore child))
       			(gtk_tree_store_set treestore subchild 0  (format nil "~d: ~a ~a" planaction-counter (car plan) (cdr plan)) -1)
					
;;-------------------------------inicio david montero-------------------------------
       	        (setq auxiliar-plan (append auxiliar-plan (list (append (list (car plan)) (cdr plan)))))
;;-------------------------------fin david montero----------------------------------

	       (incf planaction-counter)))


;;-------------------------------inicio david montero-------------------------------	
    (setq aux (format nil "~a ~a" "Plan" plan-counter))
    (setq auxiliar-plan (append (list aux) auxiliar-plan))

    (setq aux nil)
    (setq aux (format nil "~a ~a" "Problem" problem-counter))
    (setq auxiliar-planes (append (list aux) (list auxiliar-plan)))
;;-------------------------------fin david montero----------------------------------


	  (progn 

		    (setq toplevel (gtk_tree_store_append treestore nil))
		    (gtk_tree_store_set treestore toplevel 0  (format nil "Total time: ~a" (car (cdr (car contenido)))) -1)

		    (setq toplevel (gtk_tree_store_append treestore nil))
		    (gtk_tree_store_set treestore toplevel 0  (format nil "Plan cost: ~a" (car (last (cdr (car contenido))))) -1)
    
		    (setq toplevel (gtk_tree_store_append treestore nil))
		    (gtk_tree_store_set treestore toplevel 0 (format nil "Plan Length: ~a" (- planaction-counter 1))  -1)

		    (setq aux (list 0 (car (cdr (car contenido)))))
		    (setq auxiliar-plan nil)
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))
		    (setq aux (list 4 (car (last (cdr (car contenido))))))
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))
		    (setq aux (list 3 (- planaction-counter 1)))
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))

;;-------------------------------inicio david montero-------------------------------

    (setq *estructura-arbol* (append (list auxiliar-planes) (list auxiliar-plan))))
;;-------------------------------fin david montero----------------------------------
)
(progn

	(setq toplevel (gtk_tree_store_append treestore nil))
	(gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "Problem" problem-counter)  -1)


(dolist (plan1 contenido)
	(if (> plan-counter (- (length contenido) 2))
		;; se almacenan los resultados globales
		(progn
		    (if (< plan-counter (length contenido))
				(progn
				    (setq toplevel (gtk_tree_store_append treestore nil))
				    (gtk_tree_store_set treestore toplevel 0  (format nil "Total time: ~a" plan1) -1)	
				)
				(progn
				    (setq toplevel (gtk_tree_store_append treestore nil))
				    (gtk_tree_store_set treestore toplevel 0  (format nil "Best Plan cost: ~a" plan1) -1)
    
				    (setq toplevel (gtk_tree_store_append treestore nil))
				    (gtk_tree_store_set treestore toplevel 0 (format nil "Best Plan Length: ~a" (- bestplanaction-counter 1))  -1)
				)
		     )
		    (setf plan-counter (+ plan-counter 1))
		)
		(progn

		(setq child (gtk_tree_store_append treestore toplevel))
		(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Plan" plan-counter)  -1)


		(dolist (plan (car plan1))
	     		(let ()
	       
				(setq subchild (gtk_tree_store_append treestore child))
       				(gtk_tree_store_set treestore subchild 0  (format nil "~d: ~a ~a" planaction-counter (car plan) (cdr plan)) -1)
					
;;-------------------------------inicio david montero-------------------------------
       	        		(setq auxiliar-plan (append auxiliar-plan (list (append (list (car plan)) (cdr plan)))))
;;-------------------------------fin david montero----------------------------------
	        		(incf planaction-counter)))

;;-------------------------------inicio david montero-------------------------------	
		    (setq aux (format nil "~a ~a" "Plan" plan-counter))
		    (setq auxiliar-plan (append (list aux) auxiliar-plan))

		    (if (= 1 plan-counter)		
			(progn
			    (setq aux nil)
		    	    (setq aux (format nil "~a ~a" "Problem" problem-counter))
	 	 	    (setq auxiliar-planes (append (list aux) (list auxiliar-plan)))
			)
		    )
	
;;-------------------------------fin david montero----------------------------------

	  	(progn 

		    (setq child (gtk_tree_store_append treestore toplevel))
		    (gtk_tree_store_set treestore child 0  (format nil "Total time: ~a" (car (cdr plan1))) -1)

		    (setq child (gtk_tree_store_append treestore toplevel))
		    (gtk_tree_store_set treestore child 0  (format nil "Plan cost: ~a" (car (last (cdr plan1)))) -1)
    
		    (setq child (gtk_tree_store_append treestore toplevel))
		    (gtk_tree_store_set treestore child 0 (format nil "Plan Length: ~a" (- planaction-counter 1))  -1)

		    (setq aux (list 0 (car (cdr plan1))))
		    (setq auxiliar-plan nil)
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))
		    (setq aux (list 4 (car (last (cdr plan1)))))
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))
		    (setq aux (list 3 (- planaction-counter 1)))
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))

;;-------------------------------inicio david montero-------------------------------

    (setq *estructura-arbol* (append *estructura-arbol* (list auxiliar-planes) (list auxiliar-plan))))
;;-------------------------------fin david montero----------------------------------

		(if (or (< bestplanaction-counter 0) (< planaction-counter bestplanaction-counter))
			(setf bestplanaction-counter planaction-counter)
		)

		)
	)
	(setf plan-counter (+ plan-counter 1))
	(setf planaction-counter 1)	
)



)

)

 treestore
))



;;----------------------------------------------------------------------------------------------------
;; Funcion que genera y muestra el plan generado con SGPLAN
;;----------------------------------------------------------------------------------------------------
(defun sgplan_create_and_fill_model_plans ()
(let ((toplevel)
      (child)
      (subchild)
      (plans)
      (contenido)

;;variables auxiliares para la parte de David Montero
      (auxiliar-planes)
      (auxiliar-plan)
      (aux)

      (planaction-counter 1)
      (bestplanaction-counter -1)

      (problem-counter 0)             
      (plan-counter 1)
      (treestore (gtk_tree_store_newv 1  (make-array '1 :initial-contents '(64)))))

(declare (type GtkTreeIter toplevel))
(declare (type GtkTreeIter child))
(declare (type GtkTreeIter subchild))
(setf *estructura-arbol* nil)

      (setf contenido (file-to-string "sgplan-output2.lisp" *my-sgplan-pathname*))
      (setf contenido (read-from-string contenido))
      (print (format nil  "el contenido 4 es: ~d ~%" (length contenido))) 
      (print contenido)

(progn
	(setq toplevel (gtk_tree_store_append treestore nil))
	(gtk_tree_store_set treestore toplevel 0 (format nil "~a ~a" "Problem" problem-counter)  -1)

	(setq child (gtk_tree_store_append treestore toplevel))
	(gtk_tree_store_set treestore child 0 (format nil "~a ~a" "Plan" plan-counter)  -1)

	(dolist (plan (car (last contenido)))
	     (let ()
	       
	       (format t "~%     ~d: ~a ~a" planaction-counter (car plan)
		       (cdr plan))
		
		(setq subchild (gtk_tree_store_append treestore child))
       			(gtk_tree_store_set treestore subchild 0  (format nil "~d: ~a ~a" planaction-counter (car plan) (cdr plan)) -1)
					
;;-------------------------------inicio david montero-------------------------------
       	        (setq auxiliar-plan (append auxiliar-plan (list (append (list (car plan)) (cdr plan)))))
;;-------------------------------fin david montero----------------------------------

	       (incf planaction-counter)))


;;-------------------------------inicio david montero-------------------------------	
    (setq aux (format nil "~a ~a" "Plan" plan-counter))
    (setq auxiliar-plan (append (list aux) auxiliar-plan))

    (setq aux nil)
    (setq aux (format nil "~a ~a" "Problem" problem-counter))
    (setq auxiliar-planes (append (list aux) (list auxiliar-plan)))
;;-------------------------------fin david montero----------------------------------

	  (progn 

		    (setq toplevel (gtk_tree_store_append treestore nil))
		    (gtk_tree_store_set treestore toplevel 0  (format nil "Total time: ~a" (car contenido)) -1)

		    (setq toplevel (gtk_tree_store_append treestore nil))
		    (gtk_tree_store_set treestore toplevel 0  (format nil "Plan cost: ~a" (nth 2 contenido)) -1)
    
		    (setq toplevel (gtk_tree_store_append treestore nil))
		    (gtk_tree_store_set treestore toplevel 0 (format nil "Plan Length: ~a" (nth 1 contenido))  -1)

		    (setq aux (list 0 (car contenido)))
		    (setq auxiliar-plan nil)
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))
		    (setq aux (list 4 (nth 2 contenido)))
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))
		    (setq aux (list 3 (nth 1 contenido)))
		    (setq auxiliar-plan (append auxiliar-plan (list aux)))

;;-------------------------------inicio david montero-------------------------------

    (setq *estructura-arbol* (append (list auxiliar-planes) (list auxiliar-plan))))
;;-------------------------------fin david montero----------------------------------
)

 treestore
))




;;----------------------------------------------------------------------------------------------------


(defun pp-problem-solution (problem-solutions &key (list-format-p nil) (stream t) (all-solutions-p nil)) 
  (let ((solutions (if all-solutions-p
                         problem-solutions
                         (car problem-solutions))))

  (cond (list-format-p (mapcar #'(lambda (solution)
				     (get-visible-solution solution))
				 solutions))
	  (t (terpri stream)
	     (dolist (solution solutions)
		 (pp-list (get-visible-solution solution) 1 stream)
	       (terpri stream))))))

;; --------------------------------------------------------------------------------------------
;; --------------------------------------------------------------------------------------------

(defun add_rule_data_in_tree (model iter caso)
  (interface-trace t "El valor es ~a~&" caso)
  
  (if (= caso 0)
      (progn
	(multiple-value-bind (iter) (gtk_tree_store_append model nil)
	  (progn
	    (gtk_tree_store_set model iter 0 "New Rule" -1)
	    (let ((iter2 iter))
	      (progn
		(multiple-value-bind (iter) (gtk_tree_store_append model iter)
		  (gtk_tree_store_set model iter 0 "IF" -1))
		(multiple-value-bind (iter2) (gtk_tree_store_append model iter2)
		  (gtk_tree_store_set model iter2 0 "THEN" -1)))))))
      (if (= caso 1)
	  (progn
	    (multiple-value-bind (iter) (gtk_tree_store_insert model iter 5000)
	      (progn
		(gtk_tree_store_set model iter 0 "(New Precondition)" -1))))
	  (multiple-value-bind (iter) (gtk_tree_store_insert model iter 5000)
	    (progn
	      (gtk_tree_store_set model iter 0 "(New Effect)" -1)))))

  0)



(defun add_rule_in_tree ()
  (let* ((selection(gtk_tree_view_get_selection *rules-view*))
         (result 0))

    (multiple-value-bind (result iter) (gtk_tree_selection_get_selected
					selection nil)  
      (if (not (= result 0))
	  (progn
	    (let ((path (gtk_tree_model_get_path *rules-model* iter)))
	      (multiple-value-bind (iter name)(gtk_tree_model_get *rules-model*
								  iter 0 -1)
		(progn 
		  (interface-trace t "selected row is: ~a~&" name)
		  (if (equal name "IF")
		      (add_rule_data_in_tree *rules-model* iter 1)
		      (if (equal name"THEN")
			  (add_rule_data_in_tree *rules-model* iter 2)
			  (progn
			    (multiple-value-bind (res parent)(gtk_tree_model_iter_parent
							      *rules-model* iter)
			      (if (= res 0)
				  (add_rule_data_in_tree *rules-model* iter 0)
				  (progn
				    ;;(g_free name)
				    (multiple-value-bind (parent name)(gtk_tree_model_get
								       *rules-model* parent 0 -1)
				      (progn
					(if (equal name "IF")
					    (add_rule_data_in_tree *rules-model* parent 1)
					    (add_rule_data_in_tree *rules-model* parent 2)
					    )
					)
				      )))
			      ))))
		  ;;(g_free name)
		  (multiple-value-bind (iter)(gtk_tree_model_row_changed
					      *rules-model* path))))))
	  (add_rule_data_in_tree *rules-model* iter 0))))

  0)

(defun add_rule (list)
  (add_rule_in_tree)
  (if *muestra-popup*
      (progn
	(gtk_widget_hide_on_delete *popup*)
	(gtk_list_unselect_all  list)
	(setf *muestra-popup* nil)))
  0)

(defun delete_rule_in_tree ()
  (let ((selection(gtk_tree_view_get_selection *rules-view*)))
    (multiple-value-bind (result iter) (gtk_tree_selection_get_selected selection nil)	
      (if (not (= result 0))
	  (progn
	    (let ((path (gtk_tree_model_get_path *rules-model* iter)))
	      (multiple-value-bind (iter name)(gtk_tree_model_get *rules-model* iter 0 -1)
		(progn 
		  (interface-trace t "selected row is: ~a~&" name)
		  (if (not(equal name "IF"))
		      (if (not(equal name"THEN"))
			  (multiple-value-bind (iter)(gtk_tree_store_remove *rules-model* iter))))
		  ;;(g_free name)
		  )))))))
  0)

(defun delete_rule (list)
  (delete_rule_in_tree)
  (if *muestra-popup*
      (progn
	(gtk_widget_hide_on_delete *popup*)
	(gtk_list_unselect_all  list)
	(setf *muestra-popup* nil)))
  0)


(defun button_press_event ()
  (interface-trace t "button_press~&")
  (multiple-value-bind (pp x y state) (gdk_window_get_pointer nil)
    (if (= state 1024)
	(progn
	  (interface-trace t "%Se pulso el boton derecho del raton~&")
	  ;;Creamos el ventanuco
	  (if  *popup*
	       (gtk_widget_hide_on_delete *popup*))
	  (if (not *popup*)
	      ;;Generamos realmente el ventanuco
	      (let ((window (gtk_window_new 1)) 
		    (list(gtk_list_new)) 
		    (item(gtk_list_item_new_with_label "Add"))
		    (item2(gtk_list_item_new_with_label "Delete")))
		(setf *popup* window)
		(setf *mouse-screen* window)
				   
		(gtk_widget_set_name window "my_window")
		(gtk_list_set_selection_mode list 1)
		(gtk_container_add list item)
		(gtk_connect item "select" (lambda (&rest args) (funcall #'add_rule list)))
				   
		(gtk_container_add list item2)
		(gtk_connect item2 "select" (lambda (&rest args) (funcall #'delete_rule list)))
				 				   
		(gtk_container_add window list)
		(gtk_window_set_position window 2)
		(setf *muestra-popup* 1)
		(gtk_widget_show_all *popup*))
	      (progn
		(setf *muestra-popup* 1)
		(gtk_window_set_position *popup* 2)
		(gtk_widget_show_all *popup*))))
	(if *muestra-popup*
	    (progn
	      (gtk_widget_hide_on_delete *popup*)
	      (setf *muestra-popup* nil)))))
			    
  0)



;;*********************************************************

(defun list_rules_tree (iter)
  (declare (special path))
  (declare (special tree_path_str))  
  (cond (iter
	 (multiple-value-bind (iter name) (gtk_tree_model_get *rules-model* iter 0 -1)
	   (setq path (gtk_tree_model_get_path *rules-model* iter))
	   (setq tree_path_str (gtk_tree_path_to_string path))
	   (interface-trace t "%selected row is ~a ~a~&" tree_path_str name)
	   (multiple-value-bind (res iter_child) (gtk_tree_model_iter_children *rules-model* iter)
	     (if (not (= res 0))
		 (list_rules_tree iter_child)))
	   (multiple-value-bind (res iter) (gtk_tree_model_iter_next *rules-model* iter)
	     (if (not(= res 0))
		 (list_rules_tree iter))))
	 )
	(t (multiple-value-bind (res iter) (gtk_tree_model_get_iter_first *rules-model*)
	     (if (not (zerop res))
		 (list_rules_tree iter)))))
  0)

;; --------------------------------------------------------------------------------------------
;; callback to prints the rules tree (modified or not) at a file with absolute path
;; --------------------------------------------------------------------------------------------

(defun save_rules_tree_with_dialog ()
 (let ((dialog-widget (gtk_file_selection_new)))
   (gtk_file_selection_set_filename dialog-widget (concatenate 'string *domain-directory* "my-rules.lisp"))
  (if (= (gtk_dialog_run dialog-widget) -5)
    (let ((file (gtk_file_selection_get_filename dialog-widget)))
      (save_rules_tree file)))
   (gtk_widget_destroy dialog-widget))
  
0)
 
;; --------------------------------------------------------------------------------------------
;; Function that prints the rules tree (modified or not) at a file with absolute path
;; --------------------------------------------------------------------------------------------
(defun save_rules_tree (filename)
  (with-open-file (stream filename :direction :output
				:if-exists :supersede
				:if-does-not-exist :create)
         (format stream "~2%;;; New control rules of problem ~a" *problem-name*)
         (format stream "~%(in-package \"USER\")")
         (save_rules_tree_to_stream stream)))

(defun save_rules_tree_to_stream (stream &optional (iter nil) (name-rule-p t) (precond-rule-p nil) (first-precond-p nil))
(declare (special path))
(declare (special tree_path_str))  
(let ((is-name name-rule-p)
      (is-precond precond-rule-p)
      (is-first-precond first-precond-p))
    (cond (iter
	   (multiple-value-bind (iter name) (gtk_tree_model_get *rules-model* iter 0 -1)
	     (setq path (gtk_tree_model_get_path *rules-model* iter))
              (setq tree_path_str (gtk_tree_path_to_string path))
         
              (cond ((equal name "IF") (setq is-name nil) (setq is-precond t) (setq is-first-precond t) 
                                       (format stream "~%  (if (and" ))
                  ((equal name "THEN") (setq is-precond nil) (format stream "))"))
                  (t  (if is-name 
                           (format stream "~2%(control-rule ~a" name) 
                           (if is-precond
                             (if is-first-precond
                                (progn  (format stream " ~(~a~)" name) (setq is-first-precond nil))
                                (format stream "~%           ~(~a~)" name))
                             ;; it is the effect
                             (if (and (= (length name) 4) (eq (caddr name) 'bindings))
                          	(format stream "~%  (~(~a ~a ~a~%        ~a~)))"
                   		(car name) (cadr name) (caddr name) (cadddr name))
                            	(format stream "~%~(~a~))" name)))))) 
            

	   (multiple-value-bind (res iter_child) (gtk_tree_model_iter_children *rules-model* iter)
	     (if (not (= res 0))
		 (save_rules_tree_to_stream stream iter_child is-name is-precond is-first-precond)))
	   (multiple-value-bind (res iter) (gtk_tree_model_iter_next *rules-model* iter)
	     (if (not(= res 0))
		 (save_rules_tree_to_stream stream iter is-name is-precond is-first-precond)))))
	(t (multiple-value-bind (res iter) (gtk_tree_model_get_iter_first *rules-model*)
	     (if (not (zerop res))
		 (save_rules_tree_to_stream stream iter is-name is-precond is-first-precond)))))
  0))


(defun cell_edited_callback (renderer view &rest args)
  (interface-trace t "cell_edited_callback")
  (let ((new-text (strcpy (third (car args)) (third (car args))))
	(selection (gtk_tree_view_get_selection view)))
    (multiple-value-bind (result iter) (gtk_tree_selection_get_selected selection nil)
      (if (not (= 0  result))
	  (multiple-value-bind (iter name) (gtk_tree_model_get *rules-model* iter 0 -1)
	    (interface-trace t "%selected row is ~a~&" name)
	    (if (not (or (equal name "IF") (equal name "THEN")))
		(gtk_tree_store_set *rules-model* iter 0 new-text  -1))
	    ))))
  (list_rules_tree nil)
  0)



;;(defun cell_edited_callback (renderer view &rest args)
;;  (print "cell_edited_callback")
;;  (setq new-text (strcpy (third (car args)) (third (car args))))
;;  (setq selection (gtk_tree_view_get_selection view))
;;  (multiple-value-bind (result iter) (gtk_tree_selection_get_selected selection nil)
;;    (if (not (= 0  result))
;;      (multiple-value-bind (iter name) (gtk_tree_model_get *rules-model* iter 0 -1)
;;		   (format t "%selected row is ~a~&" name)
;;		   (if (not (or (equal name "IF") (equal name "THEN")))
;;		       (gtk_tree_store_set *rules-model* iter 0 new-text  -1))
;;		   )))
;; (list_rules_tree nil)
;;0)


;;    g_print ("selected row is: %s\n", name);
;;    if((!strcmp(name,"IF"))||(!strcmp(name,"THEN"))){
;;       g_print("No se puede cambiar\n");
;;       g_free(name);
;;       return;
;;    }
;;    //Cambiamos el valor
;;    gtk_tree_store_set(GTK_TREE_STORE(model), &iter,;
;;		       column_number, new_text,
;;		       -1);
;;    g_free(name);
;;  }
;;    gtk_tree_model_foreach(model, foreach_func, NULL);
;;}
;; 0)
