;;; ----------------------------------------------------------------------------------
;;;   				TIME-MAP OUTPUT FUNCTIONS  
;;; 
;;; Esta archivo contiene las funciones para visualizar el estado de la red temporal. PARA QUE NO SE VISUALIZE NADA
;;;
;;;
;;;			 LAST MODIFICATION: Marzo 2003
;;;
;;; ----------------------------------------------------------------------------------

; (load "C:/Hamlet/integration/stp-new-2/output.lsp")


(in-package "COMMON-LISP-USER")
;(in-package "USER")

;;; ----------------------------------------------------------------------------------
;;;
;;;   Visualiza los arcos entre min-dc y max-dc
;;;
;;;
;;; ----------------------------------------------------------------------------------

(defun write-dcs (tm min-dc max-dc)
 
    (dolist (dc (time_map-list_dcs tm))
      
      (if (and (>= (car dc) min-dc) (<= (car dc) max-dc))
	  
          (format T  "~%DC-~D~3,8Tlb=~D~3,8Tub=~D~3,8TSTP=~D~3,8TETP=~D"
	             (car dc)
                     (edge-lb (cdr dc)) (edge-ub (cdr dc))
	             (time_point-name (edge-from (cdr dc)))
	             (time_point-name (edge-to (cdr dc))))
	(return T))
      )
  ) ;;; END *WRITE-DCS*

;;; ----------------------------------------------------------------------------------
;;;
;;;   Visualiza la rete entre los TP min-tp y max-tp
;;;
;;;
;;; ----------------------------------------------------------------------------------


(defun write-tps (tm min-tp max-tp)
  
  (let* ((min-index (max 1 min-tp))
         (max-index max-tp))
    
    (dolist (atp (time_map-list_tps tm))

      (if (and (>= (car atp) min-index) (<= (car atp) max-index))

	  (let ((tp (cdr atp)))
      
	    (format T  "~%TP-~D~3,8Tlb=~D~3,8Tub=~D~3,8TTDClb=~A~3,8TTDCub=~A~3,8TPU=~A~3,8TPL=~A"
		    
		    (time_point-name tp)
		    
		    (time_point-lb tp)
		    (time_point-ub tp)
		    
		    (time_point-st_edge_lb tp)    
		    (time_point-st_edge_ub tp)    
		    
		    (time_point-pu tp)
		    (time_point-pl tp))
	    )
	
	(return T)))
    )
  ) ;;; END *WRITE-TPS*

;;; ----------------------------------------------------------------------------------
;;;
;;;   Visualiza la rete entre los TP min-tp y max-tp (Como la otra pero comentada return T)
;;;
;;;
;;; ----------------------------------------------------------------------------------


(defun show-tps (tm min-tp max-tp)
  
  (let* ((min-index (max 1 min-tp))
         (max-index max-tp))
    
    (dolist (atp (time_map-list_tps tm))
      ;(format T "~%Dentro1")
      (if (and (>= (car atp) min-index) (<= (car atp) max-index))
        (progn
         ;(format T "~%Dentro2")
	  (let ((tp (cdr atp)))
       
       (format T "~a" (time_point-name tp))
	    (format T  "~%TP-~D~3,8Tlb=~D~3,8Tub=~D~3,8TTDClb=~A~3,8TTDCub=~A~3,8TPU=~A~3,8TPL=~A"
		    
		    (time_point-name tp)
		    
		    (time_point-lb tp)
		    (time_point-ub tp)
		    
		    (time_point-st_edge_lb tp)    
		    (time_point-st_edge_ub tp)    
		    
		    (time_point-pu tp)
		    (time_point-pl tp));fin del format
	    );fin del let
	    ;(return T)
	   );Fin del progn
	 ;(return T)
    
    	);fin del if
  	 );fin del dolist

   );fin del let
 ) ;;; END *SHOW-TPS*


;;; ----------------------------------------------------------------------------------
;;;
;;;   Visualiza los arcos entre min-dc y max-dc
;;;
;;;
;;; ----------------------------------------------------------------------------------

(defun write-dcs-for-prodigy (tm min-dc max-dc &optional (stream t))
 
    (dolist (dc (time_map-list_dcs tm))
      
      (if (and (>= (car dc) min-dc) (<= (car dc) max-dc))
	  
          (format stream  "~%DC-~D~3,8Tlb=~D~3,8Tub=~D~3,8TSTP=~D~3,8TETP=~D"
	             (car dc)
                   (edge-lb (cdr dc)) (edge-ub (cdr dc))
	             (time_point-name (edge-from (cdr dc)))
	             (time_point-name (edge-to (cdr dc))))
	(return T))
      )
  ) ;;; END *WRITE-DCS-FOR-PRODIGY*

;;; ----------------------------------------------------------------------------------
;;;
;;;   Visualiza la rete entre los TP min-tp y max-tp pero visualizando los nombres de los operadores
;;;   de Prodigy
;;;
;;;
;;; ----------------------------------------------------------------------------------

(defun write-tps-for-prodigy (tm min-tp max-tp)
  
  (let* ((min-index (max 1 min-tp))
         (max-index max-tp)
         (t-op nil)        ;TP actual
	   (op-name nil)
	   (make-sol nil)    ;Make-Span de la solucion actual
        );fin de la declaracion de variables
    
   ;;; (format stream  "~%id-TP ~T Operator-Name ~T~T~T~T Start-Time ~T End-Time~%~%");B
    (dolist (atp (time_map-list_tps tm))

      (if (and (>= (car atp) min-index) (<= (car atp) max-index))
         (progn          
	       (let ((tp (cdr atp))
	             (aux-list user::*list-TPop*)
	             (name-found nil) ;Flag para controlar la busqueda 
	            );fin del let
       
       ;;Se recorre la lista de TP's aux-list buscando el TP con = identificador que time_point-name tp
       ;;Se sacan elementos de la pila aux-list hasta que se encuentre
       (loop while (and (not (null aux-list)) (not name-found) )
           do            
            ;;Se saca
            (setq t-op (pop aux-list))
            ;;El identificador de la est.Time-point es = al de la estructur. TimePoint
            (cond ((equal (time_point-name tp) (user::TimePoint-start-id t-op)) 
                   ;(format stream  "~9a ~T" (user::TimePoint-id t-op)) ;B
		   (setq op-name (car(user::TimePoint-operator t-op)))
#|-------------------------------------------------------------------- Para que no visualice nada
		   (if (or (equal (user::TimePoint-start-id t-op) 1) (equal (user::TimePoint-start-id t-op) 2))
	              (format stream  "~9a ~T~T~T~T ~13a ~T ~10a~%"  op-name
					                (time_point-lb tp) (+ (time_point-lb tp) (user::TimePoint-duration-min t-op))) ;AL lb le he sumado la duracion min... si las duraciones varian no se si esto seria valido
	              (format stream  "~9a ~T~T~T~T ~13a ~T ~10a~%"  (user::get-applicable-op op-name)    ;CONVERTIRLO A UNA BUENA
					                (time_point-lb tp) (+ (time_point-lb tp) (user::TimePoint-duration-min t-op)))	      
                   );;fin del if

-------------------------------------------------------------|#

		   (setq  name-found t)  
		   (if (equal (user::TimePoint-start-id t-op) 2)
			  (progn
			     (setq make-sol (time_point-lb tp))
			     (if (> user::*DurationMax* make-sol)
					;(not (equal (p4::problem-space-property :make-span) nil)))
					(progn
		     			     (setf user::*DurationMax* make-sol)
		     			     (setf user::*MakeSpan* make-sol)
				        )
			    )
			    
			 );;fin del progn
		   );;fin del if
            
                ) ;fin del si el identificador es el mismo
                );fin del cond
              
		);fin del loop
		);fin del let
	
	     ;(return T)
	   );fin del progn
	  );fin del if
	 );fin del dolist

   );fin del let
  ) ;;; END *WRITE-TPS-FOR-PRODIGY*




;;; --------------------------------------------------------------------------------
;;;
;;; Funcion para visualizar cuando hay ciclos negativos utilizando el algoritmo B-F
;;;
;;; -------------------------------------------------------------------------------

(defun print-neg-cly-info (tm)

    (format T  "~%neg-cycle-lb=~A~%~%neg-cycle-ub=~A~%~%delta=~D"
	(time_map-ncycle-list-lb tm )
        (time_map-ncycle-list-ub tm )
        (time_map-delta tm )
     )
)


;;; ----------------------------------------------------------------------------------
;;;
;;;   Visualiza la rete UTILIZANDO write-dcs-for-prodigy y write-tps-for-prodigy.
;;;   Engloba a las dos funciones y permite escribir en fichero o por pantalla.
;;;   Tambien visualiza los links causales calculados mediante el algoritmo.
;;;
;;; ----------------------------------------------------------------------------------


(defun Visualizar-Red (red n) ;; &optional (stream t))
 
 (push user::*Final* user::*list-TPop*)
#|
 (if (not (equal red nil))
    (progn
	(format stream "~%~%The causal links between opertors are .....................~%~%~d~%" user::*list-links*)

      (if user::*Resorce-Consumed*
  	   (format stream "~%~%The causal links between opertors are .....................~%~%~d~%" user::*list-links-res*)
      )

	;;Visualiza los arcos entre esas actividades
	(format stream "~%~%The arcs in the temporal network are  ............................ ~%")
	(write-dcs-for-prodigy red 1 n stream)
	;;;(write-dcs *rete* 1 *num*)  

	;;  visualizar la rete entre los nodos 1 y 8
 	(format stream "~%~%The start and end time in each operator is   ...................... ~%")
|#	

        (write-tps-for-prodigy red 1 n)  ; Con esto actualizamos el Make-span

#|
 	(format stream "~%  ....................................... ~%")

        (format stream "~%La matriz con la proporcion de recursos es = ~d~%" user::*Resorce-Consumed*)

    );;fin progn
 );;fin if
|#
 (pop user::*list-TPop*)
);;fin defun





;;; ---------------------------------------------------------------------------
;;; ---------------------------------------------------------------------------
;;; *END-OF-FILE*


; (load "C:/Hamlet/integration/stp-new-2/output.lsp")