;;; This file computes the handler to get the parallel plan for Hamlet.
;;; MOdificado en Agosto, Bug de la duracion del operador
(in-package "P4")

;; Estoy pasando operadores de la solucion de prodigy. Los convierto a TP's y los los links unen dos operadores representados   por 2 TP's
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: get-f-operator
;; Parametros: none
;; Valor devuelto: list
;; Descripcion:
;;     Esta funcion devuelve una lista con las metas.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-f-operator()
   
 (let* ((f-operator nil)
        (is-igoal nil)
        (is-goal nil)
        (is-no-and nil));fin de la declaracion
   ;(format t"~%***** fet-f- operator ***************************~%")        
    ;;Obtener la lista del operador f(metas)
      
    ;;Si el primer elemento es IGOAL 
    (setq is-igoal (equal (car (p4::problem-goal(current-problem))) 'IGOAL))
    (cond (is-igoal (setq f-operator (car (cdr (p4::problem-goal(current-problem)))) )
                  
          )
          ;;Else
          (t  (setq is-goal (equal (car (p4::problem-goal(current-problem))) 'GOAL))
              ;;si el primer elemento es GOAL
              (cond (is-goal   (setq is-no-and (not (equal (caar (cdr (p4::problem-goal(current-problem)))) 'AND) ))
                               ;;Sino es un and
                               ;;(print 'goal)
                               (cond (is-no-and (setq f-operator (list(car (cdr (p4::problem-goal(current-problem))))))
                                     );fin is-no-and
                                     ;;else (si es un and)
                                     (t ;;si es goal y tiene varias metas
                                        (setq f-operator (cdr (car (cdr (p4::problem-goal(current-problem)) ))) )
                                     );;fin del else
                               );fin del cond is-no-and 
                    );fin is-goal
              );;fin del cond si el primer elemento es goal
          );;fin del else
    );; fin del cond si el primer elemento es IGOAL
       ;(format t"~%*****FIN  get-f- operator ***************************~%")      
   ;;Devuelve las metas
   (car (list f-operator))
  );fin del let 
   
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: get-s-operator
;; Parametros: none
;; Valor devuelto: list
;; Descripcion:
;;     Esta funcion devuelve una lista con las condiciones iniciales
;;     (con el formato adecuado).
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-s-operator()
 
 (let* ((s-operator nil)
        (is-and nil));fin de la declaracion
        
        
    (setq is-and (equal (caar (cdr (p4::problem-state(current-problem)))) 'AND))
    ;;Si el estado inicial esta formado por mas de un predicado.
    (cond (is-and (setq s-operator (cdr (car (cdr (p4::problem-state(current-problem))))) )
          )
          ;;else
          (t  (setq s-operator (list (caar (cdr (p4::problem-state(current-problem))))) )
          )
    );;fin del cond de si el estado inicial esta formado por mas de un predicado
 
  
 (list s-operator)
 );fin del let
  
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: get-operators-data
;; Parametros: instantiated-op => es el nuevo operador aplicado instanciado
;; Valor devuelto: lista
;; Descripcion:
;;     Esta funcion devuelve una lista con todos los operadores aplicados
;;     que hasta el momento han sido expandido, junto con los operadores
;;     F-OP y S-OP.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-operators-data (node)
  (let* ((effects (p4::applied-op-node-justification-table node)) ;se almacena la lista de efectos de borrado y annadido
         (preconds nil)
         (preconds-found nil)
         (num-effects-found nil)
         (del-effects nil)
         (add-effects nil)
         (op-name nil)
         (op-duration nil)
         (parent nil)
         (have-adds nil)
         (adds nil)
         (aux nil)
         (aux-effects nil)
         (flag-effects nil)
         (num-adds 0)
         (num 0)
         ;;(end-search nil)
         (aux-TP nil)
         (cont 1) ;; Saber la posicion que ocupa el recurso

        );fin de la declaracion del let

  ;(format t"~%***** get-s-operator ***************************~%")        
   ;; si es el primer operador se incluye el operador S-OP y el primer operador aplicado.
   (cond (user::*first-op*  
    
     ;;Se tiene en cuenta si se quieren calcular recursos y luego si se quiere o no introducir los datos por teclado o desde fichero.
     ;; MD Marzo 2003 Para los recursos
    (if user::*calculate-resources* 
        (USER::ObtResource-Input)
        #|
        (if (equal user::*creado* nil) 
            (USER::ObtResource-Pantalla) 
            (USER::ObtResource-File)
        )
        |#
    )

     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ;;Creacion de la lista del operador S-OP   
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
     ;;Se crea el TP del operador S-OP
     (push (user::make-TimePoint   :id  1 ; S-OP
	             :operator '(S-OP)	
					 :preconds nil
					 :adds  (car(get-s-operator))
					 :dels nil
					 :start-id  1			
					 :end-id    1		
					 :duration-min  0		
					 :duration-max  0		
					 :id-domain 0
					 :added     t)
            user::*list-TPs*) 
     
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ;Obtencion de todos los datos del nuevo operador aplicado
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
     ;;Bucle que recorre los efectos del operador opi
     (setq aux-effects  (list (user::get-visible-form (caar effects))))
     (loop for effect in (cdr effects)  
       do 
       (setq aux-effects (append aux-effects (list (user::get-visible-form (car effect)))))
     );;fin del bucle que recorre los efectos      
     
     
     ;;se almacena el nodo actual en la nueva variable parent para no perder el valor de
     ;; la variable actual.
     (setq parent node)
          
     ;;Busqueda por el arbol de prodigy el numero de adds y las precondiciones hasta que se encuentren todos los datos.
     (cond (parent  ;;Bucle que recorre el arbol hacia arriba...
                     (loop while (and (>= (p4::nexus-name parent) 6) (not(and preconds-found num-effects-found)))
                       do
                       ;;Cuerpo del bucle
                       
                       
                       ;;Case que permite hacer distintas operaciones segun el tipo de nodo
                       (case (p4::type-of parent)
                           
                          
                           
                           ;;Si es de tipo Binding-Node almaceno las precondiciones
                           (PRODIGY4::BINDING-NODE  ;;Se compara el operador instanciado de este nodo con el nodo actual (node)
                                                    (cond ((eq (p4::binding-node-instantiated-op parent) (p4::applied-op-node-instantiated-op node)) 
																																									 ;;Se obtiene las precondiciones																		
																	  						                                                       (setq preconds (user::get-binding-preconds-in-visible-form (p4::binding-node-instantiated-preconds parent))) ;;Despues para las negaciones																	  						                                                       
  																	  						                                                       ;(setq preconds (user::get-binding-preconds (p4::binding-node-instantiated-preconds parent)))	;;ANtes y funcionaba							 									  						                                                       
																	  						                                                       (setq op-name (car (user::get-applicable-op (p4::binding-node-instantiated-op parent))))
																	  						                                                       ;;Se pone el flag a t para indica q se ha encontrado ya las precondiciones
																	  						                                                       (setq preconds-found t)
																	  			);fin de si es igual			                                                       
															        ); fin del cond						                                      
                           );;fin de si es de tipo Binding
                           
                           ;;Si es de tipo Operator-Node ....
                           (PRODIGY4::OPERATOR-NODE 
                                                    
                                                    ;;Si coincide con el operador ..... se obtiene el numero de adds
                                                    (cond ((eq op-name (p4::operator-name (p4::operator-node-operator parent)))                           
																				       (setq num-effects-found t)
                                                                                                        									  (setq adds (car (p4::operator-add-list (p4::operator-node-operator parent))))
                                                                                                                                    (setq have-adds (not (equal adds nil)))
                                                                                                                                    ;;Si tiene adds
                                                                                                                                    (cond (have-adds (setq num-adds 1)
                                                                                                                                                     (setq aux adds)
                                                                                                                                                     (setq flag-effects have-adds)
                                                       											                 										         		  
																					                                                                                      ;;Bucle que averigua el numero de efectos de annadido 
																					                                                                                      (loop while flag-effects 
																					                                                                                         do  (setq aux (nthcdr num-adds (car (p4::operator-add-list (p4::operator-node-operator parent )))))
																					                                                                                             (setq flag-effects (not (equal aux nil)))
																					                                                                                             (setq num-adds (+ num-adds 1))
                                                                 													                      										   
																						                                                    		                          );;fin del while
																						                                                                                   (setq num (- num-adds 1))
																						                                                                                    
													                                                                                                        );;fin de si existen adds
													                                                                                                  );fin del cond  
                                                                                                                                         
                                                    
                                                           );fin de si son iguales
                                                    
                                                     );fin del cond      
                                                                                                
                           );fin de si es de tipo Operator
                           
                          
                       );fin del case 
                       
                       (setq parent (p4::nexus-parent parent)) 
                       
                     );fin del while 
                     
             );fin de si tiene padre  
       );fin del cond
     
      
     
     ;;Obtenemos los efectos de borrado
     (setq num (list num))
     (setq del-effects (nthcdr (car num) aux-effects)) 
     
     
     ;;Obtenemos los efectos de annadido
     (setq add-effects (set-difference aux-effects del-effects))
      
	  	   
    );fin de si es el primer operador aplicado
   
    (t 
       
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ;Obtencion de todos los datos del siguiente operador aplicado
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        
      ;;Bucle que recorre los efectos del operador opi
     (setq aux-effects  (list (user::get-visible-form (caar effects))))
     (loop for effect in (cdr effects) do 
       (setq aux-effects (append aux-effects (list (user::get-visible-form (car effect)))))
     );;fin del bucle que recorre los efectos      
     
     
     ;;se almacena el nodo actual en la nueva variable parent para no perder el valor de
     ;; la variable actual.
     (setq parent node)
     
     ;;Busqueda por el arbol de prodigy el numero de adds y las precondiciones.
     (cond (parent  ;;Bucle que recorre el arbol hacia arriba...
                     (loop while (and (>= (p4::nexus-name parent) 6)(not(and preconds-found num-effects-found)))
                       do
                       ;;Cuerpo del bucle
                       ;;Case que permite hacer distintas operaciones segun el tipo de nodo
                       (case (p4::type-of parent)
                           ;;Si es de tipo Binding-Node almaceno las precondiciones
                           (PRODIGY4::BINDING-NODE  ;;Se compara el operador instanciado de este nodo con el nodo actual (node)
                                                    (cond ((equal (p4::binding-node-instantiated-op parent) (p4::applied-op-node-instantiated-op node)) 
																																									 
																		   					                                                    ;;Se obtiene las precondiciones																		
																	  						                                                       (setq preconds (user::get-binding-preconds-in-visible-form (p4::binding-node-instantiated-preconds parent))) ;Para las negaciones
																																                            ;;(setq preconds (user::get-binding-preconds (p4::binding-node-instantiated-preconds parent)))	;Antes y funcionaba																				  						                                                       
																	  						                                                       (setq op-name (car (user::get-applicable-op (p4::binding-node-instantiated-op parent))))
																	  						                                                       (setq preconds-found t)
																	  			);fin de si es igual			                                                       
															        ); fin del cond						                                      
                           );;fin de si es de tipo Binding
                           
                           ;;Si es de tipo Operator-Node ....
                           (PRODIGY4::OPERATOR-NODE 
                                                    
                                                    ;;Si conincide con el operador ..... se obtiene el numero de adds
                                                    (cond ((equal op-name (p4::operator-name (p4::operator-node-operator parent)))  
                                                                                                                                    (setq num-effects-found t)
                                                    														(setq adds (car (p4::operator-add-list (p4::operator-node-operator parent))))
                                                                                                                                    (setq have-adds (not (equal adds nil)))
                                                                                                                                    ;;Si tiene adds
                                                                                                                                    (cond (have-adds (setq num-adds 1)
                                                                                                                                                     (setq aux adds)
                                                                                                                                                     (setq flag-effects have-adds)
                                                       											                 										         		  ;;Bucle que averigua el numero de efectos de annadido 
																					                                                                                      (loop while flag-effects 
																					                                                                                         do  (setq aux (nthcdr num-adds (car (p4::operator-add-list (p4::operator-node-operator parent )))))
																					                                                                                             (setq flag-effects (not (equal aux nil)))
																					                                                                                             (setq num-adds (+ num-adds 1))
                                                                 													                      										   
																						                                                    		                          );;fin del while
																						                                                                                   (setq num (- num-adds 1))
																						                                                                                   
																												                                                                  
													                                                                                                        );;fin de si existen adds
													                                                                                                  );fin del cond  
                                                                                                                                         
                                                    
                                                           );fin de si son iguales
                                                    
                                                     );fin del cond      
                                                                                                
                           );fin de si es de tipo Operator
                           
                          
                       );fin del case 
                       
                       (setq parent (p4::nexus-parent parent)) 
                       
                     );fin del while 
                     
             );fin de si tiene padre  
       );fin del cond
     
     
     ;;Obtenemos los efectos de borrado
     (setq num (list num))
     (setq del-effects (nthcdr (car num) aux-effects)) 
     
    
     ;;Obtenemos los efectos de annadido
     (setq add-effects (set-difference aux-effects del-effects))
     
       
    );fin de si no es el primer operador aplicado
    
   );fin del cond
   
   
   
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;Obtiene la duracion de operador aplicado
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   
   (if (and (not (equal user::*cost-label* 'time)) (problem-space-property :make-span))    
       (setq op-duration (getf (p4::nexus-plist node) 'p4::associated-duration))
       (setq op-duration (getf (p4::nexus-plist node) :g-value))
   );fin del if  
   
   ;;(print 'op-duration) ;;LEt 
   ;;(print op-duration)(read t)
   
       
   ;Si no tiene coste asociado, el coste asociado sera 1.En caso contrario, se calcula los costes 
   (cond ((equal op-duration nil)  ;Si es la primera vez
                                    (cond (user::*first-op* (setf user::*op-durations* (append user::*op-durations* (list '0)(list '1) ))
                                                            (setf user::*first-op* nil)
                                          );fin de si es la primera vez
                                          (t (setf user::*op-durations* (append user::*op-durations* (list '1) )) 
                                          );fin del else
                                    );fin de cond     
         );fin de si es igual a  nil
         ;En caso contrario, se calculan los costes
         (t
    
        
     ;;Si es el operador aplicado del primer operador de la solucion al plan 
     (cond (user::*first-op* ;;La duracion de ese operador coincide con su valor absoluto  y se almacena en la lista abs-duration
                            
                            (if (and (not (equal user::*cost-label* 'time)) (problem-space-property :make-span))
                                (progn
                                  (setf user::*op-durations*
				    (append user::*op-durations*
					    (list '0)
					    (list (getf (p4::applied-op-node-plist node) 'p4::associated-duration))))
                                  (setf user::*abs-duration*
				    (append (list '0)
					    (list (getf (p4::applied-op-node-plist node) 'p4::associated-duration)))) 
                                  
                                 );fin del progn
                                 (progn
				   (setf user::*op-durations*
				     (append user::*op-durations*
					     (list '0)
					     (list (getf (p4::applied-op-node-plist node) :g-value))))
				   (setf user::*abs-duration*
				     (append (list '0)
					     (list (getf (p4::applied-op-node-plist node) :g-value)))) 
                                  
                                 );fin del progn
                             );fin del if     
                            
                            (setf user::*first-op* nil)
                            
	       );fin de si first-op = t
          ;;Else
          (t ;;Se almacena su valor en la lista abs-duration
                
                
                ;;Se calcula la duracion real de ese operador: Hay que restar la duracion del operador actual de la duracion del anterior
                ;;Y Se annade el valor de duracion a la lista
;;;;;;;;;;;;;;;;;;;;;;;;;;;; AGOSTO 2003 ;;;;;;;;;;;;;;;;;
                ;(format t "~% valor = ~d  ~% Otro = ~d~%"   op-duration (car(last user::*abs-duration*))) 
	        (if (eq (car (last user::*abs-duration*)) nil)      
                     (setf user::*op-durations* (append user::*op-durations* (list op-duration)))
	             (setf user::*op-durations* (append user::*op-durations* (list (- op-duration (car(last user::*abs-duration*)))) ))
                )
                ;;(read t)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ;;Se incluye el valor absolut en la lista
                (if (and (not (equal user::*cost-label* 'time)) (problem-space-property :make-span))
		    (setf user::*abs-duration*
		      (append user::*abs-duration*
			      (list (getf (p4::applied-op-node-plist node) 'p4::associated-duration))))
                  (setf user::*abs-duration*
		    (append user::*abs-duration*
			    (list (getf (p4::applied-op-node-plist node) :g-value))))
                 );fin del if 
                
                 
          );fin del else
       ) ;fin del cond      
    
     );fin del else
    );fin del cond 
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   
   
    ;;Se rellena el Timepoint del nodo aplicado actual, sabiendo que los datos estan en las variables
    ;;(car new-op-data),preconds,add-effects,del-effects y user::*op-durations*


   ;MD MArzo 2003
   ;; Calcula el recurso que utiliza el operador y luego le asigna el identificador  
   (setq cont (USER::Associate-Resources node))

   (setq aux-TP  (user::make-TimePoint :id  (+ (length (reverse(cdr (reverse user::*applied-operators-id*))) ) 2) 
	   			            :operator (list (p4::applied-op-node-instantiated-op node))
					      :preconds preconds
					      :adds  add-effects
					      :dels  del-effects
					      :start-id  (+ (*  2 (length (reverse(cdr (reverse user::*applied-operators-id*))) )) 1) 
					      :end-id    (+ (*  2 (length (reverse(cdr (reverse user::*applied-operators-id*))) )) 2)		
					      :duration-min  (car(last user::*op-durations*))		
					      :duration-max  (car(last user::*op-durations*))		
						:id-domain cont
						; :TP-st ;(create-TP
						:added     nil))
   
  (push  aux-TP user::*list-TPs*)
  ;;(print 'dur)
  ;;(print (car(last user::*op-durations*)))(read t)
  );fin del cuerpo del let
   ;(format t"~%*****FIN  fet-s-operator-data ***************************~%")
  
);fin de la funcion get-operators-data

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Esta funcion inicializa las variables globales tras finalizar la resolucion de un problema
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun initialise-plan()
  
  ;; Inicializacion de las variables usadas para la obtencion de informacion del
  ;; arbol de prodigy (parallel.lsp, quality.lsp)
  ;; (format t"~%***** initialise  ***************************~%")  
  
  (setf user::*applied-operators* '(S-OP)) ;Eliminar tras pruebas
  (setf user::*abs-duration* nil)
  (setf user::*op-durations* nil)
  (setf user::*first-op* t)
  (setf user::*list-TPs* nil)
  (setf user::*last-path* nil)
  (setf user::*last-op-consistence* t)
  (setf user::*applied-operators-id* '(0))
   (setf user::*no-finish* t)
  ;;Inicializacion de las variables de la red Temporal (applied.lsp)
  
  (setf user::*rete* nil)
  (setf user::*num* 100)
  
  
  (setf user::*list-links*  nil)       ; Lista con todos los links de todos los operadores annadidos.
  (setf user::*list-TPop* nil)         ; Lista con todos los operadores que son consistentes
  (setf user::*lista-de-estados* nil)  ; Lista con todos los estados por los que se va pasando al annadir operadores
  (setf user::*mi-links-temp*  nil)    ; Lista de links para cada operador
  (setf user::*list-goal* nil)	   ; Lista de links que se establecen con el ultimo operador
  (setf user::*Final* nil) 
  (setf user::*make-span* nil)
  (USER::initialise-resources)           ;; MD Marzo 2003

  ;;(format t"~%*****FIN initialise  ***************************~%")
  
);fin de la funcion initialise


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: plan-handler
;; Parametros: Ninguno
;; Valor devuelto: Ninguno
;; Descripcion:
;;     Esta funcion  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun plan-handler ()
  ;;Declaracion de variables.
  (declare (special user::*current-node* user::*applied-operators* user::*applied-operators-id*) 
  );fin de la  declaracion

   ;(format t"~%***** plan-handler  ***************************~%")  
 
(let* ((flag-consistence nil) ;variable donde se almacena el valor devuelto por la funcion check-consistence
         
        );fin de la declaracion de variables
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Se crea un fichero debug.txt donde se muestra la traza de ejecucion 
  ;; de la implementacion.
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
  
     
  ;;Si el nodo actual es de tipo operador-aplicado, entonces...
  (when (applied-op-node-p user::*current-node*) 
    
    
         
    ;;Se crea la lista  con los operadores aplicados
    (setf user::*applied-operators* (append user::*applied-operators* (list(p4::applied-op-node-instantiated-op user::*current-node*))))
    (setf user::*applied-operators-id* (append user::*applied-operators-id* (list(p4::applied-op-node-name user::*current-node*))))
    
                                      
    ;;Obtiene informacion del operador aplicado, guardandola en la 
    ;; lista op-data.         
      
    (get-operators-data user::*current-node*)
   


#|
    ;; La ruta de los ficheros sea relativa    
    ;;(with-open-file (stream (concatenate 'string *hamlet-path*  "integration/red.txt")
    ;;(with-open-file (st "C:/APLICA~1/hamlet/Versiones/red.txt"   
		  :direction :output
		 ;:if-exists :supersede
		  :if-exists :append
		  :if-does-not-exist :create)
     (setq flag-consistence (p4::check-consistence st))        
    );;fin with-open-file

|#    
    (setq flag-consistence (p4::check-consistence))    ;;MD Marzo 2003 
     
    ;;Si la red temporal no es consistente se cierra el nodo
    (cond ((not flag-consistence) ;cierra el nodo actual y se hace backtracking
                                  
                                  (setf user::*last-op-consistence* nil)
                                  
                                  (let ((new-node user::*current-node*))
					                         (setf (getf (nexus-plist new-node) :termination-reason):non-consistence)
                                        (close-node-and-children user::*current-node* :non-consistence)
                                       );fin del let     
          );fin del flag-consistence
          (t
            (setf user::*last-op-consistence* t)
          ); fin del else                  
    );fin del cond 
   
  );fin del when
 

 );fin del let
	
);fin de la funcion plan-handler


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: finish-plan-handler
;; Parametros: Ninguno
;; Valor devuelto: Ninguno
;; Descripcion:
;;     Esta funcion  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defun finish-plan-handler ()
  ;;Declaracion de variables
  (declare (special user::*current-node* user::*applied-operators* user::*applied-operators-id*)
  );fin de la declaracion de variables.
  
  
  (let* ((flag-consistence nil)      ;variable donde se almacena el valor devuelto por la funcion check-consistence
         (last-applied-op nil)
         (aux-list nil)       
        );fin de la declaracion de variables
  
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ;; Se crea un fichero debug.txt donde se muestra la traza de ejecucion 
     ;; de la implementacion.
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     

  
  
   ;;se obtiene el nodo aplicado actual
   (setq last-applied-op (car(p4::nexus-children user::*current-node*)))
   
   ;;Si el nodo actual es de tipo operador-aplicado, entonces...
   (when (applied-op-node-p last-applied-op) 
  
                
        ;;Se crea la lista  con los operadores aplicados
        (setf user::*applied-operators* (append user::*applied-operators* (list(p4::applied-op-node-instantiated-op last-applied-op)) ))
        (setf user::*applied-operators-id* (append user::*applied-operators-id* (list(p4::applied-op-node-name last-applied-op))))
        
                                              
        ;;Obtiene informacion del operador aplicado, guardandola en la 
        ;; lista op-data.         
        (get-operators-data last-applied-op)
             
  #|  
     ;; La ruta de los ficheros sea relativa   ;;MD Marzo 2003
    (with-open-file (stream (concatenate 'string *hamlet-path*  
					"integration/red.txt")
      
    ;;(with-open-file (st "C:/APLICA~1/hamlet/Versiones/red.txt"  
		  :direction :output
		 ;:if-exists :supersede
		  :if-exists :append
		  :if-does-not-exist :create)

           (setq flag-consistence (p4::check-consistence st))
    );;fin with-open-file
    |#
     (setq flag-consistence (p4::check-consistence)) ; MD Marzo 2003
               
       ;;Si la red temporal no es consistente se cierra el nodo
       (cond ((not flag-consistence) ;cierra el nodo actual y se hace backtracking
                                    
                                    (setf user::*last-op-consistence* nil)
                                    (setf user::*consistence* nil)
                                    (let ((new-node last-applied-op))
     	 				                         (setf (getf (nexus-plist new-node) :termination-reason):non-consistence)
                                           (close-node-and-children new-node :non-consistence)
                                         );fin del let     
             );fin del flag-consistence
             ;;Si es consistente....
            (t
                (setf user::*last-op-consistence* t)
                ;;Se crea el TP del operador F-OP y se incluye en la lista
			       (push  (user::make-TimePoint :id  2 ; F-OP
											:operator '(F-OP)	
											:preconds (get-f-operator)
											:adds  nil
											:dels  nil	
											:start-id  2			
											:end-id    2		
											:duration-min  0		
											:duration-max  0		
											:id-domain 0  ;; MD Marzo 2003
											:added     t)
			       user::*list-TPs*)
					        
			              
			      (setf user::*applied-operators* (append user::*applied-operators* '(F-OP) ))
			      (setf user::*applied-operators-id* (append user::*applied-operators-id* '(0.1) ))
					
					       
			      ;;Se annade el coste del operador F-OP
			      (setq aux-list (reverse user::*op-durations*))
			      
			      ;;Se annaden el coste del  F-OP
			      (setq aux-list (cons '0 aux-list))
			      
					        
			      (setf user::*op-durations* (reverse aux-list))
			      
			     
			      (push user::*Final* user::*list-TPop*)

                     ;; NO HACEN FALTA 			      
					                            
               ;;Se inicializan las variables globales, siempre que no se trate de multiples
               ;;soluciones.
               (if (not(problem-space-property :multiple-sols))
                   (progn
                     
                     ;;Se inicializan las variables globales
                     (COMMON-LISP-USER::Visualizar-Red user::*rete* user::*num*)  ;;MD MARZO no muestre solucion
                     (initialise-plan)
                    );fin del progn 
                ;);fin del if    
                 ;;En caso contrario, quitamos el ultimo operador F-OP incluido en la lista
                 ;;el correcto funcionamiento del backtracking.
                 (progn
                     ;;Se actualizan todas las variables necesarias.
                     (pop user::*list-TPop*)
                     (pop user::*list-TPs*)
                     (setf user::*applied-operators* (reverse(cdr(reverse user::*applied-operators*))) )
		         (setf user::*applied-operators-id* (reverse(cdr(reverse user::*applied-operators-id*))) )
		         (setf user::*op-durations* (reverse(cdr(reverse user::*op-durations*))) )
		        ;;;; (USER::initialise-resources)  ;MD 24 Marzo          
                   );fin del progn 
               );fin del if   
                    
           );fin del else                  
       );fin del cond 
                 
       
   );fin del when
 
 
 );fin del let 
           ;(format t"~%*****FIN finish-plan-handler  ***************************~%") 
);fin dela funcion finish-plan-handler