;;; ----------------------------------------------------------------------------------
;;;   				TIME-MAP OUTPUT FUNCTIONS  
;;; 
;;; Esta archivo contiene las funciones para trabajar con recursos. Solo se consideran los 2 ultimos casos.
;;; De esta forma cuando se intenta un MS, no da problemas en la solucion.
;;;
;;;
;;;			 LAST MODIFICATION: Febrery, 7  2003
;;;
;;; ----------------------------------------------------------------------------------

; (load "C:/Hamlet/integration/stp-new-2/resource.lsp")

(in-package "COMMON-LISP-USER")

#|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   LEER LOS RECURSOS DEL FICHERO Y DEVOLVER UNA MATRIZ CON DICHOS DATOS
;;   El fichero tendra en la primera linea el numero de recursos y el numero de operadores en el dominio.
;;   La segunda fila contendra la capacidad global de cada recurso
;;   Las siguientes lineas contendra para cada operador el consumo del recurso (Incluido S-op y F-op que seran cero)
;;  
;;   Solo sirve para que cada operador tenga siempre el mismo recurso asociado
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun OpenFile ()  
  (let* ((i 0)
	   (j 0)
	 )

  (with-open-file (st (concatenate 'string user::*hamlet-path* 
					"integration/resource.txt")
 ;(with-open-file (st "C:/Hamlet/integration/resource.txt"  
	              :direction :input)  
           (setf user::*num-r*  (read st)) ; Numero de recursos
	     (setf user::*num-op* (read st)) ; Numero de operadores
	     (setf user::*M-Resources* (ADynamic (+ user::*num-op* 1) user::*num-r*)) ;M de recursos q cada operador consum 
	     ;;;(format t "Num Res = ~d Num Op = ~d Matriz = ~d~%" user::*num-r* user::*num-op* user::*M-Resources*)
	     (do ((line (read st nil 'eof) 
                  (read st nil 'eof) 
	         ))
	         ((eql line 'eof))
               ;;(format t "La lista es: ~d ~%" line )
	         (setf (aref user::*M-Resources* i j) line)
	         (incf j)
	         (if (= j user::*num-r*)
		     (progn
		        (setq j 0)
			  (incf i)
		     );;fin progn
		   );;fin if
           );;fin do
    );;fin with-open-file
   ;;(format t "Num Res = ~d Num Op = ~d Matriz = ~d~%" user::*num-r* user::*num-op* user::*M-Resources*)
   );;fin del let*
 );;fin defun

|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Crea un array bidimensional y lo inicia con 0
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun ADynamic(DIM DIM1)
 (make-array  (list  DIM DIM1)  :element-type t
	      :initial-element 0)
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Me devuelve los dos TP asociado al operador  (Se podria evitar tener que recorrerme el bucle? Existe alguna manera de ir teniendo el TP cada vez que lo inserto en la RED????
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun ObtTP (t-op tm min-tp max-tp ) ;&optional (stream t))
  (let* ((min-index (max 1 min-tp))
         (max-index max-tp)
	   (TPl nil)
	   (TPu nil)
	   (cont 0)
	   (list-TP nil)
        );fin de la declaracion de variables
     ;;(format t "~%........................Inicio FUNCION OBTTP~%") 	;(read t)
     (dolist (atp (time_map-list_tps tm))
       (if (and (>= (car atp) min-index) (<= (car atp) max-index))
         (progn          
	   (let ((tp (cdr atp))
	         );fin del let
            ;;Se recorre la lista de TP's aux-list buscando el TP con = identificador que time_point-name tp
            ;;Se sacan elementos de la pila aux-list hasta que se encuentre
            ;(loop while (/= cont 2) do            
            ;;El identificador de la est.Time-point es = al TimePoint
            (if (equal (time_point-name tp) (user::TimePoint-start-id t-op)) 
		 (progn
		   (setq TPl tp)
		   ;;;;(format t"~%El upper bound ")
		   (incf cont) (push TPl list-TP)
		 );;fin progn
             ;;El identificador de la lst.Time-point es = al TimePoint
	       (if (equal (time_point-name tp) (user::TimePoint-end-id t-op))
		 (progn
		   (setq TPu tp)
		   ;;;;(format t"~%El upper bound ")
		   (incf cont) (push TPu list-TP)
		 )
            );;fin del if TP upper
	     );;fin del if TP lower
	   ;);;fin loop
	   (if (= cont 2)
		(progn
	       ;;;(format t "~%El contador ha valido 2. La lista es = ~d~% de op= ~d" list-TP t-op) ;(read t)
	       (return)
	      )
		;;;(format t"~%Cont no vale 2 todavia")
           );;fin if
	   ;;;;(format t"~%Se ha salido??????~%")
	 );;fin let
        );;fin progn
     );;fin if
   );;fin dolist 
   ;;(format t"~%........................FIN FUNCION OBTTP~%") 	
  list-TP
  );;fin let*
);;fin defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Se calculan heuristicas para la poder elegir el ordenamiento de variables.
;;
;; Parametros: los dos operadores en los que se quiere calcular el conflicto de recursos
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun Calculate-Res-Ordering (opi lfti esti p-i opj lftj estj pj) ; &optional (stream t)) ;res-decision
  (let* (   (lt nil)			;Link que se decide annadir
	 (lt1 nil)			;Link que se puede annadir en el futuro si la decision anterior falla. Se guarda en el campo res-decision del TP
;;	 (slackji  (- lfti estj (+ p-i pj)))
;; 	 (slackij  (- lftj esti (+ p-i pj)))
					;(t-op     (pop user::*list-TPop*))
	 )				;fin de la declaracion de variables
    
    ;;Son iguales, se debe elegir una eleccion de forma aleatoria, ELIJO i-->j
    #|   (if (> slackij slackji)
	   (progn 
	         ;;(format t"~% EL SLACK I-->J > J-->I. IMPLICA J-->I~%")
	         (setq lt (user::make-link  :id1  opj
					    ;:condition condit ;Es debido a conflicto con recursos 
					    :id2  opi
					    :min user::*Min-Dist-Ops*
					    :max user::*Max-Dist-Ops*)
		 )
	         (setq lt1 (user::make-link  :id1  opi
					    ;:condition condit ;Es debido a conflicto con recursos 
					    :id2  opj
					    :min user::*Min-Dist-Ops*
					    :max user::*Max-Dist-Ops*)
	         )
	    );;fin progn
           (if (< slackij slackji)
	      (progn 
	         ;;(format t"~% El SLACK J-->I > I-->J. IMPLICA I-->J~%")
	         (setq lt (user::make-link  :id1  opi
					    ;:condition condit ;Es debido a conflicto con recursos 
					    :id2  opj
					    :min user::*Min-Dist-Ops*
					    :max user::*Max-Dist-Ops*)
		 )
	         (setq lt1 (user::make-link  :id1  opj
					    ;:condition condit ;Es debido a conflicto con recursos 
					    :id2  opi
					    :min user::*Min-Dist-Ops*
					    :max user::*Max-Dist-Ops*)
	         )
	     );;fin progn
	     (progn
 |# 


    ;;(format t"~% El SLACK J-->I = I-->J. DECIDO I-->J~%") ;;Cualquiera es posible

    (if (> (user::TimePoint-id opi) (user::TimePoint-id opj))
	(progn
	  (setq lt (user::make-link  :id1  opj
					;:condition condit ;Es debido a conflicto con recursos 
				     :id2  opi
				     :min user::*Min-Dist-Ops*
				     :max user::*Max-Dist-Ops*)
		)
	  (setq lt1 (user::make-link  :id1  opi
					;:condition condit ;Es debido a conflicto con recursos 
				      :id2  opj
				      :min user::*Min-Dist-Ops*
				      :max user::*Max-Dist-Ops*)
		)
	  )
      (progn
			
	(setq lt (user::make-link  :id1  opi
					;:condition condit ;Es debido a conflicto con recursos 
				   :id2  opj
				   :min user::*Min-Dist-Ops*
				   :max user::*Max-Dist-Ops*)
	      )
	(setq lt1 (user::make-link  :id1  opj
					;:condition condit ;Es debido a conflicto con recursos 
				    :id2  opi
				    :min user::*Min-Dist-Ops*
				    :max user::*Max-Dist-Ops*)
	      )
	);;fin progn
      );;fin if id opi menor opj
	       
    #| );;fin progn
          ) ;;if <
        ) ;;if >
             |#

    ;;(format t"~% user::*list-links-res* = ~d~% lt = ~d" user::*list-links-res* (list lt)) 

    ;;(format t"lista-res= ~d~%~%OPI= ~d ~%~%OPJ= ~d" (user::TimePoint-links-res opi) opi opj ) ;(read t)
    (if  (not (equal (user::TimePoint-links-res opi) nil))
	(progn
	  (dolist (lik (user::TimePoint-links-res opi)) 
					;(format t"~%Hay ya links en ese operador. ~%Id-inicial= ~d Opj = ~d" (user::TimePoint-start-id (user::link-id1 lik)) (user::TimePoint-id opj)  )
	    (if (and (equal (user::TimePoint-id (user::link-id1 lik)) (user::TimePoint-id opj))
		     (equal (user::TimePoint-id (user::link-id2 lik)) (user::TimePoint-id opi)))
		(progn
		  (setq lt nil)
		  (setq lt1 nil)
		;(format t"~%~%No se annade nada, es el mismo") ;(read t)
		  );;fin progn
	      (if (equal (user::TimePoint-start-id (user::link-id1 lik))
			 (user::TimePoint-id opj) ) ;Se ha annadido el link contrario, NO ES POSIBLE
		  (progn
		    (setq lt lt1)         
		    (setq lt1 nil)
					;(format t"~%~%Se han cambiado los links") ;(read t) 
		    );;fin progn
		);;fin if		
	      );;fin if
	    );;fin del dolist
	  );;fin progn
      );;fin if

    #|
      (if  (not (equal (user::TimePoint-links-res opj) nil))
	   (progn
             (dolist (lik (user::TimePoint-links-res opj)) 
	       ;;(format t"~%Hay ya links en ese operador. ~%Id-inicial= ~d Opj = ~d" (user::TimePoint-start-id (user::link-id1 lik)) (user::TimePoint-id opj)  )
	          (if (and (equal (user::TimePoint-start-id (user::link-id1 lik)) (user::TimePoint-id opi)) (equal (user::TimePoint-end-id (user::link-id1 lik)) (user::TimePoint-id opj)))
			 (progn
			     (setq lt nil)(setq lt1 nil)
			     ;;(format t"~%~%No se annade nada, es el mismo") ;(read t)
			  );;fin progn
			 (if (equal (user::TimePoint-start-id (user::link-id1 lik)) (user::TimePoint-id opi))  ;Se ha annadido el link contrario, NO ES POSIBLE
			   (progn
			     (setq lt lt1)         
			     (setq lt1 nil)
			     ;;(format t"~%~%Se han cambiado los links") ;(read t) 
			   );;fin progn
		       );;fin if		
		     );;fin if
	  	 );;fin del dolist
	   );;fin progn
	);;fin if

|#


					;#|
    (if (equal (user::TimePoint-res-decision opi) nil)
	(progn
	  ;;(format t"~%No hay nada en la lista de decisiones de recursos = ~d~%lt1 = ~d" (user::TimePoint-res-decision opi) lt1)
	  (if (not (equal lt1 nil))
	      (setf (user::TimePoint-res-decision opi) (list lt1))
	    (push lt1 (user::TimePoint-res-decision opi)))
	  ;;(format t"~%No hay nada en la lista de decisiones de recursos = ~d" (user::TimePoint-res-decision opi))
	  )
      (progn
	;;(format t"~%hay  en la lista de decisiones de recursos = ~d"(user::TimePoint-res-decision opi))
	(if (not (equal lt1 nil))
	    (push lt1 (user::TimePoint-res-decision opi)))
	;;(format t"~%hay  en la lista de decisiones de recursos = ~d"(user::TimePoint-res-decision opi))
	);;fin progn
      );;fin if

					;|#
					;(push t-op user::*list-TPop*);(read t)
    lt
    );;fin del let*
  );;defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Calcula los cuatro casos del algoritmo de Smith AAAI-93, dado dos operadores si:
;; (donde  (estj --> earlier start time of j), (lfti --> the latest finish time of i) y (pi --> processing time required by operation i))  Supongo que sera la duracion minima ya que podria tener una maxima.
;; 1) lfti - estj < pi + pj <= lftj - esti  --> i antes que j
;; 2) lftj - esti < pi + pj <= lfti - estj  --> j antes que i
;; 3) pi + pj >  lftj - esti and pi + pj >  lfti - estj  --> INCONSISTENTE
;; 4) pi + pj <= lftj - esti and pi + pj <= lfti - estj  --> Cualquier ordenacion es posible  
;;
;; Parametros: los dos operadores en los que se quiere calcular el conflicto de recursos
;; Devolvera si es o no consistente. De esta forma la funcion que la llama "resource-reasoning"
;; se saldra en caso de que sea inconsistente.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun cases-RES (opi opj tm min-tp max-tp &optional (stream t))
  (declare (ignore stream))
  (declare (special *tracep*))
  (let* ((list-i (ObtTP opi tm min-tp max-tp ))
	 (list-j (ObtTP opj tm min-tp max-tp ))
	 (p-i (user::TimePoint-duration-min opi))
	 (pj (user::TimePoint-duration-min opj)) 
	 (lfti (time_point-ub (cadr list-i)))
	 (lftj (time_point-ub (cadr list-j)))  
	 (esti (time_point-lb (car list-i)))
	 (estj (time_point-lb (car list-j)))
	 (lt nil)
	 )				;fin de la declaracion de variables
	
;;     (when *tracep*
;;       (format t "~%........................Inicio FUNCION cases-resources~%opi=~d~%opj=~d~%"opi opj) 	
;;       (format t "pi= ~d esti = ~d lfti = ~d~%" p-i esti lfti) 	
;;       (format t "pj= ~d estj = ~d lftj = ~d~%" pj estj lftj) 
;;       (format t "pi + pj= ~d lfti - estj = ~d lfti - estj = ~d ~%" (+ p-i pj) ( - lfti estj) ( - lfti estj)))
	
					;(COMMON-LISP-USER::write-dcs user::*rete* 1 user::*num*)
       ;;;(format t   "~%~%Op hasta ahora: ~d~%~%" user::*list-TPop*)
					;(read t)

    (if (and (< (- lfti  estj) (+ p-i pj)) (<= (+ p-i pj) (- lftj  esti))) ;1
	(progn 
	  ;;(format t   "~% lfti - estj < p-i + pj <= lftj - esti  --> ~%La operacion i antes que j~%")
	  (setq lt (user::make-link  :id1  opi 
					;:condition condit ;Es debido a conflicto con recursos 
				     :id2  opj
				     :min user::*Min-Dist-Ops*
				     :max user::*Max-Dist-Ops*)
		)
	  (setf user::*last-op-consistence* t)
	  );;fin progn

      (if (and (< (- lftj  esti) (+  p-i  pj)) (<= (+  p-i  pj) (- lfti  estj))) ;2
	  (progn
	    ;;(format t   "~% lftj - esti < p-i + pj <= lfti - estj  -->  ~%La operacion j antes que i~%")
	    (setq lt (user::make-link  :id1   opj
					;:condition condit ;Es debido a conflicto con recursos 
				       :id2  opi
				       :min user::*Min-Dist-Ops*
				       :max user::*Max-Dist-Ops*)
		  )
	    (setf user::*last-op-consistence* t)
	    );;fin progn
	(if (and (< (- lftj  esti) (+  p-i  pj)) (> (+  p-i  pj) (- lfti  estj))) ;3
	    (progn
	      ;;(format t   "~% lftj - esti < p-i + pj <= lfti - estj  -->  ~%INCONSISTENTE EN RECURSOS!!!!!~%")
	      (setf user::*last-op-consistence* nil)	         
	      );;fin progn
	  (if (and (<= (+  p-i  pj)(- lftj  esti)) (<= (+  p-i  pj) (- lfti  estj))) ;4
	      (progn
		;;(format t   "~%p-i + pj <= lftj - esti and p-i + pj <= lfti - estj  --> ~%Cualquier ORDEN ES POSIBLE~%")
		(setf user::*last-op-consistence* t)
		(setq lt  (Calculate-Res-Ordering opi lfti esti p-i opj lftj estj pj ))
		);;fin progn
	    );;FIN IF CASE 4
	  );;FIN if case 3
	);;fin if case 2
      );;fin case 1
   
    ;;(format t   "~%........................ FIN FUNCION cases-resources~%") 
    lt	
    );;fin del let*
  );;fin de defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; ALGORITMO DE RECURSOS: Aplica el algoritmo de Smith AAAI-93 probando todas la combinaciones
;; que puede haber entre los recursos
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun resource-reasoning (tm min-tp max-tp ); &optional (stream t))
  (let* ((aux-list user::*list-TPop*)
	 (list-link nil)
	 (lt nil)
         (c 0)
        );fin de la declaracion de variables
   

  ;;(format t   "~%Inicio de resource-reasoning ------------------------~%")


  (if (> (length aux-list) 2) 
    (progn
	;;(format t   "~%Hay mas de un operador en la lista. Num Recursos = ~d" user::*num-r*)
      (loop for i from 0 to (- user::*num-r* 1)  do 
	  ;;(format t   "~%Bucle primero, for del recurso = ~d hasta ~d" i user::*num-r*)
        (dolist (opx aux-list) 
	    ;;(format t   "~%opx= ~d" opx)
	    (if (= (user::TimePoint-id-domain opx) 0)
		;;(format t   "~%Es igual a cero--> F-OP o S-OP")
		(progn
	       ;;(format t  "~% El operador OPX= ~d consume recursos del tipo i = ~d?" opx i)
	       ;(read t)
             (setq c (aref user::*M-Resources* (user::TimePoint-id-domain opx)  i))
		 ;;(format t "~%c= ~d" c) ;(read t)
	       (if (= c 0) ;El operador consume el recurso ri
		   ;;(format t "~%El operador no consume dicho recurso")
		   (progn
		    (dolist (opy aux-list)
		    ;;  (format t "~%opy= ~d~%" opy)
	            (if (= (user::TimePoint-id-domain opy) 0)
			  ;;(format t "~%Es F-OP o S-OP, OPY ")
		       (progn
	               ;;(format t "El operador OPY=~d consume recursos del tipo ~d (2 bucle) ?~%" opy i)
                     ;El operador consume el recurso ri y no son el mismo operador. (ID distintos), se calculan los casos
		         (setq c  (aref user::*M-Resources* (user::TimePoint-id-domain opy)  i))
 	               (if (or (= c 0) (<= (user::TimePoint-id opx) (user::TimePoint-id opy)))
				;;(format t "O no consume o son el mismo operador o esta antes y ya se ha considerado")
				(progn
			       ;;(format t "~%Se calculan los casos entre los dos operadores")
			       (setq lt (cases-RES opx opy tm min-tp max-tp t))
			       ;;(format t "~%No hay conflictos de recursos ?? lt = ~d" lt)
			       (if (not (equal lt nil))
				   (progn
				     (push lt list-link)
				   );;fin progn
                         );;fin if hay links (lt nil)
			       (if (equal  user::*last-op-consistence* nil)
				   (return)
				   ;;(format t "~%Es consistente primer bucle")
                         );;fin if				   
			     );;fin progn
		        );;fin del if
			));;fin progn, if
                 );;fin dolist
             );;fin progn
	    );; if se consusme recursos y los ID distintos
	   (if (equal  user::*last-op-consistence* nil)
	      (return)
          );;fin if         
	  ));;fin progn, if
      );;fin dolist ;;fin for Cada operador que consume dicho recurso (j)
	(if (equal  user::*last-op-consistence* nil)
	    (return)
        );;fin if     

     );;fin for Para cada recurso(i)
    );;fin progn
   );;fin if

  ;;(format t "~%FIN de resource-reasoning ------------------------~%")
  list-link

  );;fin let*
);;fin defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; ALGORITMO DE RECURSOS: Aplica el algoritmo de Smith AAAI-93
;; Version en la que cada operador tiene un identificador de recursos, si 
;; coinciden es porque consumen el mismo recurso. La capacidad se considera uno.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun resource-reasoning-SIN (tm min-tp max-tp ) ; &optional (stream t))
  (let* ((aux-list user::*list-TPop*)
	 (list-link nil)
	 (lt nil)
	 (i 0)
	 (id-res  (user::TimePoint-id-domain (car user::*list-TPop*)))	 
	 )				;fin de la declaracion de variables
   
    ;; Daniel. we have to initialize it
    (setf user::*last-op-consistence* t)
    ;;(format t "~%Inicio de resource-reasoning ------------------------~%")

    (setf user::*num-r* (length user::*list-obj*)) ; Numero de recursos, sera el numero de objetos
  
    (if (not (equal user::*Resorce-Consumed* nil))
	(progn
	  ;;;(format t "~%Antes = ~d" user::*Resorce-Consumed*)
	  (incf (aref (user::RESOURCE-times  user::*Resorce-Consumed*)  (- id-res 1)))
					;(setf (user::TimePoint-links-res op) lista-res)
	  ;;;(format t "~%Op = ~d ~%Recursos = ~d" (car user::*list-TPop*) user::*Resorce-Consumed*)
	  )
      ;;(format t "~%No se ha creado todavia la matriz de recursos")
      );;fin if

					;(setf user::*calculado* nil)

    ;;(format t "~%Operadores hasta ahora son ~d" user::*list-TPop*)
    ;; (format t "~%~%The resource links between HOLA  opertors are .....................~%~%~d~%" user::*list-links-res*)
    ;;(format t "~% aux-list = ~d~%" aux-list)

    (if (> (length aux-list) 2) 
	(progn
	  (setf i id-res)
	  ;;(format t "~%Bucle primero, for del recurso = ~d hasta ~d" i user::*num-r*) ;(read t)
	  (do* ((opx-aux-list aux-list (cdr opx-aux-list))
		(opx (car opx-aux-list) (car opx-aux-list)))
	       ((or (null opx-aux-list)
		    (not user::*last-op-consistence*)))
					;(format t "~%opx= ~d" opx)
	       (if (/= (user::TimePoint-id-domain opx) 0)
		;;;;;;;;;;;;(format t "~%Es igual a cero --> F-OP o S-OP")
		   (progn
		     ;;(format t "~% El operador OPX= ~d consume recursos del tipo i = ~d?" opx i)
					;(read t)
		     (if (= (user::TimePoint-id-domain opx)  i) ;El operador no consume el recurso con id = ri
		   ;;;;;;;;;;;(format t "~%El operador = ~d no consume el recurso = ~d " opx  i)
			 (do* ((opy-aux-list aux-list (cdr opy-aux-list))
			       (opy (car opy-aux-list) (car opy-aux-list)))
			      ((or (null opy-aux-list)
				   (not user::*last-op-consistence*))) 
			      ;;(format t "~%opy= ~d~%" opy)
			      (if (/= (user::TimePoint-id-domain opy) 0)
			  ;;;;;;;;;;(format t "~%Es F-OP o S-OP u OPY  u otro que no requiere de recursos ")
				  (progn
					;(format t "~%El operador OPY=~d consume recursos del tipo ~d (2 bucle) ?~%" opy i) ;(read t)
					;El operador consume el recurso ri y no son el mismo operador. (ID distintos), se calculan los casos
					;(setq c  (aref user::*M-Resources* (user::TimePoint-id-domain opy)  i))
				    (if (not (or (not (= (user::TimePoint-id-domain opy)  i))
						 (<= (user::TimePoint-id opx) (user::TimePoint-id opy))))
				;;;;;;;;;(format t "O no consume o son el mismo operador o esta antes y ya se ha considerado")
					(progn
					;(format t "~%Se calculan los casos entre los dos operadores")
					  (setq lt (cases-RES opx opy tm min-tp max-tp ))
					;(format t "~%No hay conflictos de recursos ?? lt = ~d~%" lt)
					  (if lt
					      (progn
						(push lt list-link)
						);;fin progn
					    (if (not user::*last-op-consistence*)
						(setq list-link nil))
					    );;fin if hay links (lt nil)
					  );;fin progn
				      );;fin del if
				    ));;fin progn, if
			      );;fin dolist
		       );; if se consume recursos y los ID distintos
		     ));;fin progn, if
	       );;fin for Para cada recurso(i)
	  );;fin progn
      ;;(format t "~%Solo tiene un operador la RED, no hay conflictos")
      );;fin if
					;(format t "~%FIN de resource-reasoning ------------------------~%")
    list-link

    );;fin let*
  );;fin defun


(in-package "USER")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Inicializa la parte de recursos.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun initialise-resources ()
 (setf *num-r* 0)   ; Numero de recursos
 (setf *num-op* 0)  ; Numero de operadores
 (setf *M-Resources* nil) ; Matriz con la capacidad global de cada recurso (1 linea) y consumo de cada op. 
 (setf *list-links-res*  nil)       ; Lista con todos los links de todos los operadores annadidos debido a los recursos.
 (setf *list-obj* nil) ; Contiene la lista de objetos correspondientes al recurso.
 (setf *Resorce-Consumed* nil) ;contine la matriz con el numero de veces que ese recurso se ha consumido durante la busqueda
 (setf *creado* nil)  ; Si se quiere leer el recurso del fichero o de la pantalla.
 (setf *recurso-temp* nil)

)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: ObtResource-Input 
;; Parametros: none
;; Valor devuelto: none 
;; Descripcion: Create de array with the identifier asociated to each object. 
;;		    the name of the resource is introduce by the user in the run parameters.
;;
;; Considero que solo se le pasa un recurso. Esta funcion se deberia modificar para el caso de recursos multiples.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun ObtResource-Input()
 (let* ((lista nil) 
	  (type *calculate-resources*)
       )


  ;(format t "~%El recurso es : ~d" type) (read t)
  (if (p4::is-type-p  type *current-problem-space*)
    (progn
      (setq lista (user::my-instances type))
     ;(format t "~%Dimi di si = ~d"  lista)

      (setf user::*Resorce-Consumed*  (user::make-RESOURCE :name  (p4::De-Lista-Array (length lista) (user::convert-object-in-name lista))
									    :times (p4::ADynUni (length lista))
									    :total (length lista)
						 )
      )
     ;(format t "~%Se ha creado la matriz = ~d~%" user::*Resorce-Consumed*)

     (dolist (isc lista)
         ;(format t "~%Ob = ~d" (user::convert-object-in-name isc))  ; --> Te los visualiza todos y sin el formato raro: D, C, B, A
         (push  (user::convert-object-in-name isc)  user::*list-obj*)
     );;fin dolist
     (setf user::*list-obj* (reverse user::*list-obj*))
     ;(format t "~%La list-obj = ~d" user::*list-obj*)
    );;fin progn
    (progn
 	   (break  "~%That resource does not exist as an object in the problem. Please verify it!!!")
    );;fin progn 
  );;fin if

 );;fin let*
)

#|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: ObtResource-Pantalla 
;; Parametros: none
;; Valor devuelto: none 
;; Descripcion: Create de array with the identifier asociated to each object. 
;;		    the name of the resource is introduce by the user.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun ObtResource-Pantalla ( ); &optional (stream t))
 (let* ((lista nil) 
	  (type nil)
       )

  ;(format t "~%Please introduce the name of the resource you want to consider  ")
  (setf type (read t))
  (if (p4::is-type-p  type *current-problem-space*)
    (progn
      (setq lista (user::my-instances type))
     ;(format t "~%Dimi di si = ~d"  lista)

      (setf user::*Resorce-Consumed*  (user::make-RESOURCE :name  (p4::De-Lista-Array (length lista) (user::convert-object-in-name lista))
									    :times (p4::ADynUni (length lista))
									    :total (length lista)
						 )
      )
     ;(format t "~%Se ha creado la matriz en ObtPantalla = ~d~%" user::*Resorce-Consumed*)

     (dolist (isc lista)
         ;(format t "~%Ob = ~d" (user::convert-object-in-name isc))  ; --> Te los visualiza todos y sin el formato raro: D, C, B, A
         (push  (user::convert-object-in-name isc)  user::*list-obj*)
     );;fin dolist
     (setf user::*list-obj* (reverse user::*list-obj*))
     ;(format t "~%La list-obj = ~d" user::*list-obj*)
    );;fin progn
    (progn
 	   (break  "~%That resource does not exist as an object in the problem. Please verify it!!!")
    );;fin progn 
  );;fin if

 );;fin let*
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: ObtResource-File 
;; Parametros: none
;; Valor devuelto: none 
;; Descripcion: Create de array with the identifier asociated to each object. 
;;
;;  Se le da un fichero donde se especifica cual de los objetos es el recurso.
;;  A partir de ahi, cada objeto del dominio tendra un numero que servira para identificar los conflictos.
;;
;; Se deberian calcular los tipos que hay, y chequear con el que se ha introducido.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun ObtResource-File () ;&optional (stream t))
  (let* ((type nil)
	   (lista nil)
	  )

;;  (with-open-file (st "C:/Hamlet/integration/res.txt"  
    (with-open-file (st (concatenate 'string  *hamlet-path* "integration/res.txt")
	              :direction :input) 

                 (setf type (read st)) ; La primera linea -->recurso
    );;fin with-open-file

     (if (p4::is-type-p  type *current-problem-space*)
       (progn
         (setq lista (user::my-instances type))
         (setf user::*Resorce-Consumed*  (user::make-RESOURCE :name  (p4::De-Lista-Array (length lista) (user::convert-object-in-name lista))
									        :times (p4::ADynUni (length lista))
									        :total (length lista)
						     )
         )
        ;;(format t "~%Se ha creado la matriz En OBT-File = ~d~%" user::*Resorce-Consumed*)

         (dolist (isc lista)
           ;(format t "~%Ob = ~d" (user::convert-object-in-name isc))  ; --> Te los visualiza todos y sin el formato raro
           (push  (user::convert-object-in-name isc)  user::*list-obj*)
         );;fin dolist
        (setf user::*list-obj* (reverse user::*list-obj*))
        ;(format t "~%La list-obj = ~d" user::*list-obj*)
      );;fin progn
      (progn
 	   (break  "~%That resource does not exist as an object in the problem. Please verify it!!!")
      )
    );;fin if



  );;fin del let*
);;fin defun

|#


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nombre: Associate-Resources 
;; Parametros: nombre del nodo instanciado sobre el que se calcula el recurso que consume
;; Valor devuelto: devuelve el identificador del recurso que consume. 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Associate-Resources (node)
  (let* ((cont 1)
	   ;;(op-domain (reverse (cdr (cdr (user::get-all-operators)))))  ;Obtengo una lista de los operadores que hay en el dominio
         (op-name (user::get-applicable-op  (p4::applied-op-node-instantiated-op node)) )
	  )

 ;; Cada operador instanciado consume un recurso
   (if user::*calculate-resources*
     (progn
       (dolist (obj user::*list-obj*)
        ;(format t "~% Interseccion = ~d" (intersection (list obj)  op-name :test #'equal)) 
	  ;(format t "~% OBJ= ~d" obj) 
	   (if (equal (intersection (list obj)  op-name :test #'equal) nil)
		(incf cont)
	      (progn
		 ;(format t "~%Hubo matching en la posicion = ~d" cont) 
		  (return)
	      )
	   );;fin if
	 );;FIN DOLIST
        (if (> cont (length user::*list-obj*))
    	  (progn
	   ;(format t "~%No se se encuentran parametros en = ~d OBJ= ~d" op-name user::*list-obj*) 
	    (setq cont 0) ; No existen parametros en la lista del operador, por tanto no hay conflictos. Lo pongo a cero
	  );;fin progn
        );;fin if
     );;progn
    (setq cont 0) ;No se calculan recursos, por tanto los pongo a 0
   ) ;;fin if se quieren calcular recursos

  ;(format t "El id del recurso es: ~d. Op-name = ~d" cont op-name) (read t)
 cont
 );;fin del let*
) ;;fin funcion


(in-package "P4")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Crea un array unidimensional y lo inicia con ceros
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun ADynUni(DIM)
  (make-array  (list DIM)  :element-type t
	      :initial-element 0)	
)


;;PRUEBAS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;; Esta parte es para que cada operador (template) tenga asociado un num de recurso que contendra una capacidad
#|
    ;(format  t "~%Nombre en  PARALLEL = ~d~% NOMBRE??? = ~d ~%DOMINIo= ~d" (p4::applied-op-node-instantiated-op node) (list op-name) op-domain)
    ;(format t "~%Interseccion = ~d" (intersection op-domain (list op-name) :test #'equal)) 
     (dolist (ops op-domain)
	;(format t "~%op = ~d ~%El que busco = ~d. Long = ~d" ops op-name (length op-domain))
	(if (equal ops op-name)
	   (progn
	      ;(format t "~%coincidencia. El cont= ~d" cont)
	      (return)
	   )
         (incf cont)
     )
     ;(format t "~%El cont = ~d" cont)
    );; fin dolist
   (if (= cont (length op-domain))
	(progn
  	  ;(format t " ~%No se encontro, por defecto se pone el recurso del operador 1")
	  (setq cont 1)
	)
   )

     ;;He probado esto??? 
     ;(operator (p4::operator-node-operator node))
     ;(args (p4::operator-vars operator)))

|#


;;; ---------------------------------------------------------------------------
;;; ---------------------------------------------------------------------------
;;; *END-OF-FILE*


; (load "C:/Hamlet/integration/stp-new-2/resource.lsp")