(in-package "USER")

(create-problem-space 'SATELLITE :current t)

(ptype-of MODE :top-type)
(ptype-of INSTRUMENT :top-type)
(ptype-of DIRECTION :top-type)
(ptype-of SATELLITE :top-type)

(infinite-type DURATION #'numberp)

(additive TIME #'numberp)

(operator TURN_TO
   (params <s> <d_new> <d_prev>)
   (preconds 
      ((<s> satellite) (<d_new> direction) (<d_prev> direction))
      (and (pointing <s> <d_prev>)))
   (effects 
      nil
      ((del (pointing <s> <d_prev>)) (add (pointing <s> <d_new>))))
)

(operator SWITCH_ON
   (params <i> <s>)
   (preconds 
      ((<i> instrument) (<s> satellite))
      (and (on_board <i> <s>) (power_avail <s>)))
   (effects 
      nil
      ((del (power_avail <s>)) (del (calibrated <i>)) (add (power_on <i>))))
)

(operator SWITCH_OFF
   (params <i> <s>)
   (preconds 
      ((<i> instrument) (<s> satellite))
      (and (on_board <i> <s>) (power_on <i>)))
   (effects 
      nil
      ((add (power_avail <s>)) (del (power_on <i>))))
)

(operator CALIBRATE
   (params <s> <i> <d>)
   (preconds 
      ((<s> satellite) (<i> instrument) (<d> direction))
      
(and (on_board <i> <s>) (calibration_target <i> <d>) (pointing <s> <d>)
 (power_on <i>)))
   (effects 
      nil
      ((add (calibrated <i>))))
)

(operator TAKE_IMAGE
   (params <s> <d> <i> <m>)
   (preconds 
      ((<s> satellite) (<d> direction) (<i> instrument) (<m> mode))
      
(and (calibrated <i>) (on_board <i> <s>) (supports <i> <m>) (power_on <i>)
 (pointing <s> <d>)))
   (effects 
      nil
      ((add (have_image <d> <m>))))
)