(in-package "USER")

(create-problem-space 'LOGISTICS :current t)

(ptype-of OBJECT :top-type)
(ptype-of TRUCK VEHICLE)
(ptype-of AIRPLANE VEHICLE)
(ptype-of PACKAGE PHYSOBJ)
(ptype-of VEHICLE PHYSOBJ)
(ptype-of AIRPORT PLACE)
(ptype-of LOCATION PLACE)
(ptype-of CITY OBJECT)
(ptype-of PLACE OBJECT)
(ptype-of PHYSOBJ OBJECT)

(infinite-type DURATION #'numberp)

(additive TIME #'numberp)

(operator LOAD-TRUCK
   (params <pkg> <truck> <loc>)
   (preconds 
      ((<pkg> package) (<truck> truck) (<loc> place))
      (and (at <truck> <loc>) (at <pkg> <loc>)))
   (effects 
      nil
      ((add (in <pkg> <truck>)) (del (at <pkg> <loc>))))
)

(operator LOAD-AIRPLANE
   (params <pkg> <airplane> <loc>)
   (preconds 
      ((<pkg> package) (<airplane> airplane) (<loc> place))
      (and (at <pkg> <loc>) (at <airplane> <loc>)))
   (effects 
      nil
      ((add (in <pkg> <airplane>)) (del (at <pkg> <loc>))))
)

(operator UNLOAD-TRUCK
   (params <pkg> <truck> <loc>)
   (preconds 
      ((<pkg> package) (<truck> truck) (<loc> place))
      (and (at <truck> <loc>) (in <pkg> <truck>)))
   (effects 
      nil
      ((add (at <pkg> <loc>)) (del (in <pkg> <truck>))))
)

(operator UNLOAD-AIRPLANE
   (params <pkg> <airplane> <loc>)
   (preconds 
      ((<pkg> package) (<airplane> airplane) (<loc> place))
      (and (in <pkg> <airplane>) (at <airplane> <loc>)))
   (effects 
      nil
      ((add (at <pkg> <loc>)) (del (in <pkg> <airplane>))))
)

(operator DRIVE-TRUCK
   (params <truck> <loc-from> <loc-to> <city>)
   (preconds 
      ((<truck> truck) (<loc-from> place) (<loc-to> place) (<city> city))
      
(and (at <truck> <loc-from>) (in-city <loc-from> <city>)
 (in-city <loc-to> <city>)))
   (effects 
      nil
      ((add (at <truck> <loc-to>)) (del (at <truck> <loc-from>))))
)

(operator FLY-AIRPLANE
   (params <airplane> <loc-from> <loc-to>)
   (preconds 
      ((<airplane> airplane) (<loc-from> airport) (<loc-to> airport))
      (at <airplane> <loc-from>))
   (effects 
      nil
      ((add (at <airplane> <loc-to>)) (del (at <airplane> <loc-from>))))
)
