
/*********************************************************************
 *
 * File: control_rules.h
 *
 * Description: headers of routines that evaluate heuristic 
 *              using control rules and CLIPS
 *              Modification: Susana Fernndez 2006. 
 *                            Control rules for selecting operators
 *
 *
 * Author: Raquel Fuentetaja 2005
 *
 *********************************************************************/

#ifndef _CONTROL_RULES_H
#define _CONTROL_RULES_H

/* global variables */
/* asserted facts: */
void *possible_positive_clips_facts[MAX_RELEVANT_FACTS];

/* 0 --> not in state */
/* 1 --> in state */
int positive_facts_in_state[MAX_RELEVANT_FACTS];

/* end of global variables */

/*SFA Nov06. New types*/

#define MAX_NAME 20 /*maximun length for an action or predicate name*/
#define MAX_PARTS 50 /* the instantiated actions can be in different parts*/


typedef struct _IndexAction {
  char action[MAX_NAME];
  int first[MAX_PARTS];
  int last[MAX_PARTS];
  int ind_parts;

} IndexAction;

IndexAction index_action_table[5000];
/*int gnum_index_action=0;*/
extern int gCR[5000];
extern int gnum_CR;

void **possible_clips_fluents[MAX_FUNCTIONS][MAX_ARITY];

/*end SFA*/

int initialize_clips(void);

void initialize_facts_info(void);

int assert_static_facts_to_clips(void);

int assert_goals_to_clips(void);

void assert_state_to_clips(State *S);

void assert_clips_fact(int index);

void retract_clips_fact(int index);

float get_h_from_control_rules(State *state); 

/*SFA Nov06. New Functions*/
Bool sus_get_operators_from_cr(State *S, Bool lH);
int sus_get_index_action(char *action, char **vars);
IndexAction* sus_get_index(char *action);
void sus_decode_domain_in_integers();
void sus_print_index_table();
void sus_print_types();
/*Bool sus_calculate_intersecion_gA(int *rules, int *num, int *gCR, int *gnum_CR);*/
Bool sus_in_gAH(int v, Bool lH);
void retract_clips_fluents();
void assert_clips_fluents();

#endif /*_CONTROL_RULES_H */
