


/*
 * THIS SOURCE CODE IS SUPPLIED  ``AS IS'' WITHOUT WARRANTY OF ANY KIND, 
 * AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH 
 * (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL 
 * WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * ANY WARRANTIES OR NON INFRINGEMENT.  THE USER ASSUMES ALL LIABILITY AND
 * RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR NOR
 * JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR 
 * DAMAGES OF ANY KIND RESULTING FROM ITS USE.  Without limiting the 
 * generality of the foregoing, neither the author, nor JAIR, nor JAIR's
 * publishers and distributors, warrant that the Source Code will be 
 * error-free, will operate without interruption, or will meet the needs 
 * of the user.
 */










/*********************************************************************
 *
 * File: search.h
 *
 * Description: headers of routines that search the state space
 *
 *              ADL version, Enforced Hill-climbing enhanced with
 *                           Goal-adders deletion heuristic
 *
 * Author: Joerg Hoffmann 2000
 *
 *********************************************************************/ 






#ifndef _SEARCH_H
#define _SEARCH_H

/* raquel */
extern float final_total_cost;
extern float time_ehc;
extern int optimal_solution;
/* end raquel */

Bool do_enforced_hill_climbing( void );



Bool search_for_better_state( State *S, int h, float h_cost, State *S_, int *h_, float *h_cost_ );
void add_to_ehc_space( State *S, int op, EhcNode *father );
int expand_first_node( int h, float h_cost, float  *h_cost_ );



void hash_ehc_node( EhcNode *n );
Bool ehc_state_hashed( State *S );
Bool superior_ehc_state_hashed( State *S );
Bool superior_state( State *S1, State *S2 );
void reset_ehc_hash_entrys( void );



void extract_plan_fragment( State *S );
PlanHashEntry *hash_plan_state( State *S, int step );
PlanHashEntry *plan_state_hashed( State *S );
Bool same_state( State *S1, State *S2 );



Bool do_best_first_search( void );
void add_to_bfs_space( State *S, int op, BfsNode *father );
float state_cost( State *S, BfsNode *father );
void extract_plan( BfsNode *last );



void hash_bfs_node( BfsNode *n );
Bool bfs_state_hashed( State *S );
Bool superior_bfs_state_hashed( State *S );
int state_sum( State *S );
void unhash_bfs_node( BfsNode *n );


Bool result_to_dest( State *dest, State *source, int op );
Bool determine_source_val( State *source, int fl, float *val );
void copy_source_to_dest( State *dest, State *source );
void source_to_dest( State *dest, State *source );
void output_h_info(int _depth, float _g, float heuristic_estimation, float _final_cost);


#endif /* _SEARCH_H */
