;; This is the blocksworld according to the proposed 4.0 syntax

(create-problem-space 'blocksworld :current t)

(ptype-of OBJECT :top-type)

(OPERATOR PICK-UP
	  (params <ob1>)
	  (preconds 
	   ((<ob1> OBJECT))
	   (and (clear <ob1>)
		(on-table <ob1>)
		(arm-empty)))
	  (effects 
	   ()				; no vars need generated in effects list
	   ((del (on-table <ob1>))
	    (del (clear <ob1>))
	    (del (arm-empty))
	    (add (holding <ob1>)))))

(OPERATOR PUT-DOWN
	  (params <ob>)
	  (preconds 
	   ((<ob> OBJECT))
	   (holding <ob>))
	  (effects 
	   ()
	   ((del (holding <ob>))
	    (add (clear <ob>))
	    (add (arm-empty))
	    (add (on-table <ob>)))))

(OPERATOR STACK
	  (params <ob> <underob>)
	  (preconds 
	   ((<ob> Object)
	    (<underob> (and OBJECT (diff <ob> <underob>))))
	   (and (clear <underob>)
		(holding <ob>)))
	  (effects 
	   ()
	   ((del (holding <ob>))
	    (del (clear <underob>))
	    (add (arm-empty))
	    (add (clear <ob> ))
	    (add (on <ob> <underob>)))))

(OPERATOR UNSTACK
	  (params <ob> <underob>)
	  (preconds
	   ((<ob> Object)
	    (<underob> Object))
	   (and (on <ob> <underob>)
		(clear <ob>)
		(arm-empty)))
	  (effects 
	   ()
	   ((del (on <ob> <underob>))
	    (del (clear <ob>))
	    (del (arm-empty))
	    (add (holding <ob>))
	    (add (clear <underob>)))))


;; Function that tests whether two objects are different
(defun diff (x y)
  (not (eq x y)))


;; Example of control rule
(CONTROL-RULE SELECT-PICKUP-FOR-HOLDING-IF-ON-TABLE
	      (IF (and (current-goal (holding <ob>))
		       (true-in-state (on-table <ob>))))
	      (THEN select operator PICK-UP))
