#|
--------------------------------------------------------------------------------

LOGISTICS domain.

--------------------------------------------------------------------------------
|#

(create-problem-space 'logistics :current t)

(ptype-of OBJECT :top-type)
(ptype-of CARRIER :top-type)
(ptype-of TRUCK  CARRIER)
(ptype-of AIRPLANE CARRIER)
(ptype-of LOCATION :top-type)
(ptype-of AIRPORT LOCATION)
(ptype-of POST-OFFICE LOCATION)
(ptype-of CITY :top-type)



#|  ------------------------------  OPERATORS ------------------------------ |#



(OPERATOR LOAD-TRUCK
  (params <obj> <truck> <loc>)  ;; params are used for printing purposes only
  (preconds
   ((<obj> OBJECT)
    (<truck> TRUCK)
    (<loc>  (and LOCATION (in-truck-city-p  <truck> <loc>))))
   (and (at-obj <obj> <loc>)
	(at-truck <truck> <loc>)))
  (effects
   ()
   ((add (inside-truck <obj> <truck>))
    (del (at-obj <obj> <loc>)))))


(OPERATOR LOAD-AIRPLANE
  (params <obj> <airplane> <loc>)
  (preconds 
   ((<obj> OBJECT)
    (<airplane> AIRPLANE)
    (<loc> (and AIRPORT (in-obj-city-p <obj> <loc>))))
   (and (at-obj <obj> <loc>)
	(at-airplane <airplane> <loc>)))
  (effects
   ()
   ((del (at-obj <obj> <loc>))
    (add (inside-airplane <obj> <airplane>)))))

	     


(OPERATOR UNLOAD-TRUCK
  (params <obj> <truck> <loc>)
  (preconds 
   ((<obj> OBJECT)
    (<truck> TRUCK)
    (<loc> (and LOCATION
		(in-truck-city-p <truck> <loc>))))
   (and (inside-truck <obj> <truck>)
	(at-truck <truck> <loc>)))
  (effects
   ()
   ((del (inside-truck <obj> <truck>))
    (add (at-obj <obj> <loc>)))))


(OPERATOR UNLOAD-AIRPLANE
  (params <obj> <airplane> <loc>)
  (preconds 
   ((<obj> OBJECT)
    (<airplane> AIRPLANE)
    (<loc> AIRPORT))
   (and (inside-airplane <obj> <airplane>)
	(at-airplane <airplane> <loc>)))
  (effects
   ()
   ((del (inside-airplane <obj> <airplane>))
    (add (at-obj <obj> <loc>)))))


(OPERATOR DRIVE-TRUCK
  (params <truck> <loc-from> <loc-to>)
  (preconds
   ((<truck> TRUCK)
    (<loc-from> LOCATION)
    (<loc-to> (and LOCATION
		   (diff <loc-from> <loc-to>))))
   (and
    (same-city <loc-from> <loc-to>)
    (at-truck <truck> <loc-from>)))
  (effects
   ()
   ((del (at-truck <truck> <loc-from>))
    (add (at-truck <truck> <loc-to>)))))


(OPERATOR FLY-AIRPLANE
  (params <airplane> <loc-from> <loc-to>)
  (preconds
   ((<airplane> AIRPLANE)
    (<loc-from> AIRPORT)
    (<loc-to> (and AIRPORT
		   (diff <loc-from> <loc-to>))))
   (at-airplane <airplane> <loc-from>))
  (effects
   ()
   ((del (at-airplane <airplane> <loc-from>))
    (add (at-airplane <airplane> <loc-to>)))))



(Inference-Rule  IN-SAME-CITY
   (mode eager)

   (params <loc1> <loc2> <city>)
   (preconds
    ((<loc1> LOCATION)
     (<loc2> (and LOCATION (diff <loc1> <loc2>)))
     (<city> CITY))
    (and (loc-at <loc1> <city>)
	 (loc-at <loc2> <city>)))
   (effects
    ()
    ((add (same-city <loc1> <loc2>)))))
