

(create-problem-space 'logistics :current t)

(ptype-of object :top-type)

(ptype-of carrier :top-type)

(ptype-of truck carrier)

(ptype-of airplane carrier)

(ptype-of location :top-type)

(ptype-of airport location)

(ptype-of post-office location)

(ptype-of city :top-type)

(operator macro-op-g19619
 (params <airplane1-airplane> <pgh-airport-airport> <bos-airport-airport>)
 (preconds
  ((<bos-airport-airport> airport) (<pgh-airport-airport> airport)
   (<airplane1-airplane> airplane))
  (and (at-airplane <airplane1-airplane> <pgh-airport-airport>)))
 (effects nil
  ((add (at-airplane <airplane1-airplane> <bos-airport-airport>))
   (del (at-airplane <airplane1-airplane> <pgh-airport-airport>)))))

(operator load-truck (params <obj> <truck> <loc>)
 (preconds
  ((<obj> object) (<truck> truck)
   (<loc> (and location (in-truck-city-p <truck> <loc>))))
  (and (at-obj <obj> <loc>) (at-truck <truck> <loc>)))
 (effects nil ((add (inside-truck <obj> <truck>)) (del (at-obj <obj> <loc>)))))

(operator load-airplane (params <obj> <airplane> <loc>)
 (preconds
  ((<obj> object) (<airplane> airplane)
   (<loc> (and airport (in-obj-city-p <obj> <loc>))))
  (and (at-obj <obj> <loc>) (at-airplane <airplane> <loc>)))
 (effects nil
  ((del (at-obj <obj> <loc>)) (add (inside-airplane <obj> <airplane>)))))

(operator unload-truck (params <obj> <truck> <loc>)
 (preconds
  ((<obj> object) (<truck> truck)
   (<loc> (and location (in-truck-city-p <truck> <loc>))))
  (and (inside-truck <obj> <truck>) (at-truck <truck> <loc>)))
 (effects nil ((del (inside-truck <obj> <truck>)) (add (at-obj <obj> <loc>)))))

(operator unload-airplane (params <obj> <airplane> <loc>)
 (preconds ((<obj> object) (<airplane> airplane) (<loc> airport))
  (and (inside-airplane <obj> <airplane>) (at-airplane <airplane> <loc>)))
 (effects nil
  ((del (inside-airplane <obj> <airplane>)) (add (at-obj <obj> <loc>)))))

(operator drive-truck (params <truck> <loc-from> <loc-to>)
 (preconds
  ((<truck> truck) (<loc-from> location)
   (<loc-to> (and location (diff <loc-from> <loc-to>))))
  (and (same-city <loc-from> <loc-to>) (at-truck <truck> <loc-from>)))
 (effects nil
  ((del (at-truck <truck> <loc-from>)) (add (at-truck <truck> <loc-to>)))))

(operator fly-airplane (params <airplane> <loc-from> <loc-to>)
 (preconds
  ((<airplane> airplane) (<loc-from> airport)
   (<loc-to> (and airport (diff <loc-from> <loc-to>))))
  (at-airplane <airplane> <loc-from>))
 (effects nil
  ((del (at-airplane <airplane> <loc-from>))
   (add (at-airplane <airplane> <loc-to>)))))

(inference-rule in-same-city (mode eager) (params <loc1> <loc2> <city>)
 (preconds
  ((<loc1> location) (<loc2> (and location (diff <loc1> <loc2>)))
   (<city> city))
  (and (loc-at <loc1> <city>) (loc-at <loc2> <city>)))
 (effects nil ((add (same-city <loc1> <loc2>)))))