(in-package "USER")

(create-problem-space 'MICONIC :current t)

(ptype-of OBJECT :top-type)
(ptype-of FLOOR OBJECT)
(ptype-of PASSENGER OBJECT)

(infinite-type DURATION #'numberp)

(additive TIME #'numberp)

(operator BOARD
   (params <f> <p>)
   (preconds 
      ((<f> floor) (<p> passenger))
      (and (lift-at <f>) (origin <p> <f>)))
   (effects 
      nil
      ((add (boarded <p>))))
)

(operator DEPART
   (params <f> <p>)
   (preconds 
      ((<f> floor) (<p> passenger))
      (and (lift-at <f>) (destin <p> <f>) (boarded <p>)))
   (effects 
      nil
      ((add (served <p>)) (del (boarded <p>))))
)

(operator UP
   (params <f1> <f2>)
   (preconds 
    ((<f1> floor) 
     (<f2> (and floor (diff <f1> <f2>))))
      (and (lift-at <f1>) (above <f1> <f2>)))
   (effects 
      nil
      ((del (lift-at <f1>)) (add (lift-at <f2>))))
)

(operator DOWN
   (params <f1> <f2>)
   (preconds 
    ((<f1> floor) 
     (<f2> (and floor (diff <f1> <f2>))))
      (and (lift-at <f1>) (above <f2> <f1>)))
   (effects 
      nil
      ((del (lift-at <f1>)) (add (lift-at <f2>))))
   )

(defun diff (x y )
  (not (eq x y)))