(setf *this-timeout* 300)
(setf *this-date* "sat_optimi0620")
(setf *this-domain* "satellite")
(setf *this-domain-file* "satellite.pddl")

(setf *test-probs-prefix* "pfile")


(setf *experiment-train*
      (list '(delete-casebase)
	    '(cbp-runset *this-domain* *this-domain-file* :store-case t  :timeout 100 :heuristic 'h-relaxedplan
			 :probs-prefix "dep_train")
	    
	    ))


(setf *experiment-tests*
      (list
         '('ehc (runset *this-domain* *this-domain-file*
		:timeout *this-timeout* :probs-prefix *test-probs-prefix*
 		:out-file (conc-outfile "ehc" "txt")))
	'('beam-cbr (cbp-runset *this-domain* *this-domain-file* :heuristic 'h-relaxedplan
		     :runtype 'beam-cbr :timeout *this-timeout* :use-case t :save-result t
		     :probs-prefix *test-probs-prefix* :out-file (conc-outfile "beam-cbr" "txt")))
	'('bfs-cbr (cbp-runset *this-domain* *this-domain-file* :heuristic 'h-relaxedplan
		     :runtype 'bfs-cbr :timeout *this-timeout* :use-case t :save-result t
		     :probs-prefix *test-probs-prefix* :out-file (conc-outfile "bfs-cbr" "txt")))
  	'('a-star (runset *this-domain* *this-domain-file*
  		   :algorithm 'a-star :timeout *this-timeout* 
  		   :probs-prefix *test-probs-prefix* :out-file (conc-outfile "a-star" "txt")))
	))

(setf *experiment-outputs*
      (list '(num-problems-solved (conc-outfile "cbr_search_maxi_probsolved" "txt"))
	    '(data-toplot (conc-outfile "cbr_search_maxi_data" "txt" ))
	    ))
