(setf *this-timeout* 120)
(setf *this-date* "sat_analysis_0308")
(setf *this-domain* "satellite")

(setf *cbp-case-w-greedy* 0.75)
(setf *cbp-step-w-greedy* 0.75)

(setf *experiment-train*
      (list '(delete-casebase *this-domain*)
	    '(cbp-runset *this-domain* :store-case t  :timeout *this-timeout*
			 :save-result nil :probs-prefix "sat_train")
	    '(cbp-runset *this-domain* :runtype 'ehc-cbr-utility :use-case t 
			 :store-utility t :timeout *this-timeout* :probs-prefix "sat_valid")
	    
	    ))

(setf *cbp-case-w-greedy* 0.5)
(setf *cbp-step-w-greedy* 0.5)

(setf *analyze-tree* t)

(setf *test-probs-prefix* "sat_test")
(setf *experiment-tests*
      (list 
        '('ehc (runset *this-domain* :timeout *this-timeout* :probs-prefix *test-probs-prefix*
		:out-file (conc-outfile "ehc" "dat")
		:analyze-tree *analyze-tree*))
	'('ehc-sorted-h (runset *this-domain* :runtype 'ehc-sort-h :timeout *this-timeout* 
			 :probs-prefix *test-probs-prefix* :out-file (conc-outfile "ehc-sort-h" "dat")
			 :analyze-tree *analyze-tree*))

	'('cbr-allob (cbp-runset *this-domain* :runtype 'ehc-cbr-allob :timeout *this-timeout* :probs-prefix *test-probs-prefix*
				 :out-file (conc-outfile "cbp-allob" "dat") :store-case nil 
				 :use-case t :save-result t :analyze-tree *analyze-tree*))
;; 	'('cb-order (cbp-runset *this-domain* :runtype 'ehc-cborder :timeout *this-timeout* :probs-prefix *test-probs-prefix*
;; 				:out-file (conc-outfile "cbp-order" "dat")
;; 				:use-case t :save-result t))
	'('cb-utility (cbp-runset *this-domain* :runtype 'ehc-cbr-utility :timeout *this-timeout* :probs-prefix *test-probs-prefix*
				  :out-file (conc-outfile "cbp-utility" "dat")
				  :use-case t :save-result t :analyze-tree *analyze-tree*))
;; 	'('cb-steputil (cbp-runset *this-domain* :runtype 'ehc-steputility :timeout *this-timeout* :probs-prefix *test-probs-prefix*
;; 				  :out-file (conc-outfile "cbp-step-utility" "dat")
;; 				  :use-case t :save-result t))
;; 	'('cb-caseutil (cbp-runset *this-domain* :runtype 'ehc-caseutility :timeout *this-timeout* :probs-prefix *test-probs-prefix*
;; 				  :out-file (conc-outfile "cbp-case-utility" "dat")
;; 				  :use-case t :save-result t))

))


(setf *experiment-outputs*
      (list '(num-problems-solved (conc-outfile "ehc_strategies_probsolved" "txt"))
	    '(data-toplot (conc-outfile "ehc_strategies_data" "txt" ))
	    '(ehctree-data-toanalyze (conc-outfile "ehctree_data" "txt" ))
;; 	    '(save-usedcases (conc-outfile "ehc_vs_cbr_usedcases" "txt"))
	    ))

;;===================================================================
;; CRX - SIBLINGS EXPERIMENTS
;;===================================================================

;; (setf *this-timeout* 300)
;; (setf *this-date* "test2701")
;; (setf *this-domain* "satellite")
;; 
;; (setf *experiment-train*
;;       (list '(crx-init)  ;; Vaciando la Tabla HASH de los siblings
;; 	    '(crx-runset *this-domain*  :probs-prefix "train"
;; 			 :add-sibling-match t :timeout *this-timeout*)))
;; 	    
;; 
;; (setf *test-probs-prefix* "rndp")
;; 
;; (setf *experiment-tests*
;;       (list '('ehc (runset *this-domain* :timeout *this-timeout* :probs-prefix *test-probs-prefix*
;; 			   :out-file (conc-outfile "ehc" "dat")))
;; 	    '('crx (crx-runset *this-domain* :timeout *this-timeout* :probs-prefix *test-probs-prefix*
;; 			       :use-sibling-match t :save-result t
;; 			       :out-file (conc-outfile "crx" "dat")))))
;; 
;; 
;; (setf *experiment-outputs*
;;       (list '(num-problems-solved (conc-outfile "ehc_vs_crx_probsolved" "txt"))
;; 	    '(data-toplot (conc-outfile "ehc_vs_crx_data" "txt" ))
;; 	    ))
