(defparameter *gen-prob-populate-paramlist*
  '((1 3 3 3 4) 
    (1 3 3 3 5) 
    (2 3 3 3 5) 
    (2 3 3 3 7) 
    (3 3 3 3 7) 
    (3 3 4 4 7) 
    (4 3 4 5 7)
    (4 3 4 5 10) 
    (5 3 5 5 10)
    (5 3 5 5 12)))

(defparameter *gen-prob-test-paramlist*
  '((1 3 3 3 4) 
    (1 3 3 3 5) 
    (2 3 3 3 5) 
    (2 3 3 3 7) 
    (3 3 3 3 7) 
    (3 3 4 4 7) 
    (4 3 4 5 7) 
    (4 3 4 5 10) 
    (5 3 5 5 10)
    (5 3 5 5 12)
    (5 3 5 5 15)
    (5 3 5 5 20)
    (5 3 5 5 25)
    (6 3 5 5 20)
    (8 3 5 5 20)
    (10 3 5 5 20)
    (12 3 5 5 20)
    (5 5 5 5 20)
    (5 8 8 5 20)
    (5 10 10 5 20)))
 

;; Tomas la lista de parametros y las convierte a string para poder ser utilizadas 
;; por el format de run-program. 
(defmacro format-arguments (param-list)
  `(mapcar #'(lambda (x) (format nil "~a" x)) ,param-list))

(defun generar-set(prefix n-problemas paramlist)
  (let ((i-group 1) (n-prob 1))
    (dolist (i-params paramlist)
      (dotimes (i-prob n-problemas)
	(genprob-satellite prefix i-group n-prob i-params)
	(incf n-prob))
      (incf i-group)
      )))

(defun genprob-satellite (prob-prefix group number sat-params)
  (let* ((prob-seed (random 1000))
	(prob-number (format-numprob number))
	(group-number (format-groupprob group))
	(prob-file (format nil "~asatellite/probsets/~a~a-~a.pddl" 
			   *domains-dir* prob-prefix group-number prob-number)))
;;     (format t "~asatellite/satgen" *domains-dir*)
    (run-program (format nil "~asatellite/satgen.exe" *domains-dir*)
		 :arguments (format-arguments (cons prob-seed sat-params))
		 :output prob-file)

      ))

(defun format-numprob (number)
  (cond ((< number 10)
	 (format nil "00~d" number))
	((< number 100)
	 (format nil "0~d" number))
	(t
	 (format nil "~d" number))))

(defun format-groupprob (number)
  (cond ((< number 10)
	 (format nil "0~d" number))
	(t
	 (format nil "~d" number))))




;; (generar-set "train" 2 *gen-prob-populate-paramlist*)
;; (generar-set "rndp" 5 *gen-prob-test-paramlist*)



