;; SAYPHI Case-Based Reasoner
;; File System Interface for Cases
;; Td. 10.02.2006
;; _________________________________________________________________________________________


;; (defun store-type-case (type ob-typeseq)
;;   (let ((new-stored-cases nil)
;; 	(stored-cases (read-cbp-file type)))
;;     (setf new-stored-cases (merge-type-cases (format-typeseq ob-typeseq) stored-cases))
;;     (write-cbp-file type new-stored-cases)))


(defun format-sequence (type-seq)
  (let ((formated-typeseq nil))
    (dolist (i-step type-seq (reverse formated-typeseq))
      (push (list (casestep-properties i-step)
		  (casestep-prop-extras i-step)
		  (casestep-app-action i-step))
	    formated-typeseq))))


;; (defun format-typeseq (type-seq)
;;   (let ((formated-typeseq nil))
;;     (dolist (i-staterelation type-seq (reverse formated-typeseq))
;;       (push (list (staterelation-pred-ints-relation i-staterelation)
;; 		  (staterelation-applied-action i-staterelation))
;; 	    formated-typeseq))))

(defun read-cbp-file (file-name)
  (let ((file-path (format nil "~a/cases/~a.cbp" *domain-dir* file-name)))
    (cond ((probe-file file-path)
	   (with-open-file (istream file-path :direction :input)
			   (let ((cbp-def (read istream)))
			     (when (listp cbp-def) cbp-def))))
	  (t nil))))


(defun write-case-sequence (stream sequence)
  (dolist (step sequence)
    (format stream "~a~%  " step)))



(defun write-cbp-file (name content)
  (let ((cbp-file (format nil "~a/cases/~a.cbp" *domain-dir* name)))
    (with-open-file (out-stream cbp-file :direction :output :if-exists 
				:supersede :if-does-not-exist :create)
      (cond ((listp content)
	     (format out-stream "(")
	     (dolist (el content)
	       (cond ((listp el)
		      (format out-stream "(")
		      (dolist (el-sub el)
			(cond ((eq (car el-sub) 'sequence)
			       (format out-stream " (SEQUENCE ~%  (")
			       (write-case-sequence out-stream (cadr el-sub))
			       (format out-stream "))"))
			      (t
			       (format out-stream "~a~% " el-sub))))
		      (format out-stream ")~%"))
		     (t
		      (format out-stream "~a~%" el))))
	     (format out-stream ")~%"))
	    (t
	     (format out-stream "~a~%" content))))
    (when *cbp-verbose*
      (format t "~%Storing Type Case [~a]" name))))
    

(defun write-cbp-info (name content)
  (let ((cbp-file (format nil "~a/result/info_~a" *domain-dir* name)))
    (with-open-file (out-stream cbp-file :direction :output :if-exists 
				:append :if-does-not-exist :create)
		    (format out-stream "CBR SAYPHI INFO ~A~%" name)
		    (format out-stream "~a" content))))

  
    
    