;; SAYPHI Case-Based Reasoner
;; Building Domain Type Sub-states
;; Td. 30.05.2006
;; _________________________________________________________________________________________

;; Notes:
;; La posicion del objeto en el literal (litposmap) esta relacionado con el Property Space
;; de TIM, utilizado tambien en los Landmarks de L.Sebastia.

(defvar *analysis-info* nil)

(defun init-domain_analysis ()
  (build-type-substate-table))


;; Create a hash-table for storing sub-states list of each domain types
;; A sub-state list is also stored in a hash table
(defun build-type-substate-table(&key (forid nil))
  (let ((typesubstates-table (make-hash-table :test #'eq))
	(dtypes (get-all-types (dom-domtypes *pspace*))))
    (dolist (itype dtypes typesubstates-table)
      (if forid
	  (setf (gethash itype typesubstates-table) (make-hash-table :test #'equal))
	(setf (gethash itype typesubstates-table) (make-hash-table))
	))))
    

;; (defun extract-type-substates()
;;     (let* ((problem *current-problem*)
;; 	 (objects (problem-objects problem))
;; 	 (init-state (problem-init-state problem))
;; 	 (solseq (solution-path *say-solution*))
;; 	 (type-substates-table (build-type-substate-table))
;; 	 (ob-typeseq nil))
;;     (maphash #'(lambda (type objects-of-type)
;; 		 (dolist (iobject objects-of-type)
;; 		   (setf ob-typeseq (get-typeseq iobject solseq init-state))
;; 		   (scan-type-substates iobject ob-typeseq type-substates-table) 
;; 	     objects)



;; It searchs in an object substate-relation sequence for storing different types of 
;; substates in the tsbs-table
;; (defun scan-type-substates (object ob-typeseq tsbs-table)
;;   (dolist (i-sr ob-typeseq)
;;     (let* ((ob-substate (staterelation-ob-substate i-sr))
;; 	   (type-substate (ob2type-substate object ob-substate)))
;;       (dolist i-
      

(defun find-typesubstate-table (t-substate t-table)
  (let ((is-found nil))
    (maphash #'(lambda (key value)
		 (unless is-found
		   (when (equal-typesubstate t-substate key)
		     (setf is-found t))))
	     t-table)
    is-found))


(defun ob2type-substate (object ob-substate)
  (let ((tsubstate nil))
    (dolist (i-literal ob-substate tsubstate)
      (push (cons (ob-relativelitpos object i-literal) (car i-literal)) tsubstate)))) 


(defun equal-typesubstate (tsbst1 tsbst2)
  (let ((is-equal t))
    (dolist (i-pred tsbst1)
      (when is-equal
	(when (null (find i-pred tsbst2 :test #'equal))
	  (setf is-equal nil))))
    (dolist (j-pred tsbst2 is-equal)
      (when is-equal
	(when (null (find j-pred tsbst1 :test #'equal))
	  (setf is-equal nil))))))
	    


(defmacro ob-relativelitpos (ob literal)
  `(aref (gethash (car ,literal) (gethash ,ob (cbp-objs-litposmap *cbp-info*))) (cdr ,literal)))
