;; SAYPHI Case-Based Reasoner
;; Unifying Type Sequences with the current goals to achieve
;; Td. 04.02.2006
;; _________________________________________________________________________________________

(defun instantiate-typedseq (object obreplay achieved-goals)
  (let* ((n-layers (hash-table-count achieved-goals))
	 (typedseq (replay-sequence obreplay))
	 (seq-len (length typedseq))
	 (seq-pointer (1- seq-len))
	 (partially-instantiated nil)
	 )
;;     (pp-achieved-graph achieved-goals)
    (dotimes (i-count (1- n-layers) partially-instantiated)
      (let* ((i-layer (- n-layers (1+ i-count)))
	     (i-agoals (gethash i-layer achieved-goals))
	     (i-obsubstate (car (objstate-properties object i-agoals))))
	(cond ((and (>= seq-pointer 0) 
		    (noop-step-p (nth seq-pointer typedseq)))
	       (decf seq-pointer))
	      ((and (>= seq-pointer 0)
		    (not (null i-obsubstate))
		    (stepcase-memberset (instep-properties (nth seq-pointer typedseq)) i-obsubstate))
	       (setf partially-instantiated t)
	       (setf (instep-inst-substate (nth seq-pointer typedseq)) 
		     (append (instep-inst-substate (nth seq-pointer typedseq))
			     (objstate-literals object i-agoals)))
	       (decf seq-pointer)
	       ))))))



(defun instantiate-replay-table (achieved-goals-table replay-table)
  (maphash #'(lambda (object obreplay)
	       (unless (instantiate-typedseq object obreplay achieved-goals-table)
		 (remhash object replay-table)))
	     replay-table))
