;; Sayphi Planner
;; Dealing with Oversubscription Problem
;; Ag & Td. 2007.10.22
;; _________________________________________________________________________________________


(defparameter *sayover-algorithm* 'over-search)


(defun over-search (init-node heuristic-fn cost-fn search-options)
  (declare (ignore cost-fn search-options))
  ;;Calculando el plan relajado por meta
  (dolist (igoal (problem-lit-goals *current-problem*))
    (let ((igoal-state (onegoal-bitmap igoal)))
      (multiple-value-bind 
          (h-value relaxed-plan focus-goals) (funcall heuristic-fn init-node igoal-state)
	(format t "~% GOAL: ~a" igoal)
	(format t "~% >>> Heuristic value: ~a" h-value)
	(format t "~% >>> Relaxed Plan: ~% ~a" relaxed-plan)
	(format t "~% _______________________")
     ))))



(defun over-plan (&key (algorithm *sayover-algorithm*)
		       (heuristic nil)
		       (timeout *say-timeout*)
                       (depthbound *say-depthbound*)
		       (cost *say-costfn*)
		  )
  (let ((problem *current-problem*)
	(i-node nil)
	(algorithm-fn (if (not (null algorithm)) (symbol-function algorithm) (say-plan-defaults 'algorithm)))
	(heuristic-fn (if (not (null heuristic)) (symbol-function heuristic) (say-plan-defaults 'heuristic)))
	(cost-fn (symbol-function cost))
	(start-time (get-internal-run-time))
	(search-options nil)
	(sol nil))


    (set-sayp :say-timeout timeout)
    (set-sayp :say-depthbound depthbound)

    (sayout-initialize)
    (setf i-node (initialize-current-problem))
    (set-duplicate-hashing)

    (setf (get (problem-plist problem) :initial-pre-time) start-time)
    (setf (get (problem-plist problem) :initial-search-time) (get-internal-run-time))
    
 
    (sayout-search t algorithm heuristic cost)


    ;; De momento no buscamos ninguna solucion
   (setf sol (funcall algorithm-fn i-node heuristic-fn cost-fn search-options))


))
