;; SAYPHI Relational Prototyping 
;; Extracting & Generating Prototypes from Current Problem
;; 10.02.2006 Rocio Garcia Duran
;; _________________________________________________________________________________________

(defun relational-trace ()
  (let ((path (solution-path *say-solution*)))
    (dolist (inode path)
      (format t "~% Action ~a ~% State ~a ~% Goals ~a ~%" 
	      (snode-plan-action inode) (pp-state (snode-state inode) 'list) 
	      (pp-state (target-goals (snode-state inode))  'list)))))

;; rocio
;; FALTA el primer estado y primera acción (porque el path no guarda el estado ini del problema)
(defun write-training ()
  (let ((cbp-file (format nil "~a/train_01.rel" *domain-dir*))
	(path (solution-path *say-solution*))
	(i 0))
    (with-open-file (out-stream cbp-file :direction :output :if-exists :append :if-does-not-exist :create)
;      (print path)
      (let ((state-first-inode nil)
	    (goals-first-inode nil))
	(setf state-first-inode (pp-state (problem-init-state *current-problem*) 'list))
	(setf goals-first-inode (pp-state (target-goals (problem-init-state *current-problem*)) 'list))
	(when goals-first-inode ; si existe alguna meta que cumplir 
	  (format out-stream "~%State ~a~%Goals ~a~%" state-first-inode goals-first-inode)
	  (dolist (inode path)
	    (let ((state-inode nil)
		  (goals-inode nil)
		  (action-inode nil))
	      (setf state-inode  (pp-state (snode-state inode) 'list))
	      (setf goals-inode  (pp-state (target-goals (snode-state inode)) 'list)) 
	      (setf action-inode (snode-plan-action inode))
	      (when (eq i 0) (format out-stream "Action ~a~%"  action-inode))
	      (if (and (eq i 0) (> (length path) 1))
		  (progn 
		    (format out-stream "~%State ~a~%Goals ~a~%" state-inode goals-inode)
		    (incf i))
		  (if goals-inode
		      (format out-stream "Action ~a~%~%State ~a~%Goals ~a~%" action-inode state-inode goals-inode)
		      (when (> i 0) (format out-stream "Action ~a~%" action-inode)))))))))))



;; (defun runset-relational (domain domain-file &key (algorithm nil)
;; 		      (heuristic nil)
;; 	              (runtype 'ehc) 
;; 		      (cost *say-costfn*) 
;; 		      (timeout 5) (output-level 1)
;; 		      (depthbound 3000) (metric nil)
;; 		      (probs-prefix "p") (save-result t)
;; 		      (out-file nil) (try2-search t))
;;   (declare (ignore metric))
;;   (setf *say-output* output-level)
;;   (say-domain domain domain-file)
;;   (let* ((probdir (format nil "~aprobsets/" *domain-dir*))
;; 	 (count-prob 1) (this-sol nil) 
;; 	 (result-file (if (not (stringp out-file))
;; 			  (format nil "~a/result/~aset-~a-~a-~d.csv"
;; 				  *domain-dir* probs-prefix algorithm heuristic timeout)
;; 			(format nil "~a/result/~a"
;; 				  *domain-dir* out-file)))
;; 	 (wild-char #+SBCL "*.*"
;; 		    #-SBCL "*"))
;;  
;; 
;;     (dolist (thisprob (dirfiles-sorted probdir (concatenate 'string probs-prefix wild-char)))
;;       (format t "~% Solving Problem ~a" (pathname-name thisprob))
;;       (read-pddl-problem thisprob)
;;       (setf *problem-file* (pathname-name thisprob))
;;       (setf this-sol (plan :algorithm algorithm :try2-search try2-search
;; 			   :heuristic heuristic :cost cost :runtype runtype
;; 			   :timeout timeout :depthbound depthbound))
;; 
;;       (when save-result
;; 	(with-open-file (out-stream result-file :direction :output :if-exists 
;; 				    :append :if-does-not-exist :create)
;; 	        (format out-stream "~d, ~a," count-prob (pathname-name thisprob))
;; 		(format out-stream "~a~%" (format-solution this-sol))))
;;       
;; ;;       (write-training)
;;       (incf count-prob)
;;       (say-mem-free-pointers)
;;        #+SBCL (sb-ext:gc :full t)
;;     )
;; ))





